/*
 *      Web server handler routines for UPNP stuffs
 *
 */


/*-- System inlcude files --*/
#include <net/if.h>
#include <signal.h>

/*-- Local inlcude files --*/
#include "../webs.h"
#include "webform.h"
#include "mib.h"
#include "utility.h"

//#ifdef CONFIG_USER_UPNPD
#if defined(CONFIG_USER_UPNPD)||defined(CONFIG_USER_MINIUPNPD)

///////////////////////////////////////////////////////////////////
void formUpnp(webs_t wp, char_t *path, char_t *query)
{
	char_t	*str, *submitUrl;
	char tmpBuf[100];
	FILE *fp;
	char * argv[8];
	char ifname[6];
#ifndef NO_ACTION
	int pid;
#endif
	unsigned char daemon, ext_if;
#ifdef EMBED
	unsigned char if_num;
	int igmp_pid;
#endif


	// Set UPNP
	str = websGetVar(wp, T("daemon"), T(""));
	if (str[0]) {
		if (str[0] == '0')
			daemon = 0;
		else
			daemon = 1;
		if ( !mib_set(MIB_UPNP_DAEMON, (void *)&daemon)) {
			strcpy(tmpBuf, T("Set UPNP error!"));
			goto setErr_igmp;
		}
	}

	str = websGetVar(wp, T("ext_if"), T(""));
	//printf("formUpnp: external interface is %s\n", str);
	if (str[0]) {
		ext_if = (unsigned char)atoi(str);
		if ( !mib_set(MIB_UPNP_EXT_ITF, (void *)&ext_if)) {
			printf("Set UPNP Binded WAN interface index error(1)\n");
			strcpy(tmpBuf, T("Set UPNP Binded WAN interface index error!"));
			goto setErr_igmp;
		}
	}
	
	/* upgdate to flash */
//	mib_update(CURRENT_SETTING);

#ifndef NO_ACTION
	pid = fork();
        if (pid)
                waitpid(pid, NULL, 0);
        else if (pid == 0) {
		snprintf(tmpBuf, 100, "%s/%s", _CONFIG_SCRIPT_PATH, _CONFIG_SCRIPT_PROG);
#ifdef HOME_GATEWAY
		execl( tmpBuf, _CONFIG_SCRIPT_PROG, "gw", "bridge", NULL);
#else
		execl( tmpBuf, _CONFIG_SCRIPT_PROG, "ap", "bridge", NULL);
#endif
                exit(1);
        }
#endif

	submitUrl = websGetVar(wp, T("submit-url"), T(""));
	OK_MSG(submitUrl);
  	return;

setErr_igmp:
	ERR_MSG(tmpBuf);
}
#endif
