#include <sys/reboot.h>
#include <semaphore.h>
#include <signal.h>
#include "utility.h"
#ifdef CONFIG_MIDDLEWARE
#include <rtk/midwaredefs.h>
#endif
#ifdef CONFIG_USER_DDNS 
#include "adslif.h"
#endif
#include "../syslog.h"
#include "mib.h"

sem_t semSave;
char *g_post_file_name;
int g_startPos;
int boa_poll = 0;

//xl_yue
#ifdef CONFIG_MIDDLEWARE
static int sendMsg2MidProcess(struct mwMsg * pMsg)
{
	int spid;
	FILE * spidfile;
	int msgid;
	
	msgid = msgget((key_t)1357,  0666);
	if(msgid <= 0){
		fprintf(stdout,"get cwmp msgqueue error!\n");
		return -1;
	}

	/* get midware interface pid*/
	if ((spidfile = fopen(CWMP_MIDPROC_RUNFILE, "r"))) {
		fscanf(spidfile, "%d\n", &spid);
		fclose(spidfile);
	}else{
		fprintf(stdout,"midware midprocess pidfile not exists in %s\n",__FUNCTION__);
		return -1;
	}

	pMsg->msg_type = spid;
	pMsg->msg_datatype = MSG_MIDWARE;
	if(msgsnd(msgid, (void *)pMsg, MW_MSG_SIZE, 0) < 0){
		fprintf(stdout,"send message to midwareintf error!\n");
		return -1;
	}
	
	return 0;
}

int sendInformKeyParaMsg2MidProcess()
{
	struct mwMsg sendMsg;
	char * sendBuf = sendMsg.msg_data;
	
	*(sendBuf) = OP_informKeyPara;
	return(sendMsg2MidProcess(&sendMsg));
}

 int sendSetDefaultFlagMsg2MidProcess()
 {
	struct mwMsg sendMsg;
	char * sendBuf = sendMsg.msg_data;
	
	*(sendBuf) = OP_SetDefaultFlag;
	return(sendMsg2MidProcess(&sendMsg));

 }

 static int sendMsg2MidIntf(struct mwMsg * pMsg)
{
	int spid;
	FILE * spidfile;
	int msgid;
	
	msgid = msgget((key_t)1357,  0666);
	if(msgid <= 0){
		fprintf(stdout,"get cwmp msgqueue error!\n");
		return -1;
	}

	/* get midware interface pid*/
	if ((spidfile = fopen(MW_INTF_RUNFILE, "r"))) {
		fscanf(spidfile, "%d\n", &spid);
		fclose(spidfile);
	}else{
		fprintf(stdout,"midware interface pidfile not exists in %s\n",__FUNCTION__);
		return -1;
	}

	pMsg->msg_type = spid;
	pMsg->msg_datatype = PACKET_OK;
	if(msgsnd(msgid, (void *)pMsg, MW_MSG_SIZE, 0) < 0){
		fprintf(stdout,"send message to midwareintf error!\n");
		return -1;
	}
	
	return 0;
}

int sendSetDefaultRetMsg2MidIntf()
{
	struct mwMsg sendMsg;
	char * sendBuf = sendMsg.msg_data;

	*sendBuf = OP_SetDefaultRet;		/*Opcode*/
	*(sendBuf+1) = 0;				/*N*/
	return(sendMsg2MidIntf(&sendMsg));
}

#if 0
int sendSetDefaultRetMsg2MidIntf()
{
	int spid;
	FILE * spidfile;
	int msgid;
	int ret;
 	struct mwMsg sendMsg;
	char * sendBuf = sendMsg.msg_data;

	*sendBuf = OP_SetDefaultRet;		/*Opcode*/
	*(sendBuf+1) = 0;				/*N*/

	msgid = msgget((key_t)1357,  0666);
	if(msgid <= 0){
		//fprintf(stdout,"get cwmp msgqueue error!\n");
		return -1;
	}

	/* get midware interface pid*/
	if ((spidfile = fopen(MW_INTF_RUNFILE, "r"))) {
		fscanf(spidfile, "%d\n", &spid);
		fclose(spidfile);
	}else{
		//fprintf(stdout,"midware interface pidfile not exists\n");
		return -1;
	}

	sendMsg.msg_type = spid;
	sendMsg.msg_datatype = PACKET_OK;
	if(msgsnd(msgid, (void *)&sendMsg, MW_MSG_SIZE, 0) < 0){
		fprintf(stdout,"send message to midwareintf error!\n");
		return -1;
	}

 	return 0;
}
#endif
#endif

// Save/reboot thread startup function
void saveD (void)
{
    int reboot_flag = 0;

#ifdef CONFIG_USER_DDNS    		
    unsigned int totalEntry;
    MIB_CE_ATM_VC_T Entry;
    char ifname[6];
    int j;
    int startDDNS=0;	
#endif
	int i, i2;

    // Added by Mason Yu for Reset button
    FILE *fp3, *fp4;            
	int dsl_link = 0;
	int dhcpc_pid;

	Modem_LinkSpeed vLs;
	vLs.upstreamRate=0;

again:
	// wait for user save/reboot
	sem_wait(&semSave);
    
    if (boa_poll)
    {
#ifdef EMBED					
        // Added by Mason Yu for check Reset button
        // (1) Check Reset to default		
        if (fp3=fopen("/proc/load_default","r"))
        {
            fscanf(fp3,"%d",&i);
            if(i==1)
            {
                semSave.__sem_value=SEM_DEFAULT;
                reboot_flag = 1;
            }
            fclose(fp3);
        }        	

        // (2) Check Reset to current		
        if (fp4=fopen("/proc/load_reboot","r"))
        {
            fscanf(fp4,"%d",&i2);
            if(i2==1)
            {
                // wake up the Save/reboot thread
                semSave.__sem_value=SEM_REBOOT;
                reboot_flag = 1;
            }
            fclose(fp4);
        }
#endif

        if (!reboot_flag)
        {
            //star: for wlan on/off button
     
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC) ||defined(CONFIG_BOA_WEB_E8B_CH)
#if defined( WLAN_SUPPORT)&&(defined(ZTE_LED_REQUEST) || defined(WLAN_BUTTON_LED))	//cathy
#ifdef WLAN_ONOFF_BUTTON_SUPPORT
        	int button_flag, flags;
        	unsigned char wlan_flag;
        	unsigned char vChar;
        	FILE *fpwlan;
        	fpwlan = fopen("/proc/wlan_reboot","r+");
        	if(fpwlan)
            {
                fscanf(fpwlan,"%d",&button_flag);

                if(button_flag==1)
                {
                     mib_get( MIB_WLAN_DISABLED, (void *)&vChar);
			if(vChar == 0)
                        vChar = 1;
                    else
                        vChar = 0;
                     
			update_wlan_disable(vChar);
			if (getInFlags("wlan0", &flags) == 1) {
				if (vChar)
					flags &= ~IFF_UP;
				else
					flags |= IFF_UP;
				
				setInFlags("wlan0", flags);
			}
                                        
                    mib_set( MIB_WLAN_DISABLED, (void *)&vChar);	
#if 0 //cathy, use update_wlan_disable to replace this block of code		      
                    itfcfg("eth0", 0);
                    itfcfg("sar", 0);
                    itfcfg((char *)WLANIF, 0);

                    if(mib_update(CURRENT_SETTING, CONFIG_MIB_ALL) == 0)
                        printf("CS Flash error! \n");

                    itfcfg("eth0",1);
                    itfcfg("sar",1);
#endif
                    config_WLAN(ACT_RESTART);	

                    wlan_flag = '0';
                    fwrite(&wlan_flag,1,1,fpwlan);
                }		
                fclose(fpwlan);
            }
#endif
#endif
#endif
     	
            // Added by Mason Yu for Start DDNS client with static Link(route1483/MER with Dhcp client) 
            if ( adsl_drv_get(RLCM_GET_LINK_SPEED, (void *)&vLs,
                RLCM_GET_LINK_SPEED_SIZE) && vLs.upstreamRate != 0) 
            {
#ifdef CONFIG_USER_DDNS  			
                if ( startDDNS == 0 )
                {       
                    //sleep(1000);
                    //for (j=0; j<2000; j++)

                    totalEntry = mib_chain_total(MIB_ATM_VC_TBL); /* get chain record size */	
                    for (i=0; i<totalEntry; i++)
                    {
                        mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&Entry); /* get the specified chain record */
                        if ( (Entry.cmode == ADSL_RT1483) || ((Entry.cmode == ADSL_MER1483) && (Entry.ipDhcp == DHCP_DISABLED)) )
                        {
                            sprintf(ifname, "vc%u", VC_INDEX(Entry.ifIndex));
                            va_cmd("/bin/updateddctrl", 1, 1, ifname);
                        }	
                    }
                    startDDNS = 1;
                }
#endif
                if (dsl_link == 0)
                { // down --> up
                    syslog(LOG_INFO, "DSL Link up");
                    // signal dhcp client to renew
                    dhcpc_pid = read_pid((char*)DHCPC_PID);
                    if (dhcpc_pid > 0) { // renew
                        kill(dhcpc_pid, SIGUSR1);
                    }
#ifdef CONFIG_MIDDLEWARE
		    sendInformKeyParaMsg2MidProcess();		
#endif
                }
                dsl_link = 1;
            }
            else
            {
                if (dsl_link == 1) { // up --> down
                    syslog(LOG_INFO, "DSL Link down");
                }
                dsl_link = 0;
            }

            boa_poll = 0;
            goto again;
        }
    }	
    
#if (defined(CONFIG_RTL867X_NETLOG)  && defined (CONFIG_USER_NETLOGGER_SUPPORT))
           va_cmd("/bin/netlogger",1,1,"disable");
	   sleep(1);
#endif

#ifdef EMBED
	// Modified by Mason Yu
	if ( semSave.__sem_value == SEM_REBOOT ) {
        printf("Going to Reboot\n");
		sleep(3);		
		cmd_reboot();		
	}
    
	if ( semSave.__sem_value == SEM_DEFAULT) {
        printf("Going to Reload Default\n");
        cmd_killproc(ALL_PID & ~(1<<PID_WEB));
#ifdef CONFIG_MIDDLEWARE
        if(sendSetDefaultFlagMsg2MidProcess() == 0 && sendSetDefaultRetMsg2MidIntf() == 0)
        {
            sleep(10);	//wait reboot command from middleware
        }
#endif
		va_cmd("/bin/flash", 3, 1, "default", "cs", "cpe");
		sleep(3);		
		cmd_reboot();		
	}
#ifdef WEB_UPGRADE
#ifdef UPGRADE_V1
	else if ( semSave.__sem_value == SEM_UPGRADE ){	
		sleep(3);								
		cmd_upload(g_post_file_name, g_startPos);		
		
		/* reboot the system */
		//reboot(RB_AUTOBOOT);			
		//cmd_reboot();					
	}
#endif
#ifdef UPGRADE_V2
	else if (semSave.__sem_value == SEM_UPGRADE_2) {
		cmd_upgrade_mode(0);
	}
#endif
#endif
	else {
		va_cmd("/bin/adslctrl",1,1,"disablemodemline");
		sleep(1);	
		sync();
		va_cmd("/bin/sarctl",1,1,"disable");
		va_cmd(IFCONFIG, 2, 1, (char *)ELANIF, "down");
		va_cmd(IFCONFIG, 2, 1, (char *)WLANIF, "down");
		
		/* upgdate to flash */
		mib_update(CURRENT_SETTING, CONFIG_MIB_ALL);
		/* reboot the system */
		reboot(RB_AUTOBOOT);
		//va_cmd("/bin/reboot", 0, 1);
	}
#endif
}

void startSaved()
{
	pthread_t ptSaveId;
	if (pthread_create( &ptSaveId, 0, &saveD, 0 )!=0)
		return;
}
