#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <dirent.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <signal.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <sys/wait.h>
#include <time.h>
#include <net/route.h>
#include <sys/ioctl.h>
#include <signal.h>
#include <sys/ioctl.h>
#include <net/if.h>

/*-- Local inlcude files --*/
#include "../webs.h"
#include "webform.h"
#include "mib.h"



int fm3g_checkWrite(int eid, webs_t wp, int argc, char_t **argv)
{
	char_t *name;
	MIB_WAN_3G_T entry,*p;
	
	//printf( "%s: enter\n", __FUNCTION__ );
   	if (ejArgs(argc, argv, T("%s"), &name) < 1) {
   		websError(wp, 400, T("Insufficient args\n"));
		//printf( "%s: error, line=%d\n", __FUNCTION__, __LINE__ );
   		return -1;
   	}
	//printf( "%s: name=%s\n", __FUNCTION__, name );

	p=&entry;
	if(!mib_chain_get( MIB_WAN_3G_TBL, 0, (void*)p))
	{
		//printf( "%s: error mib_chain_get(), line=%d\n", __FUNCTION__, __LINE__ );
		return -1;
	}

	if(!strcmp(name, T("fm3g-enable-dis"))) {
		if(p->enable==0) websWrite(wp, "checked");
		return 0;
	}else if(!strcmp(name, T("fm3g-enable-en"))) {
		if(p->enable) websWrite(wp, "checked");
		return 0;
	}else if(!strcmp(name, T("fm3g-pin"))) {
		if( p->pin!=NO_PINCODE ) websWrite(wp, "%04u", p->pin);
		return 0;
	}else if(!strcmp(name, T("fm3g-apn"))) {
		websWrite(wp, "%s", p->apn);
		return 0;
	}else if(!strcmp(name, T("fm3g-dial"))) {
		websWrite(wp, "%s", p->dial);
		return 0;
	}else if(!strcmp(name, T("fm3g-auth-none"))) {
		if(p->auth==PPP_AUTH_NONE) websWrite(wp, "selected");
		return 0;
	}else if(!strcmp(name, T("fm3g-auth-auto"))) {
		if(p->auth==PPP_AUTH_AUTO) websWrite(wp, "selected");
		return 0;
	}else if(!strcmp(name, T("fm3g-auth-pap"))) {
		if(p->auth==PPP_AUTH_PAP) websWrite(wp, "selected");
		return 0;
	}else if(!strcmp(name, T("fm3g-auth-chap"))) {
		if(p->auth==PPP_AUTH_CHAP) websWrite(wp, "selected");
		return 0;
	}else if(!strcmp(name, T("fm3g-username"))) {
		websWrite(wp, "%s", p->username);
		return 0;
	}else if(!strcmp(name, T("fm3g-username-dis"))) {
		if(p->auth==PPP_AUTH_NONE) websWrite(wp, "disabled");
		return 0;
	}else if(!strcmp(name, T("fm3g-password"))) {
		websWrite(wp, "%s", p->password);
		return 0;
	}else if(!strcmp(name, T("fm3g-password-dis"))) {
		if(p->auth==PPP_AUTH_NONE) websWrite(wp, "disabled");
		return 0;
	}else if(!strcmp(name, T("fm3g-ctype-cont"))) {
		if(p->ctype==CONTINUOUS) websWrite(wp, "selected");
		return 0;
	}else if(!strcmp(name, T("fm3g-ctype-demand"))) {
		if(p->ctype==CONNECT_ON_DEMAND) websWrite(wp, "selected");
		return 0;
	}else if(!strcmp(name, T("fm3g-ctype-manual"))) {
		if(p->ctype==MANUAL) websWrite(wp, "selected");
		return 0;
	}else if(!strcmp(name, T("fm3g-idletime"))) {
		websWrite(wp, "%u", p->idletime);
		return 0;
	}else if(!strcmp(name, T("fm3g-idletime-dis"))) {
		if(p->ctype!=CONNECT_ON_DEMAND) websWrite(wp, "disabled");
		return 0;
	}else if(!strcmp(name, T("fm3g-napt-dis"))) {
		if(!p->napt) websWrite(wp, "checked");
		return 0;
	}else if(!strcmp(name, T("fm3g-napt-en"))) {
		if(p->napt) websWrite(wp, "checked");
		return 0;
	}else if(!strcmp(name, T("fm3g-droute-dis"))) {
		if(!p->dgw) websWrite(wp, "checked");
		return 0;
	}else if(!strcmp(name, T("fm3g-droute-en"))) {
		if(p->dgw) websWrite(wp, "checked");
		return 0;
	}else if(!strcmp(name, T("fm3g-mtu"))) {
		websWrite(wp, "%u", p->mtu);
		return 0;
	}else{
		//printf( "%s: error, line=%d\n", __FUNCTION__, __LINE__ );
		return -1;
	}
	
	return 0;
}


#define RECONNECT_MSG(url) do { \
	websHeader(wp); \
	websWrite(wp, T("<body><blockquote><h4>Change setting successfully!" \
                "<form><input type=button value=\"  OK  \" OnClick=window.location.replace(\"%s\")></form></blockquote></body>"), url);\
	websFooter(wp); \
	websDone(wp, 200); \
} while(0)
///////////////////////////////////////////////////////////////////
void form3GConf(webs_t wp, char_t *path, char_t *query)
{
	char_t	*strData;
	char tmpBuf[100];
	MIB_WAN_3G_T entry,*p;

#ifdef APPLY_CHANGE
	//wan3g_stop();
	deleteAllConnection();
#endif //APPLY_CHANGE

	p=&entry;
	if(!mib_chain_get( MIB_WAN_3G_TBL, 0, (void*)p))
	{
		//printf( "%s: error mib_chain_get(), line=%d\n", __FUNCTION__, __LINE__ );
		strcpy(tmpBuf, T("internal error: mib_chain_get() failed!"));
		goto setErr_3g;
	}

	strData = websGetVar(wp, T("enable3g"), T(""));
	if ( strData[0] ) 
	{
		p->enable= (strData[0]=='0')? 0:1;
	}

	strData = websGetVar(wp, T("pin"), T(""));
	if ( strData[0] ) 
	{
		if( (strlen(strData)!=4) || 
		    isdigit(strData[0])==0 || 
		    isdigit(strData[1])==0 || 
		    isdigit(strData[2])==0 || 
		    isdigit(strData[3])==0 )
		{
			strcpy(tmpBuf, T("Invalid PIN Code value!"));
			goto setErr_3g;			
		}
		p->pin= (unsigned short) atoi( strData );
	}else //no pin code
		p->pin= NO_PINCODE;

	strData = websGetVar(wp, T("apn"), T(""));
	//if ( strData[0] )
	{
		strncpy( p->apn, strData, sizeof(p->apn)-1 );
		p->apn[sizeof(p->apn)-1]=0;
	}

	strData = websGetVar(wp, T("dial"), T(""));
	if ( strData[0] )
	{
		strncpy( p->dial, strData, sizeof(p->dial)-1 );
		p->dial[sizeof(p->dial)-1]=0;
	}

	strData = websGetVar(wp, T("auth"), T(""));
	if ( strData[0] )
	{
		p->auth= (unsigned char) atoi( strData );
	}

	strData = websGetVar(wp, T("username"), T(""));
	//if ( strData[0] )
	{
		strncpy( p->username, strData, sizeof(p->username)-1 );
		p->username[sizeof(p->username)-1]=0;
	}

	strData = websGetVar(wp, T("password"), T(""));
	//if ( strData[0] )
	{
		strncpy( p->password, strData, sizeof(p->password)-1 );
		p->password[sizeof(p->password)-1]=0;
	}

	strData = websGetVar(wp, T("ctype"), T(""));
	if ( strData[0] )
	{
		p->ctype= (unsigned char) atoi( strData );
	}

	strData = websGetVar(wp, T("idletime"), T(""));
	if ( strData[0] )
	{
		p->idletime= (unsigned short) atoi( strData );
	}

	strData = websGetVar(wp, T("napt"), T(""));
	if ( strData[0] )
	{
		p->napt= (strData[0]=='0')? 0:1;
	}

	strData = websGetVar(wp, T("droute"), T(""));
	if ( strData[0] )
	{
		p->dgw= (strData[0]=='0')? 0:1;
	}

	strData = websGetVar(wp, T("mtu"), T(""));
	if ( strData[0] )
	{
		p->mtu= (unsigned short) atoi( strData );
		if( p->mtu<65 || p->mtu>1500 )
		{
			strcpy(tmpBuf, T("Invalid MTU value!"));
			goto setErr_3g;
		}
	}



	if(!mib_chain_update( MIB_WAN_3G_TBL, (void*)p, 0))
	{
		//printf( "%s: error mib_chain_get(), line=%d\n", __FUNCTION__, __LINE__ );
		strcpy(tmpBuf, T("internal error: mib_chain_update() failed!"));
		goto setErr_3g;
	}

#ifdef APPLY_CHANGE
	//wan3g_start();
	restartWAN();
#endif //APPLY_CHANGE
	
// Magician: Commit immediately
#ifdef COMMIT_IMMEDIATELY
	Commit();
#endif

	strData = websGetVar(wp, T("submit-url"), T(""));
	RECONNECT_MSG(strData);
	return;



setErr_3g:

#ifdef APPLY_CHANGE
	//wan3g_start();
	restartWAN();
#endif //APPLY_CHANGE

	ERR_MSG(tmpBuf);
	return;
}

