/*
 *      Web server handler routines for Commit/reboot stuffs
 *
 */


/*-- System inlcude files --*/
/*-- Local inlcude files --*/
#include "../webs.h"
#include "webform.h"
#include "mib.h"
#include "utility.h"
#include <semaphore.h>
//alex_huang 
#ifdef EMBED
#include <linux/config.h>
#include <config/autoconf.h>
#else
#include "../../../../uClibc/include/linux/autoconf.h"
#include "../../../../config/autoconf.h"
#endif


#define DEBUG printf

unsigned char getSelectPVCIndex()
{
    unsigned char entryNum;
    unsigned char vchar;
    // get selected pvc number
    if (!mib_get(MIB_WIZ_MULTIPVC, (void *)&vchar)){
        return 0;
    }
    DEBUG("MIB_WIZ_MULTIPVC is %d\n", vchar);

    entryNum =(unsigned char) mib_chain_total(MIB_ATM_VC_TBL);
    DEBUG("MIB_WIZ_MULTIPVC is %d, entryNum is %d\n", vchar, entryNum);

    // modify last entry when the selected pvc number is greater then total entry number
    if (entryNum > 0)
        entryNum--;
    return vchar<entryNum?vchar:entryNum;
}

int atmWizMultipvc(int eid, webs_t wp, int argc, char_t **argv)
{
    int nBytesSent=0;
    unsigned int entryNum, i;
    MIB_CE_ATM_VC_T Entry;
    char if_display_name[16];
    char selectstate[10];
    MIB_AUTO_PVC_SEARCH_T PVCEntry[8];
    unsigned char vchar;
    if (!mib_get(MIB_WIZ_MULTIPVC, (void *)&vchar)){
        websError(wp, 400, T("Get MIB_WIZ_MULTIPVC record error!\n"));
        return -1;
    }

    entryNum = mib_chain_total(MIB_ATM_VC_TBL);
    // show 8 pvc in wizard Web GUI
    for (i=0; i<8; i++){
        if (i < entryNum){
            if (!mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&Entry)){
                websError(wp, 400, T("Get chain record error!\n"));
                return -1;
            }
            PVCEntry[i].vpi = Entry.vpi;
            PVCEntry[i].vci = Entry.vci;
        }
        else{
            // init vpi/vci
            PVCEntry[i].vpi = 5;
            PVCEntry[i].vci = 35;
        }
    }

    // last entry show default vpi/vci, when the selected pvc number is greater then total entry number
    if (vchar >= entryNum && entryNum <= 8 && entryNum > 0){
        PVCEntry[entryNum-1].vpi = 5;
        PVCEntry[entryNum-1].vci = 35;
        PVCEntry[vchar].vpi = Entry.vpi;
        PVCEntry[vchar].vci = Entry.vci;
    }
    
    nBytesSent += websWrite(wp, T("<tr>\n" 
                            	"<td align=center width=\"5%%\" bgcolor=\"#CCCCCC\"><b>Select</b></td>\n"
                            	"<td align=center width=\"4%%\" bgcolor=\"#CCCCCC\"><b>Interface</b></td>\n"
                            	"<td align=center width=\"4%%\" bgcolor=\"#CCCCCC\"><b>VPI</b></td>\n"
                            	"<td align=center width=\"5%%\" bgcolor=\"#CCCCCC\"><b>VCI</b></td></tr>\n"));

    for (i=0; i<8; i++){
        nBytesSent += websWrite(wp, T("<tr>\n"
                                    "<td align=center width=\"5%%\" bgcolor=\"#EEEEEE\">\n"
                                    "<input type=\"radio\" name=\"select\" value=\"%d\" %s> </td>\n"
                        		    "<td align=center width=\"4%%\" bgcolor=\"#EEEEEE\">PVC%d</td>\n"
                        		    "<td align=center width=\"4%%\" bgcolor=\"#EEEEEE\">%u</td>\n"
                        		    "<td align=center width=\"5%%\" bgcolor=\"#EEEEEE\">%u</td></tr>\n"),
                        		    i,i==vchar?"checked":"",i, PVCEntry[i].vpi, PVCEntry[i].vci);
    }
    
    return nBytesSent;
}

void formWizMultipvc(webs_t wp, char_t *path, char_t *query)
{
    char_t *str;
    unsigned char wiz_multipvc_select;
    unsigned char entryNum;
    MIB_CE_ATM_VC_T Entry;
    
    entryNum = (unsigned char) mib_chain_total(MIB_ATM_VC_TBL);
    str = websGetVar( wp, T( "autopvcenable" ), T( "" ) );
    DEBUG("autopvenable is %s\n", str);
    if (str[0]){
        if (strncmp(str, "on", 2) != 0){
            // autopvenable checkbox is not checked
            wiz_multipvc_select = 0;
        }
        else{
            str = websGetVar( wp, T( "select" ), T( "" ) );
            DEBUG("select is %s\n", str);
            if (!str[0])
                goto setErr_filter;
            wiz_multipvc_select = str[0] - '0';
        }
    }
    else{
        //autopvcenable checkbox is not checked
        wiz_multipvc_select = 0;
    }
    DEBUG("MIB_WIZ_MULTIPVC is %d, total Entry is %d\n", wiz_multipvc_select, entryNum);
    
    mib_set( MIB_WIZ_MULTIPVC, ( void * ) &wiz_multipvc_select);

    // add an entry when the selected pvc number is greater then total entry number
    if (wiz_multipvc_select >= entryNum){
        memset( &Entry, 0x00, sizeof( Entry ) );
        Entry.vpi = 5;
        Entry.vci = 35;
        Entry.encap = 1;
        Entry.qos = 0;
        Entry.pcr = ATM_MAX_US_PCR;
        mib_chain_add(MIB_ATM_VC_TBL, (unsigned char*)&Entry);
    }
    websRedirect( wp, "/wiz_home.asp" );
    
setErr_filter:
    ERR_MSG( "Get Value from web Error!" );
    return;
}

// add by lhj Auto search VPI/VCI without connection
static int
 AutoSearchPVC(MIB_CE_ATM_VC_Tp pEntry)
{
    // start searching ...
    DEBUG("Wizard start search PVC :Default pvc failed, start searching ...\n");

    //Retrieve PVC list from MIB
    int i, entryNum, entryATMNum, iNum;
    MIB_CE_ATM_VC_T ATMEntry;
    MIB_AUTO_PVC_SEARCH_T PVCEntry;
    bool bPVCIsUsed;
    unsigned char vchar;
    vchar = getSelectPVCIndex();

    entryNum = mib_chain_total(MIB_AUTO_PVC_SEARCH_TBL);
    DEBUG("MIB_AUTO_PVC_SEARCH_TBL entryNum is %d\n", entryNum);
    
    for(i = 0; i < entryNum; i++){
        // get vpi/vci from mib
        if (!mib_chain_get(MIB_AUTO_PVC_SEARCH_TBL, i, (void *)&PVCEntry)){
            DEBUG("Get chain record error!\n");
            return 0;
        }
        pEntry->vpi = PVCEntry.vpi;
        pEntry->vci = PVCEntry.vci;
        DEBUG("doOAMLookback start\n");

        if (doOAMLookback(pEntry)) {
            DEBUG("Wizard search PVC success:That's it! vpi=%d, vci=%d\n", pEntry->vpi, pEntry->vci);

            // check vpi/vci whether have been used
            bPVCIsUsed = false;
            entryATMNum = mib_chain_total(MIB_ATM_VC_TBL);
            for (iNum=0; iNum<entryATMNum; iNum++) {
                if (iNum == vchar)
                    continue; // ignore current entry's pvc setting
                if (!mib_chain_get(MIB_ATM_VC_TBL, iNum, (void *)&ATMEntry)){
                    DEBUG("Get chain record error!\n");
                    return 0;
                }
                if (ATMEntry.vpi == PVCEntry.vpi && ATMEntry.vci == PVCEntry.vci){
                    bPVCIsUsed = true;  // vpi/vci have been used
                    break;
                }
            }
            if (!bPVCIsUsed)
                return 1; // vpi/vci have not been used
            
            DEBUG("Wizard PVC has been used: vpi=%d, vci=%d\n", pEntry->vpi, pEntry->vci);
        }
        else
            DEBUG("Wizard PVC fail: vpi=%d, vci=%d\n", pEntry->vpi, pEntry->vci);
    }

    return 0;
}

void
formWizConnType( webs_t wp, char_t* path, char_t* query )
{
    unsigned char detect_type_old;
    char detect_type[2] = "1";
    MIB_CE_ATM_VC_T Entry;
    
    unsigned char vchar;
    vchar = getSelectPVCIndex();

    strcpy( detect_type, websGetVar( wp, T( "detect_type" ), T( "" ) ) );

    mib_get( MIB_WIZ_CONN_TYPE, ( void * ) &detect_type_old );

    if ( strcmp( detect_type, &detect_type_old ) != 0 )
    {
        mib_set( MIB_WIZ_CONN_TYPE, ( void * ) &detect_type );
    }

     mib_chain_get( MIB_ATM_VC_TBL, (unsigned int) vchar, ( void * ) &Entry );
    
    if ( atoi( detect_type ) == 1 )
    {
        websRedirect( wp, "/wiz_adsl.asp" );
    }
    else
    {
        MIB_CE_ATM_VC_T EntryTest;
        memset( &EntryTest, 0x00, sizeof( EntryTest ) );
        if ( AutoSearchPVC(&EntryTest) == 1 )    // if auto search pvc fail goto manual selection
       {
            Entry.vpi = EntryTest.vpi;
            Entry.vci = EntryTest.vci;
            Entry.encap = 1;
            mib_chain_update( MIB_ATM_VC_TBL, ( void * ) &Entry, (unsigned int) vchar );

            // set adsl mode
            short mode;
            mib_get( MIB_ADSL_MODE, ( void * ) &mode );
            mode &= ADSL_MODE_ANXB;
            mode |= ADSL_MODE_T1413;
            mode |= ADSL_MODE_GDMT;
            mode |= ADSL_MODE_ADSL2;
            mode |= ADSL_MODE_ANXL;
            mode |= ADSL_MODE_ANXM;
            mode |= ADSL_MODE_ADSL2P;
            mib_set( MIB_ADSL_MODE, ( void * ) &mode );

            websRedirect( wp, "/wiz_chamode.asp" );
        }
        else
        {
            //ERR_MSG("Auto search PVC Fail, manual select the correct please!");
            OK_MSG1("Auto-PVC Search fails, please manual input the correct VPI/VCI!", "/wiz_adsl.asp");
            //websRedirect( wp, "/wiz_adsl.asp" );
        }
    }

    return;
}


static int
retrieveVcRecordAdsl( webs_t wp, MIB_CE_ATM_VC_Tp pEntry )
{
    char tmpBuf[100];
    char_t* strValue;
    unsigned int vUInt;
    MIB_CE_ATM_VC_T entry;
    unsigned char vchar;
    vchar = getSelectPVCIndex();

    mib_chain_get( MIB_ATM_VC_TBL, (unsigned int) vchar, ( void * ) &entry );
    
    // VPI (0~255)
    strValue = websGetVar( wp, T( "vpi" ), T( "" ) );
    if ( !strValue[0] )
    {
        strcpy( tmpBuf, T( "Enter VPI (0~255)!" ) );
        goto setErr_filter;
    }

    sscanf( strValue, "%u", &vUInt );
    if ( vUInt > 255 )
    {
        strcpy( tmpBuf, T( "Invalid VPI!" ) );
        goto setErr_filter;
    }
    entry.vpi = ( unsigned char ) vUInt;

    // VCI (0~65535)
    strValue = websGetVar( wp, T( "vci" ), T( "" ) );

    if ( !strValue[0] )
    {
        strcpy( tmpBuf, T( "Enter VCI (0~65535)!" ) );
        goto setErr_filter;
    }

    sscanf( strValue, "%u", &vUInt );
    if ( vUInt > 65535 )
    {
        strcpy( tmpBuf, T( "Invalid VCI!" ) );
        goto setErr_filter;
    }
    entry.vci = ( unsigned short ) vUInt;

    // Encaptulation
    strValue = websGetVar( wp, T( "adslEncap" ), T( "" ) );

    if ( strValue[0] )
    {
        entry.encap = strValue[0] - '0';
    }

    memcpy( pEntry, &entry, sizeof( entry ) );
    return 0;

    setErr_filter:
    ERR_MSG( tmpBuf );
    return -1;
}


void
formWizAdsl( webs_t wp, char_t* path, char_t* query )
{
    char tmpBuf[100];
    char_t* strValue;
    unsigned int vUInt;
    MIB_CE_ATM_VC_T Entry;
    int intVal;
    short mode;
    unsigned char vchar;
    vchar = getSelectPVCIndex();

    if ( retrieveVcRecordAdsl( wp, &Entry ) != 0 )
    {
        /*RegisterPVCnumber();    
          cleanAllFirewallRule();
          restart_dnsrelay();
          startWan(BOOT_LAST);*/
        //carpenter:restartWAN();
        websError( wp, 400, T( "Get chain record error!\n" ) );
        return -1;
        //return;
    }

    mib_chain_update( MIB_ATM_VC_TBL, ( void * ) &Entry, (unsigned int) vchar );
    
    int i, entryNum;
    MIB_AUTO_PVC_SEARCH_T PVCentry;	
    entryNum = mib_chain_total(MIB_AUTO_PVC_SEARCH_TBL);
    for(i = 0; i < entryNum; i++){
        if (!mib_chain_get(MIB_AUTO_PVC_SEARCH_TBL, i, (void *)&PVCentry)){
            DEBUG("Get chain record error!\n");
            goto  setADSL_Mode;
        }
        else{
            if (PVCentry.vpi == Entry.vpi && PVCentry.vci == Entry.vci)
                goto  setADSL_Mode;
        }
    }
    PVCentry.vpi = Entry.vpi;
    PVCentry.vci = Entry.vci;
    intVal = mib_chain_add(MIB_AUTO_PVC_SEARCH_TBL, (unsigned char*)&PVCentry);
    if (intVal == 0) {
        DEBUG(strAddChainerror);
    }
    else if (intVal == -1) {
        DEBUG(strTableFull);
    }

setADSL_Mode:
    mib_get( MIB_ADSL_MODE, ( void * ) &mode );
    mode &= ADSL_MODE_ANXB;


    strValue = websGetVar( wp, T( "glite" ), T( "" ) );
    if ( strValue[0] == '1' )
    {
        mode |= ADSL_MODE_GLITE;
    }
    strValue = websGetVar( wp, T( "t1413" ), T( "" ) );
    if ( strValue[0] == '1' )
    {
        mode |= ADSL_MODE_T1413;
    }
    strValue = websGetVar( wp, T( "gdmt" ), T( "" ) );
    if ( strValue[0] == '1' )
    {
        mode |= ADSL_MODE_GDMT;
    }
//    strValue = websGetVar( wp, T( "adsl2" ), T( "" ) );
//    if ( strValue[0] == '1' )
//    {
        mode |= ADSL_MODE_ADSL2;
//    }
    strValue = websGetVar( wp, T( "anxl" ), T( "" ) );
    if ( strValue[0] == '1' )
    {
        mode |= ADSL_MODE_ANXL;
    }
    strValue = websGetVar( wp, T( "anxm" ), T( "" ) );
    if ( strValue[0] == '1' )
    {
        mode |= ADSL_MODE_ANXM;
    }
//    strValue = websGetVar( wp, T( "adsl2p" ), T( "" ) );
//    if ( strValue[0] == '1' )
//    {
        mode |= ADSL_MODE_ADSL2P;
//    }

    mib_set( MIB_ADSL_MODE, ( void * ) &mode );

    websRedirect( wp, "/wiz_chamode.asp" );
    return;
}



static int
retrieveVcRecordCMode( webs_t wp, MIB_CE_ATM_VC_Tp pEntry )
{
    char tmpBuf[100];
    char_t* strValue, * strIp, * strMask, * strGW;
    unsigned int vUInt;
    MIB_CE_ATM_VC_T entry;

    // Connection mode
    strValue = websGetVar( wp, T( "adslConnectionMode" ), T( "" ) );
    DEBUG( "\n\n-----------webcmode=%d-------\n", strValue );
    if ( strValue[0] )
    {
        entry.cmode = strValue[0] - '0';
    }

    memcpy( pEntry, &entry, sizeof( entry ) );
    return 0;

    setErr_filter:
    ERR_MSG( tmpBuf );
    return -1;
}

void
formWizChanMode( webs_t wp, char_t* path, char_t* query )
{
    MIB_CE_ATM_VC_T Entry, myEntry;
    unsigned char vchar;
    vchar = getSelectPVCIndex();
    if ( retrieveVcRecordCMode( wp, &Entry ) != 0 )
    {
        /*RegisterPVCnumber();    
          cleanAllFirewallRule();
          restart_dnsrelay();
          startWan(BOOT_LAST);*/
        //carpenter:restartWAN();
        websError( wp, 400, T( "Get chain record error!\n" ) );
        return -1;
        //return;
    }
    mib_chain_get( MIB_ATM_VC_TBL, (unsigned int) vchar, ( void * ) &myEntry );
    myEntry.cmode = Entry.cmode;
    myEntry.enable = 1;
    myEntry.napt = 1;
    
// check if connection exists for creat ifIndex
	unsigned int ifMap = 0;
	int cnt=0;
    unsigned int totalEntry;
    int i, pIdx;
    char tmpBuf[100];
    
	totalEntry = mib_chain_total(MIB_ATM_VC_TBL); /* get chain record size */
	if (totalEntry >= MAX_VC_NUM)
	{
		strcpy(tmpBuf, T(strMaxVc));
		goto setErr_filter;
	}
    
	for (i=0; i<totalEntry; i++) {
        if (i == vchar)
            continue;
		if (!mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&Entry))
		{
			strcpy(tmpBuf, T(strGetChainerror));
			goto setErr_filter;
		}
		
		if (Entry.vpi == myEntry.vpi && Entry.vci == myEntry.vci)
		{
			cnt++;
			pIdx = i;	// Jenny, for multisession PPPoE, record entry index instead of atmvc entry pointer
		}

		ifMap |= 1 << (Entry.ifIndex & 0x0f);	// vc map
		ifMap |= (1 << 16) << ((Entry.ifIndex >> 4) & 0x0f);	// PPP map
	}

	if (cnt == 0)	// pvc not exists
	{
		myEntry.ifIndex = if_find_index(myEntry.cmode, ifMap);
		if (myEntry.ifIndex == 0xff)
		{
			strcpy(tmpBuf, T(strMaxVc));
			goto setErr_filter;
		}
		else if (myEntry.ifIndex == 0xef)
		{
			strcpy(tmpBuf, T(strMaxNumPPPoE));
			goto setErr_filter;
		}
	}
	else	// pvc exists
	{
		if (!mib_chain_get(MIB_ATM_VC_TBL, pIdx, (void *)&Entry)) {	// Jenny, for multisession PPPoE, get existed pvc config
			strcpy(tmpBuf, errGetEntry);
			goto setErr_filter;
		}
		if (Entry.cmode == ADSL_PPPoE && myEntry.cmode == ADSL_PPPoE)
		{
			if (cnt<MAX_POE_PER_VC)
			{	// get the pvc info.
				myEntry.qos = Entry.qos;
				myEntry.pcr = Entry.pcr;
				myEntry.encap = Entry.encap;
				ifMap &= 0xffff0000; // don't care the vc part
				myEntry.ifIndex = if_find_index(myEntry.cmode, ifMap);
				if (myEntry.ifIndex == 0xef)
				{
					strcpy(tmpBuf, T(strMaxNumPPPoE));
					goto setErr_filter;
				}
				myEntry.ifIndex &= 0xf0;
				myEntry.ifIndex |= (Entry.ifIndex&0x0f);
#ifdef PPPOE_PASSTHROUGH
				myEntry.brmode = Entry.brmode;	// Jenny, for multisession PPPoE
#endif
			}
			else
			{
				strcpy(tmpBuf, T(strMaxNumPPPoE));
				goto setErr_filter;
			}
		}
		else
		{
			strcpy(tmpBuf, T(strConnectExist));
			goto setErr_filter;
		}
	}

    mib_chain_update( MIB_ATM_VC_TBL, ( void * ) &myEntry, (unsigned int) vchar );
    
    if ( myEntry.cmode == ADSL_BR1483)
    {
        WizReboot( 0, wp, 0, NULL );
    }
    else if ( myEntry.cmode == ADSL_MER1483 )
    {
        websRedirect( wp, "/wiz_MERMode.asp" );
    }
    else if ( myEntry.cmode == ADSL_PPPoE)
    {
        websRedirect( wp, "/wiz_PPPoE.asp" );
    }
    else if ( myEntry.cmode == ADSL_PPPoA )
    {
        websRedirect( wp, "/wiz_PPPoA.asp" );
    }
    else if ( myEntry.cmode == ADSL_RT1483)
    {
        websRedirect( wp, "/wiz_routeMode.asp" );
    }
#ifdef CONFIG_ATM_CLIP
    else if (myEntry.cmode == ADSL_RT1577)
    {
        websRedirect( wp, "/wiz_MERMode.asp" );
    }
#endif
    else
        DEBUG("cmode is not defined\n");
    
    return;

setErr_filter:
    ERR_MSG(tmpBuf);
    return;
}

#ifdef DEFAULT_GATEWAY_V1
int checkDefaultRoute()
{
    int i, entryNum;
    MIB_CE_ATM_VC_T Entry;
    unsigned char vchar;
    vchar = getSelectPVCIndex();
    entryNum = mib_chain_total(MIB_ATM_VC_TBL);
    for(i = 0; i < entryNum; i++){
        if (vchar == i)
            continue;   // ignore current entry's gateway setting
        if (!mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&Entry)){
            DEBUG("Get chain record error!\n");
            return 0;
        }
        if (Entry.dgw == 1)
            return 1;   // default route is already exsit, return 1
    }
    
    return 0;
}
#endif

static int
retrieveVcRecordMer( webs_t wp, MIB_CE_ATM_VC_Tp pEntry )
{
    char tmpBuf[100];
    char_t* strValue, * strIp, * strMask, * strGW, * strMAC;
    unsigned int vUInt;
    MIB_CE_ATM_VC_T entry;

#ifdef DEFAULT_GATEWAY_V1
    // Default Route
    strValue = websGetVar( wp, T( "droute" ), T( "" ) );
    if ( strValue[0] )
    {
        entry.dgw = strValue[0] - '0';
        if (checkDefaultRoute() && entry.dgw == 1)
        {
            strcpy(tmpBuf, T(strDrouteExist));
            goto setErr_filter;
        }
    }
#else
    {
        char_t* strIp, * strIf;
        unsigned char vChar, strIfc;
        unsigned char dgw;
        struct in_addr inGatewayIp;

        strValue = websGetVar( wp, T( "droute" ), T( "" ) );
        if ( strValue[0] )
        {
            vChar = strValue[0] - '0';
        }

        if ( vChar == 0 )
        {
            strValue = websGetVar( wp, T( "gwStr" ), T( "" ) );
            if ( strValue[0] )
            {
                strIfc = strValue[0] - '0';
                if ( strIfc == 1 )
                {
                    char ifname[16];
                    strIf = websGetVar( wp, T( "wanIf" ), T( "" ) );
                    dgw = ( unsigned char ) atoi( strIf );
                }
                else if ( strIfc == 0 )
                {
                    dgw = DGW_NONE;
                    strIp = websGetVar( wp, T( "dstGtwy" ), T( "" ) );
                    if ( strIp[0] )
                    {
                        if ( !inet_aton( strIp, &inGatewayIp ) )
                        {
                            strcpy( tmpBuf, T( strInvalidGatewayerror ) );
                            goto setErr_filter;
                        }
                        if ( entry.cmode ==
                             ADSL_MER1483 ||
                             ( entry.cmode == ADSL_RT1483 &&
                               entry.ipunnumbered == 0 ) )
                        {
                            if ( !inet_aton( strIp,
                                             ( struct in_addr * ) &entry.remoteIpAddr ) )
                            {
                                strcpy( tmpBuf, T( strIPAddresserror ) );
                                goto setErr_filter;
                            }
                        }
                        if ( !mib_set( MIB_ADSL_WAN_DGW_IP,
                                       ( void * ) &inGatewayIp ) )
                        {
                            strcpy( tmpBuf, T( strSetGatewayerror ) );
                            goto setErr_filter;
                        }
                    }
                }
            }
        }
        else if ( vChar == 1 )
        {
            dgw = DGW_AUTO;
        }

        if ( !mib_set( MIB_ADSL_WAN_DGW_ITF, ( void * ) &dgw ) )
        {
            strcpy( tmpBuf, T( strSetGatewayerror ) );
            goto setErr_filter;
        }
    }
#endif

    // IP mode
    strValue = websGetVar( wp, T( "ipMode" ), T( "" ) );
    if ( strValue[0] )
    {
        if ( strValue[0] == '0' )
        {
            entry.ipDhcp = ( char ) DHCP_DISABLED;
        }
        else if ( strValue[0] == '1' )
        {
            entry.ipDhcp = ( char ) DHCP_CLIENT;
        }
        else
        {
            strcpy( tmpBuf, T( strInvalDHCP ) );
            goto setErr_filter;
        }
    }

    // Local IP address
    strIp = websGetVar( wp, T( "ip" ), T( "" ) );
    if ( strIp[0] )
    {
        if ( !inet_aton( strIp, ( struct in_addr * ) &entry.ipAddr ) )
        {
            strcpy( tmpBuf, T( strInvalIP ) );
            goto setErr_filter;
        }
    }

    // Remote IP address
    strGW = websGetVar( wp, T( "remoteIp" ), T( "" ) );
    if ( strGW[0] )
    {
        if ( !inet_aton( strGW, ( struct in_addr * ) &entry.remoteIpAddr ) )
        {
            strcpy( tmpBuf, T( strInvalGateway ) );
            goto setErr_filter;
        }
    }

    // Subnet Mask, added by Jenny
    strMask = websGetVar( wp, T( "netmask" ), T( "" ) );
    if ( strMask[0] )
    {
        if ( !isValidNetmask( strMask, 1 ) )
        {
            strcpy( tmpBuf, T( strInvalMask ) );
            goto setErr_filter;
        }
        if ( !inet_aton( strMask, ( struct in_addr * ) &entry.netMask ) )
        {
            strcpy( tmpBuf, T( strInvalMask ) );
            goto setErr_filter;
        }
        if ( !isValidHostID( strIp, strMask ) )
        {
            strcpy( tmpBuf, T( "Invalid IP/Subnet Mask combination!!" ) );
            goto setErr_filter;
        }
    }



    memcpy( pEntry, &entry, sizeof( entry ) );

        
    //lhj, wan mac
    strMAC = websGetVar(wp, T("wanmac"), T(""));
    if (strMAC[0]){
        strMAC[12] = '\0';
        if ( !string_to_hex(strMAC, pEntry->wanMAC, 12)) {
            strcpy(tmpBuf, T("Error, invalid wan mac address!"));
            goto setErr_filter;
        }
    }
    return 0;

    setErr_filter : ERR_MSG( tmpBuf );
    return -1;
}

void
formWizMer( webs_t wp, char_t* path, char_t* query )
{
    MIB_CE_ATM_VC_T Entry, myEntry, testEntry;
    char* temp, * tempremote, * tempnetMask;
    unsigned char vchar;
    vchar = getSelectPVCIndex();
    if ( retrieveVcRecordMer( wp, &Entry ) != 0 )
    {
        /*RegisterPVCnumber();    
          cleanAllFirewallRule();
          restart_dnsrelay();
          startWan(BOOT_LAST);*/
        websError( wp, 400, T( "Get chain record error!\n" ) );
        return -1;
        //carpenter: restartWAN();
        //return;
    }

    mib_chain_get( MIB_ATM_VC_TBL, (unsigned int) vchar, ( void * ) &myEntry );
    myEntry.ipDhcp = Entry.ipDhcp;
    //carpenter
    strncpy( myEntry.ipAddr, Entry.ipAddr, IP_ADDR_LEN );
    strncpy( myEntry.remoteIpAddr, Entry.remoteIpAddr, IP_ADDR_LEN );
    strncpy( myEntry.netMask, Entry.netMask, IP_ADDR_LEN );

    //carpenter
    //myEntry.ipAddr = Entry.ipAddr;
    //myEntry.remoteIpAddr = Entry.remoteIpAddr;
    //myEntry.netMask = Entry.netMask;

    myEntry.dgw = Entry.dgw;
    //lhj, copy wan mac
    int i;
    if (myEntry.cmode == ADSL_MER1483 )
    {
        for(i=0; i < MAC_ADDR_LEN; i++)
            myEntry.wanMAC[i] = Entry.wanMAC[i];
    }
    mib_chain_update( MIB_ATM_VC_TBL, ( void * ) &myEntry, (unsigned int) vchar );
    //carpenter : reboot
    //WizReboot( 0, wp, 0, NULL );
    // add wiz_dns web

    char_t *strValue;
    strValue = websGetVar( wp, T( "ipMode" ), T( "" ) );        

    if ( strValue[0] == '0' )
    {
        websRedirect( wp, "/wiz_dns.asp" );
    }
    else if ( strValue[0] == '1' )
    {
        WizReboot( 0, wp, 0, NULL );
     }
    return 0;
}



static int
retrieveVcRecordPPP( webs_t wp, MIB_CE_ATM_VC_Tp pEntry )
{
    char tmpBuf[100];
    char_t* strValue, * strIp, * strMask, * strGW;
    unsigned int vUInt;
    MIB_CE_ATM_VC_T entry;


#ifdef DEFAULT_GATEWAY_V1
    // Default Route
    strValue = websGetVar( wp, T( "droute" ), T( "" ) );
    if ( strValue[0] )
    {
        entry.dgw = strValue[0] - '0';
        if (checkDefaultRoute() && entry.dgw == 1)
        {
            strcpy(tmpBuf, T(strDrouteExist));
            goto setErr_filter;
        }
    }
#else
    {
        char_t* strIp, * strIf;
        unsigned char vChar, strIfc;
        unsigned char dgw;
        struct in_addr inGatewayIp;

        strValue = websGetVar( wp, T( "droute" ), T( "" ) );
        if ( strValue[0] )
        {
            vChar = strValue[0] - '0';
        }

        if ( vChar == 0 )
        {
            strValue = websGetVar( wp, T( "gwStr" ), T( "" ) );
            if ( strValue[0] )
            {
                strIfc = strValue[0] - '0';
                if ( strIfc == 1 )
                {
                    char ifname[16];
                    strIf = websGetVar( wp, T( "wanIf" ), T( "" ) );
                    dgw = ( unsigned char ) atoi( strIf );
                }
                else if ( strIfc == 0 )
                {
                    dgw = DGW_NONE;
                    strIp = websGetVar( wp, T( "dstGtwy" ), T( "" ) );
                    if ( strIp[0] )
                    {
                        if ( !inet_aton( strIp, &inGatewayIp ) )
                        {
                            strcpy( tmpBuf, T( strInvalidGatewayerror ) );
                            goto setErr_filter;
                        }
                        if ( entry.cmode ==
                             ADSL_MER1483 ||
                             ( entry.cmode == ADSL_RT1483 &&
                               entry.ipunnumbered == 0 ) )
                        {
                            if ( !inet_aton( strIp,
                                             ( struct in_addr * ) &entry.remoteIpAddr ) )
                            {
                                strcpy( tmpBuf, T( strIPAddresserror ) );
                                goto setErr_filter;
                            }
                        }
                        if ( !mib_set( MIB_ADSL_WAN_DGW_IP,
                                       ( void * ) &inGatewayIp ) )
                        {
                            strcpy( tmpBuf, T( strSetGatewayerror ) );
                            goto setErr_filter;
                        }
                    }
                }
            }
        }
        else if ( vChar == 1 )
        {
            dgw = DGW_AUTO;
        }

        if ( !mib_set( MIB_ADSL_WAN_DGW_ITF, ( void * ) &dgw ) )
        {
            strcpy( tmpBuf, T( strSetGatewayerror ) );
            goto setErr_filter;
        }
    }
#endif


#ifdef CONFIG_GUI_WEB
    // PPP user name
    strValue = websGetVar( wp, T( "pppUserName" ), T( "" ) );
    if ( strValue[0] )
    {
        if ( strlen( strValue ) > P_MAX_NAME_LEN - 1 )
        {
            strcpy( tmpBuf, T( strUserNametoolong ) );
            goto setErr_filter;
        }
        strncpy( entry.pppUsername, strValue, P_MAX_NAME_LEN - 1 );
        entry.pppUsername[P_MAX_NAME_LEN - 1] = '\0';
        //entry.pppUsername[P_MAX_NAME_LEN]='\0';
    }

    // PPP password
    strValue = websGetVar( wp, T( "pppPassword" ), T( "" ) );

    if ( strValue[0] )
    {
        if ( strlen( strValue ) > P_MAX_NAME_LEN - 1 )
        {
            strcpy( tmpBuf, T( strPasstoolong ) );
            goto setErr_filter;
        }
        strncpy( entry.pppPassword, strValue, P_MAX_NAME_LEN - 1 );
        entry.pppPassword[P_MAX_NAME_LEN - 1] = '\0';
        //entry.pppPassword[P_MAX_NAME_LEN]='\0';
    }
#else
    // PPP user name
    strValue = websGetVar( wp, T( "pppUserName" ), T( "" ) );
    if ( strValue[0] )
    {
        if ( strlen( strValue ) > MAX_PPP_NAME_LEN )
        {
            strcpy( tmpBuf, T( strUserNametoolong ) );
            goto setErr_filter;
        }
        strncpy( entry.pppUsername, strValue, MAX_PPP_NAME_LEN );
        entry.pppUsername[MAX_PPP_NAME_LEN] = '\0';
    }

    // PPP password
    strValue = websGetVar( wp, T( "pppPassword" ), T( "" ) );

    if ( strValue[0] )
    {
        if ( strlen( strValue ) > MAX_NAME_LEN - 1 )
        {
            strcpy( tmpBuf, T( strPasstoolong ) );
            goto setErr_filter;
        }
        strncpy( entry.pppPassword, strValue, MAX_NAME_LEN - 1 );
        entry.pppPassword[MAX_NAME_LEN - 1] = '\0';
        //entry.pppPassword[MAX_NAME_LEN]='\0';
    }
#endif

    // PPP connection type
    strValue = websGetVar( wp, T( "pppConnectType" ), T( "" ) );

    if ( strValue[0] )
    {
        PPP_CONNECT_TYPE_T type;

        if ( strValue[0] == '0' )
            type = CONTINUOUS;
        else if ( strValue[0] == '1' )
            type = CONNECT_ON_DEMAND;
        else if ( strValue[0] == '2' )
            type = MANUAL;
        else
        {
            strcpy( tmpBuf, T( strInvalPPPType ) );
            goto setErr_filter;
        }

        entry.pppCtype = ( unsigned char ) type;

        if ( type != CONTINUOUS )
        {
            // PPP idle time
            strValue = websGetVar( wp, T( "pppIdleTime" ), T( "" ) );
            if ( strValue[0] )
            {
                unsigned short time;
                time = ( unsigned short ) strtol( strValue,
                                                  ( char * * ) NULL,
                                                  10 );
                entry.pppIdleTime = time;
            }
        }
    }

//lhj,  get PPP static ip from web
#ifdef CONFIG_SPPPD_STATICIP
		strValue = websGetVar(wp, T("pppip"), T(""));
		if (strValue[0])
                    entry.pppIp = strValue[0] - '0';
        
		strIp = websGetVar(wp, T("staticip"), T(""));
		if (strIp[0]) {
			if (!inet_aton(strIp, (struct in_addr *)&entry.ipAddr)) {
				strcpy(tmpBuf, T(strInvalIP));
				goto setErr_filter;
			}
		}
#endif

    memcpy( pEntry, &entry, sizeof( entry ) );
    return 0;

    setErr_filter : ERR_MSG( tmpBuf );
    return -1;
}


// map: bit map of used interface, ppp index (0~15) is mapped into high 16 bits,
// while vc index (0~15) is mapped into low 16 bits.
// return: interface index, high nibble for PPP index and low nibble for vc index.
//		0xef: PPP not available
//		0xff: vc not available
static unsigned char if_find_index(int cmode, unsigned int map)
{
	int i;
	unsigned char index;
	
	// find the first available vc index (mpoa interface)
	i = 0;
	for (i=0; i<MAX_VC_NUM; i++)
	{
		if (!((map>>i) & 1))
			break;
	}
	
	if (i != MAX_VC_NUM)
		index = i;
	else
		return 0xff;
	
	if (cmode == ADSL_PPPoE || cmode == ADSL_PPPoA)
	{
		// find an available PPP index
		map >>= 16;
		i = 0;
		while (map & 1)
		{
			map >>= 1;
			i++;
		}
		if (i<=(MAX_PPP_NUM-1))
			index |= i << 4;	// high nibble for PPP index
		else
			return 0xef;
		
		if (cmode == ADSL_PPPoA)
			index |= 0x0f;	// PPPoA doesn't use mpoa interface, set to 0x0f (don't care)
	}
	else
	{
		// don't care the PPP index
		index |= 0xf0;
	}
	return index;
}

void
formWizPPPoA( webs_t wp, char_t* path, char_t* query )
{
    MIB_CE_ATM_VC_T Entry, myEntry, testEntry;
    //unsigned int ifMap = 0;
    unsigned char vchar;
    vchar = getSelectPVCIndex();
    if ( retrieveVcRecordPPP( wp, &Entry ) != 0 )
    {
        /*RegisterPVCnumber();    
          cleanAllFirewallRule();
          restart_dnsrelay();
          startWan(BOOT_LAST);*/
        restartWAN();
        return;
    }

    mib_chain_get( MIB_ATM_VC_TBL, (unsigned int) vchar, ( void * ) &myEntry );

    //add by lhj
    //myEntry.ifIndex = if_find_index(myEntry.cmode, ifMap);
#ifdef _CWMP_MIB_
    myEntry.ConIPInstNum = 1;
#endif

    myEntry.mtu = 1500;
#ifdef CONFIG_USER_PPPOE_PROXY
    myEntry.PPPoEProxyMaxUser=4;
    myEntry.PPPoEProxyEnable=0;
#endif
    
#ifdef CONFIG_EXT_SWITCH
		// VLAN
		myEntry.vlan = 0;	// disable
		myEntry.vid = 0; // VLAN tag
		myEntry.vprio = 0; // priority bits (0 ~ 7)
		myEntry.vpass = 0; // no pass-through
#endif
    //end by lhj

    strcpy( myEntry.pppUsername, Entry.pppUsername );
    strcpy( myEntry.pppPassword, Entry.pppPassword );
    myEntry.pppCtype = Entry.pppCtype;
    myEntry.pppIdleTime = Entry.pppIdleTime;
    myEntry.dgw = Entry.dgw;

#ifdef CONFIG_SPPPD_STATICIP
    myEntry.pppIp = Entry.pppIp;
    strncpy( myEntry.ipAddr, Entry.ipAddr, IP_ADDR_LEN );
#endif
    mib_chain_update( MIB_ATM_VC_TBL, ( void * ) &myEntry, (unsigned int) vchar );

    //carpenter : reboot
    char_t *strValue;
    strValue = websGetVar( wp, T( "pppip" ), T( "" ) );        

    if ( strValue[0] == '1' )
    {
        websRedirect( wp, "/wiz_dns.asp" );
    }
    else if ( strValue[0] == '0' )
    {
        WizReboot( 0, wp, 0, NULL );
     }

    //mib_chain_get(MIB_ATM_VC_TBL, 0, (void *)&testEntry);
    //printf("\n\n------testEntry.pppUsername=%s-----\n------testEntry.pppPassword=%s----\n-----testEntry.pppCtype=%d-------\n------testEntry.pppIdleTime=%d----\n-----testEntry.dgw=%d------\n\n", testEntry.pppUsername, testEntry.pppPassword, testEntry.pppCtype, testEntry.pppIdleTime, testEntry.dgw);

    return;
}

void
formWizPPPoE( webs_t wp, char_t* path, char_t* query )
{
    MIB_CE_ATM_VC_T Entry, myEntry, testEntry;
    //unsigned int ifMap = 0;
    unsigned char vchar;
    vchar = getSelectPVCIndex();
    if ( retrieveVcRecordPPP( wp, &Entry ) != 0 )
    {
        /*RegisterPVCnumber();    
          cleanAllFirewallRule();
          restart_dnsrelay();
          startWan(BOOT_LAST);*/
        //carpenter:restartWAN();
        websError( wp, 400, T( "Get chain record error!\n" ) );
        return -1;
        //return;
    }

    mib_chain_get( MIB_ATM_VC_TBL, (unsigned int) vchar, ( void * ) &myEntry );

    //add by lhj
    //myEntry.ifIndex = if_find_index(myEntry.cmode, ifMap);
    //myEntry.ConIPInstNum = 1;

    myEntry.mtu = 1492;
#ifdef CONFIG_USER_PPPOE_PROXY
    myEntry.PPPoEProxyMaxUser=4;
    myEntry.PPPoEProxyEnable=0;
#endif
    
#ifdef CONFIG_EXT_SWITCH
		// VLAN
		myEntry.vlan = 0;	// disable
		myEntry.vid = 0; // VLAN tag
		myEntry.vprio = 0; // priority bits (0 ~ 7)
		myEntry.vpass = 0; // no pass-through
#endif
    // end by lhj

    strcpy( myEntry.pppUsername, Entry.pppUsername );
    strcpy( myEntry.pppPassword, Entry.pppPassword );
    myEntry.pppCtype = Entry.pppCtype;
    myEntry.pppIdleTime = Entry.pppIdleTime;
    myEntry.dgw = Entry.dgw;
    myEntry.brmode = BRIDGE_DISABLE;

#ifdef CONFIG_SPPPD_STATICIP
    myEntry.pppIp = Entry.pppIp;
    strncpy( myEntry.ipAddr, Entry.ipAddr, IP_ADDR_LEN );
#endif
    mib_chain_update( MIB_ATM_VC_TBL, ( void * ) &myEntry, (unsigned int) vchar );

    //carpenter : reboot
    char_t *strValue;
    strValue = websGetVar( wp, T( "pppip" ), T( "" ) );        

    if ( strValue[0] == '1' )
    {
        websRedirect( wp, "/wiz_dns.asp" );
    }
    else if ( strValue[0] == '0' )
    {
        WizReboot( 0, wp, 0, NULL );
     }
    //  mib_chain_get(MIB_ATM_VC_TBL, 0, (void *)&testEntry);
    //printf("\n\n------testEntry.pppUsername=%s-----\n------testEntry.pppPassword=%s----\n-----testEntry.pppCtype=%d-------\n------testEntry.pppIdleTime=%d----\n-----testEntry.dgw=%d------\n\n", testEntry.pppUsername, testEntry.pppPassword, testEntry.pppCtype, testEntry.pppIdleTime, testEntry.dgw);

    return;
}


static int
retrieveVcRecordRt( webs_t wp, MIB_CE_ATM_VC_Tp pEntry )
{
    char tmpBuf[100];
    char_t* strValue, * strIp, * strMask, * strGW;
    unsigned int vUInt;
    MIB_CE_ATM_VC_T entry;


    // Enable NAPT
    strValue = websGetVar( wp, T( "naptEnabled" ), T( "" ) );
    if ( !gstrcmp( strValue, T( "ON" ) ) )
    {
        entry.napt = 1;
    }
    else
    {
        entry.napt = 0;
    }

#ifdef DEFAULT_GATEWAY_V1
    // Default Route
    strValue = websGetVar( wp, T( "droute" ), T( "" ) );
    if ( strValue[0] )
    {
        entry.dgw = strValue[0] - '0';
        if (checkDefaultRoute() && entry.dgw == 1)
        {
            strcpy(tmpBuf, T(strDrouteExist));
            goto setErr_filter;
        }
    }
#else
    {
        char_t* strIp, * strIf;
        unsigned char vChar, strIfc;
        unsigned char dgw;
        struct in_addr inGatewayIp;

        strValue = websGetVar( wp, T( "droute" ), T( "" ) );
        if ( strValue[0] )
        {
            vChar = strValue[0] - '0';
        }

        if ( vChar == 0 )
        {
            strValue = websGetVar( wp, T( "gwStr" ), T( "" ) );
            if ( strValue[0] )
            {
                strIfc = strValue[0] - '0';
                if ( strIfc == 1 )
                {
                    char ifname[16];
                    strIf = websGetVar( wp, T( "wanIf" ), T( "" ) );
                    dgw = ( unsigned char ) atoi( strIf );
                }
                else if ( strIfc == 0 )
                {
                    dgw = DGW_NONE;
                    strIp = websGetVar( wp, T( "dstGtwy" ), T( "" ) );
                    if ( strIp[0] )
                    {
                        if ( !inet_aton( strIp, &inGatewayIp ) )
                        {
                            strcpy( tmpBuf, T( strInvalidGatewayerror ) );
                            goto setErr_filter;
                        }
                        if ( entry.cmode ==
                             ADSL_MER1483 ||
                             ( entry.cmode == ADSL_RT1483 &&
                               entry.ipunnumbered == 0 ) )
                        {
                            if ( !inet_aton( strIp,
                                             ( struct in_addr * ) &entry.remoteIpAddr ) )
                            {
                                strcpy( tmpBuf, T( strIPAddresserror ) );
                                goto setErr_filter;
                            }
                        }
                        if ( !mib_set( MIB_ADSL_WAN_DGW_IP,
                                       ( void * ) &inGatewayIp ) )
                        {
                            strcpy( tmpBuf, T( strSetGatewayerror ) );
                            goto setErr_filter;
                        }
                    }
                }
            }
        }
        else if ( vChar == 1 )
        {
            dgw = DGW_AUTO;
        }

        if ( !mib_set( MIB_ADSL_WAN_DGW_ITF, ( void * ) &dgw ) )
        {
            strcpy( tmpBuf, T( strSetGatewayerror ) );
            goto setErr_filter;
        }
    }
#endif
#ifdef ZTE_GENERAL_ROUTER_SC
    strValue = websGetVar( wp, T( "ipUnnum" ), T( "" ) );
    if ( !gstrcmp( strValue, T( "ON" ) ) )
    {
        entry.ipunnumbered = 1;
    }
    else
    {
        entry.ipunnumbered = 0;
    }
#endif  

    // Local IP address
    strIp = websGetVar( wp, T( "ip" ), T( "" ) );
    if ( strIp[0] )
    {
        if ( !inet_aton( strIp, ( struct in_addr * ) &entry.ipAddr ) )
        {
            strcpy( tmpBuf, T( strInvalIP ) );
            goto setErr_filter;
        }
    }

    // Remote IP address
    strGW = websGetVar( wp, T( "remoteIp" ), T( "" ) );
    if ( strGW[0] )
    {
        if ( !inet_aton( strGW, ( struct in_addr * ) &entry.remoteIpAddr ) )
        {
            strcpy( tmpBuf, T( strInvalGateway ) );
            goto setErr_filter;
        }
    }

    
    memcpy( pEntry, &entry, sizeof( entry ) );
    return 0;

    setErr_filter : ERR_MSG( tmpBuf );
    return -1;
}


void
formWizRoute( webs_t wp, char_t* path, char_t* query )
{
    MIB_CE_ATM_VC_T Entry, myEntry, testEntry;
    char* temp, * tempremote, * tempnetmask;
    unsigned char vchar;
    vchar = getSelectPVCIndex();
    if ( retrieveVcRecordRt( wp, &Entry ) != 0 )
    {
        websError( wp, 400, T( "Get chain record error!\n" ) );
        return -1;
    }

    mib_chain_get( MIB_ATM_VC_TBL, (unsigned int) vchar, ( void * ) &myEntry );

    myEntry.napt = Entry.napt;
    strcpy( myEntry.ipAddr, Entry.ipAddr );
    strcpy( myEntry.remoteIpAddr, Entry.remoteIpAddr );
    myEntry.ipunnumbered = Entry.ipunnumbered;
    myEntry.dgw = Entry.dgw;

    mib_chain_update( MIB_ATM_VC_TBL, ( void * ) &myEntry, (unsigned int) vchar );

    //carpenter : reboot
    //WizReboot( 0, wp, 0, NULL );
    // add wiz_dns web
    websRedirect( wp, "/wiz_dns.asp" );
    return 0;
}

int
atmVcList3( int eid, webs_t wp, int argc, char_t** argv )
{
    //carpenter

    DEBUG( "\n  atmVcList3 ---1\n" );
    int nBytesSent = 0;

    unsigned int entryNum, i;
    MIB_CE_ATM_VC_T Entry;


    char vpi[6], vci[6], * aal5Encap;
    entryNum = mib_chain_total( MIB_ATM_VC_TBL );

    int flags;
    DEBUG( "\n  atmVcList3 ---2\n" );
    char vc_checked[10] = "";
    char llc_checked[10] = "checked";
    unsigned char vchar;
    vchar = getSelectPVCIndex();
    DEBUG("MIB_WIZ_MULTIPVC is %d, total Entry is %d\n", vchar, entryNum);
    if ( entryNum != 0 )
    {
        if ( !mib_chain_get( MIB_ATM_VC_TBL, (unsigned int) vchar, ( void * ) &Entry ) )
        {
            websError( wp, 400, T( "Get chain record error!\n" ) );
            return -1;
        }
        snprintf( vpi, 6, "%u", Entry.vpi );
        snprintf( vci, 6, "%u", Entry.vci );

        aal5Encap = 0;

        if ( Entry.encap == 0 )
        {
            strcpy( vc_checked, "checked" );
            strcpy( llc_checked, "" );
        }
        DEBUG( "\n  atmVcList3 ---3\n" );
        DEBUG( "\n  atmVcList3:%s %s %s %s \n",
               vpi,
               vci,
               llc_checked,
               vc_checked );
        nBytesSent += websWrite( wp,
                                 T( "\n<tr>\n"
                                    " <td width=\"30%%\" nowrap class=\"bgblue\">VPI: </td>\n"
                                    " <td width=\"70%%\" class=\"bggrey\">\n"
                                    "<input type=\"text\" name=\"vpi\" size=\"4\" maxlength=\"3\" value=%s>\n"
                                    "  </td>\n"
                                    " </tr>\n"
                                    "<tr>\n"
                                    "<td class=\"bgblue\">&nbsp;&nbsp;VCI:</td>\n"
                                    "	<td class=\"bggrey\">\n"
                                    "<input type=\"text\" name=\"vci\" size=\"6\" maxlength=\"5\" value=%s>\n"
                                    "	</td>\n"
                                    " </tr>\n"
                                    " <tr>\n"
                                    "		<td class=\"bgblue\">Encapsulation: </td>\n"
                                    "		<td class=\"bggrey\">\n"
                                    "	<input type=\"radio\" value=\"1\" name=\"adslEncap\"  %s >LLC &nbsp;&nbsp;\n"
                                    "			<input type=\"radio\" value=\"0\" name=\"adslEncap\" %s>VC-Mux</td>\n"
                                    "</tr>\n" ),
                                 vpi,
                                 vci,
                                 llc_checked,
                                 vc_checked );
        DEBUG( "\n  atmVcList3 ---4\n" );

        return nBytesSent;
    }
    else
    {
        DEBUG( "\n  atmVcList3 ---5\n" );
        nBytesSent += websWrite( wp,
                                 T( "<tr>\n"
                                    " <td width=\"30%%\" nowrap class=\"bgblue\">VPI: </td>"
                                    " <td width=\"70%%\" class=\"bggrey\">"
                                    "<input type=\"text\" name=\"vpi\" size=\"4\" maxlength=\"3\" value=8>"
                                    "  </td>"
                                    " </tr>"
                                    "<tr>"
                                    "<td class=\"bgblue\">&nbsp;&nbsp;VCI:</td>"
                                    "	<td class=\"bggrey\">"
                                    "	<input type=\"text\" name=\"vci\" size=\"6\" maxlength=\"5\" value=35>"
                                    "	</td>"
                                    " </tr>"
                                    " <tr>"
                                    "		<td class=\"bgblue\">Encapsulation: </td>"
                                    "		<td class=\"bggrey\">"
                                    "	<input type=\"radio\" value=\"1\" name=\"adslEncap\" checked >LLC &nbsp;&nbsp;"
                                    "			<input type=\"radio\" value=\"0\" name=\"adslEncap\">VC-Mux</td>"
                                    "</tr>" ) );

        DEBUG( "\n  atmVcList3 ---6\n" );
        return nBytesSent;
    }
}


int
atmModeList3( int eid, webs_t wp, int argc, char_t** argv )
{
    //carpenter

    DEBUG( "\n  atmModeList3 ---1\n" );
    unsigned char vChar;
    unsigned short mode;
    char glite[10] = "";
    char t1413[10] = "";
    char gdmt[10] = "";

    mib_get( MIB_ADSL_MODE, ( void * ) &mode );
    DEBUG( "\n  atmModeList3:mode:%u ---2\n", mode );
    if ( mode & ADSL_MODE_GLITE )
    {
        strcpy( glite, " checked" );
    }
    if ( mode & ADSL_MODE_T1413 )
    {
        strcpy( t1413, " checked" );
    }
    if ( mode & ADSL_MODE_GDMT )
    {
        strcpy( gdmt, " checked" );
    }
    DEBUG( "\n  atmModeList3 ---2\n" );
    int nBytesSent = 0;
    DEBUG( "\n  atmVcList3:%s %s %s \n",
           glite,
           gdmt,
           t1413);
    nBytesSent += websWrite( wp,
                             T( "	<tr>\n"
                                "			<td class=\"bggrey\"><input type=checkbox name=glite value=1 %s>G.Lite</td>\n"
                                "	      		<td class=\"bggrey\"><input type=checkbox name=gdmt value=1 %s>G.Dmt</td>\n"
                                "			<td class=\"bggrey\"><input type=checkbox name=t1413 value=1 %s>T1.413</td>\n"
				    "	</tr>\n"
				    "	<tr>\n"
                                "		<td class=\"bggrey\"><input type=checkbox name=adsl2 value=1 checked disabled><font color=\"gray\">ADSL2</font></td>\n"
                                "			<td class=\"bggrey\"><input type=checkbox name=adsl2p value=1 checked disabled><font color=\"gray\">ADSL2+</font></td>\n"
                                "	</tr>\n" ),
                             glite,
                             gdmt,
                             t1413 );
    DEBUG( "\n  atmModeList3 ---3\n" );

    return nBytesSent;
}


int
atmChannelModeList3( int eid, webs_t wp, int argc, char_t** argv )
{
    //carpenter
    DEBUG( "\n  atmChannelModeList3 ---1\n" );
    int nBytesSent = 0;

    unsigned int entryNum, i;
    MIB_CE_ATM_VC_T Entry;


    char vpi[6], vci[6], * aal5Encap;
    entryNum = mib_chain_total( MIB_ATM_VC_TBL );
    DEBUG( "\n  atmChannelModeList3 ---2\n" );
    char PPPoE_checked[10] = " ";
    char PPPoA_checked[10] = " ";
    char br1483_checked[10] = " ";
    char mer1483_checked[10] = " ";
    char rt1483_checked[10] = " ";
    char rt1577_checked[10] = " ";
    unsigned char vchar;
    vchar = getSelectPVCIndex();
    DEBUG( "\n  atmChannelModeList3 ---3\n" );
    if ( entryNum != 0 )
    {
        if ( !mib_chain_get( MIB_ATM_VC_TBL, (unsigned int) vchar, ( void * ) &Entry ) )
        {
            websError( wp, 400, T( "Get chain record error!\n" ) );
            return -1;
        }
        DEBUG( "\n  atmChannelModeList3:mode:%d ---4\n", Entry.cmode );
        if ( Entry.cmode == ADSL_PPPoE )
            strcpy( PPPoE_checked, " checked" );
        else if ( Entry.cmode == ADSL_PPPoA )
            strcpy( PPPoA_checked, " checked" );
        else if ( Entry.cmode == ADSL_BR1483 )
            strcpy( br1483_checked, " checked" );
        else if ( Entry.cmode == ADSL_MER1483 )
            strcpy( mer1483_checked, " checked" );
        else if ( Entry.cmode == ADSL_RT1483 )
            strcpy( rt1483_checked, " checked" );
#ifdef CONFIG_ATM_CLIP
        else if (Entry.cmode == ADSL_RT1577)
            strcpy( rt1577_checked, " checked");
#endif
    }
    else
    {
        strcpy( PPPoE_checked, " checked" );
    } 
    DEBUG( "\n  atmChannelModeList: %s %s %s %s %s  ---\n",
           br1483_checked,
           mer1483_checked,
           PPPoE_checked,
           PPPoA_checked,
           rt1483_checked );
    nBytesSent += websWrite( wp,
                             T( "<tr>"
                                "<td nowrap class=\"bggrey\">"
                                "<input type=\"radio\" value=\"0\" name=\"adslConnectionMode\" %s>1483 Bridged (Modem mode) &nbsp;&nbsp;"
                                " </td>"
                                "</tr>"
                                "<tr>"
                                "<td nowrap class=\"bggrey\">"
                                "<input type=\"radio\" value=\"1\" name=\"adslConnectionMode\" %s >1483 MER (Router + Modem)&nbsp;&nbsp;"
                                " </td>"
                                "  </tr>"
                                " <tr>"
                                "    <td nowrap class=\"bggrey\">"
                                "   	<input type=\"radio\" value=\"2\" name=\"adslConnectionMode\"  %s>PPPoE &nbsp;&nbsp;"
                                "    </td>"
                                " </tr>"
                                "<tr>"
                                " <td nowrap class=\"bggrey\">"
                                " 	<input type=\"radio\" value=\"3\" name=\"adslConnectionMode\"  %s>PPPoA &nbsp;&nbsp;"
                                " </td>"
                                "</tr>"
                                "<tr>"
                                "<td nowrap class=\"bggrey\">"
                                "<input type=\"radio\" value=\"4\" name=\"adslConnectionMode\"  %s>1483 Routed &nbsp;&nbsp;"
                                " </td>"
                                " </tr>"),
                             br1483_checked,
                             mer1483_checked,
                             PPPoE_checked,
                             PPPoA_checked,
                             rt1483_checked);
#ifdef CONFIG_ATM_CLIP
       nBytesSent += websWrite(wp,
                               T( "<tr>"
                                "<td nowrap class=\"bggrey\">"
                                "<input type=\"radio\" value=\"5\" name=\"adslConnectionMode\"  %s>1577 Routed &nbsp;&nbsp;"
                                " </td>"
                                " </tr>"),rt1577_checked);
#endif
    DEBUG( "\n  atmChannelModeList3 ---5\n" );
    return nBytesSent;
}


int
atmMerList3( int eid, webs_t wp, int argc, char_t** argv )
{
    //carpenter
    DEBUG( "\n  atmMerList3 ---1\n" );
    MIB_CE_ATM_VC_T testEntry;
    char* temp, * tempremote, * tempnetMask;
    char fix_ipdhcp_checked[10] = "";
    char dhcp_ipdhcp_checked[10] = "";
    char en_drt_checked[10] = "";
    char dis_drt_checked[10] = "";
    unsigned char vchar;
    vchar = getSelectPVCIndex();

    memset( &testEntry, 0, sizeof( MIB_CE_ATM_VC_T ) );
    mib_chain_get( MIB_ATM_VC_TBL, (unsigned int) vchar, ( void * ) &testEntry );
    DEBUG( "\n  atmMerList3 ---2\n" );

    DEBUG( "\nformWizMer:ipDhcp:%u\n", testEntry.ipDhcp );
    DEBUG( "\nformWizMer:dgw:%u\n", testEntry.dgw );

    char ipaddr[20], remoteaddr[20], netmask[20];
    memset( ipaddr, 0, 20 );
    memset( remoteaddr, 0, 20 );
    memset( netmask, 0, 20 );
    if ( testEntry.ipDhcp == 1 || testEntry.ipAddr[0] == 0)
    {
        strcpy( dhcp_ipdhcp_checked, " checked" );
    }
    else
    {
        temp = inet_ntoa( *( ( struct in_addr * ) testEntry.ipAddr ) );
        strncpy( ipaddr, temp, 19 );
        DEBUG( "\nformWizMer:ipaddr:%s\n", ipaddr );

        tempremote = inet_ntoa( *( ( struct in_addr * ) testEntry.remoteIpAddr ) );
        strncpy( remoteaddr, tempremote, 19 );
        DEBUG( "\nformWizMer:remoteaddr:%s\n", remoteaddr );

        tempnetMask = inet_ntoa( *( ( struct in_addr * ) testEntry.netMask ) );
        strncpy( netmask, tempnetMask, 19 );
        DEBUG( "\nformWizMer:netmask:%s\n", netmask );
        strcpy( fix_ipdhcp_checked, " checked" );
    }

    //if ( testEntry.dgw == 1 )
    //{
        strcpy( en_drt_checked, " checked" );
    //}
    //else
    //{
    //    strcpy( dis_drt_checked, " checked" );
    //}

    int nBytesSent = 0;
    
#ifdef CONFIG_ATM_CLIP
    if ( testEntry.cmode == ADSL_RT1577 )
        nBytesSent += websWrite( wp,
                             T( "\n<tr>         	"
                                "\n<td class=\"headerbg2\">1577 Routed</td></tr>"));
    else
#endif
        nBytesSent += websWrite( wp,
                             T( "\n<tr>         	"
                                "\n<td class=\"headerbg2\">1483 MER (Router + modem)</td></tr>"));
    
    nBytesSent += websWrite( wp,
                               T( "\n<tr><td height=\"230\" align=\"center\" valign=\"top\"><br>"
                                "\n<table width=\"500\" border=\"0\" cellpadding=\"3\" cellspacing=\"1\" bgcolor=\"#4b688b\">"
                                "\n<tr><td nowrap><font color=\"#FFFFFF\">WAN IP Settings</font></td>"
                                "\n</tr>" ));
    nBytesSent += websWrite( wp,
                             T( "\n<tr>         	"
                                "\n<td width=\"11%%\" class=\"bgblue\">Type:</td>"
                                "\n<td width=\"89%%\" class=\"bggrey\" nowrap>"
                                "\n<input type=radio value=\"0\" name=\"ipMode\" %s onClick=\"ipTypeSelection()\">Fixed IP&nbsp;&nbsp;"
                                "\n<input type=radio value=\"1\" name=\"ipMode\" %s onClick=\"ipTypeSelection()\">DHCP"
                                "     \n </td>"
                                "\n</tr>"
                                "\n<tr>       	"
                                "\n	<td width=\"11%%\" class=\"bgblue\" nowrap>Local IP Address:</td>"
                                "\n       <td width=\"89%%\" class=\"bggrey\" nowrap>"
                                "\n        <input type=\"text\" name=\"ip\" size=15 maxlength=15 value=%s >"
                                "\n	</td>"
                                "\n</tr>" ),
                             fix_ipdhcp_checked,
                             dhcp_ipdhcp_checked,
                             ipaddr );

    nBytesSent += websWrite( wp,
                             T( "\n<tr>          	"
                                "\n	      <td width=\"11%%\" class=\"bgblue\" nowrap>Gateway IP Address:</td>"
                                "\n	      <td width=\"89%%\" class=\"bggrey\" nowrap>"
                                "\n	    <input type=\"text\" name=\"remoteIp\" size=15 maxlength=15 value=%s>"
                                "\n             </td>"
                                "\n </tr>"
                                " \n<tr>"
                                "\n     <td width=\"11%%\" class=\"bgblue\" nowrap>Subnet Mask:</td>"
                                "\n	      <td width=\"89%%\" class=\"bggrey\" nowrap>"
                                "\n	      <input type=\"text\" name=\"netmask\" size=15 maxlength=15 value=%s >"
                                "\n	      </td>"
                                "\n</tr>"
                                "\n<tr> "
                                "\n <td width=\"11%%\" class=\"bgblue\" nowrap>Default Route:</td>"
                                "\n <td width=\"89%%\" class=\"bggrey\" nowrap>"
                                "\n <input type=radio value=\"0\" name=\"droute\" %s >Disable&nbsp;&nbsp;"
                                "\n <input type=radio value=\"1\" name=\"droute\" %s >Enable"
                                "\n </td>"
                                "\n</tr>" ),
                             remoteaddr,
                             netmask,
                             dis_drt_checked,
                             en_drt_checked );
    
    DEBUG( "\nformWizMer:cmode:%u\n", testEntry.cmode );
    if ( testEntry.cmode == ADSL_MER1483 )
    {
	 unsigned char devAddr[MAC_ADDR_LEN];
        char macaddr[MAC_ADDR_LEN*2+1];
        
       if(testEntry.wanMAC[1] == '\0' && testEntry.wanMAC[2] == '\0' && testEntry.wanMAC[3] == '\0'
                                                    && testEntry.wanMAC[4] == '\0' && testEntry.wanMAC[5] == '\0')
       {
            mib_get(MIB_ELAN_MAC_ADDR, (void *)devAddr);
	     snprintf(macaddr, 13, "%02x%02x%02x%02x%02x%02x",
                                devAddr[0], devAddr[1], devAddr[2],
                                devAddr[3], devAddr[4], devAddr[5]);
       }
       else
       {
	     snprintf(macaddr, 13, "%02x%02x%02x%02x%02x%02x",
				testEntry.wanMAC[0], testEntry.wanMAC[1], testEntry.wanMAC[2],
				testEntry.wanMAC[3], testEntry.wanMAC[4], testEntry.wanMAC[5]);
       }
       
        nBytesSent += websWrite( wp,
                             T("<tr>          	"
                                "     <td width=\"11%%\" class=\"bgblue\" nowrap>Wan MAC:</td>"
                                "     <td width=\"89%%\" class=\"bggrey\" nowrap>"
                                "     <input type=\"text\" name=\"wanmac\" size=15 maxlength=15 value=%s >"
                                "     </td>"
                                "</tr>" ),
                             macaddr);
        DEBUG( "\nformWizMer:macaddr:%s\n", macaddr );
    }
    
    nBytesSent += websWrite( wp,T( "</table></td> </tr>"));

    DEBUG( "\n  atmMerList3 ---3\n" );
    return nBytesSent;
}


int
atmRouteList3( int eid, webs_t wp, int argc, char_t** argv )
{
    DEBUG( "\n  atmRouteList3(---1\n" );
    MIB_CE_ATM_VC_T testEntry;
    char* temp, * tempremote, * tempnetMask;
    char en_napt_checked[10] = "";
    //char dis_napt_checked[10]="";
    char en_drt_checked[10] = "";
    char dis_drt_checked[10] = "";
    char en_ipunnumbered_checked[10] = "";
    //char dis_ipunnumbered_checked[10]="";
    unsigned char vchar;
    vchar = getSelectPVCIndex();

    memset( &testEntry, 0, sizeof( MIB_CE_ATM_VC_T ) );
    mib_chain_get( MIB_ATM_VC_TBL, (unsigned int) vchar, ( void * ) &testEntry );
    DEBUG( "\n  atmMerList3 ---2\n" );


    DEBUG( "\natmRouteList3(:dgw:%u\n", testEntry.dgw );
    DEBUG( "\natmRouteList3(:napt:%u\n", testEntry.napt );
    DEBUG( "\natmRouteList3(:ipunnumbered:%u\n", testEntry.ipunnumbered );

//    if ( testEntry.dgw == 1 )
//    {
        strcpy( en_drt_checked, " checked" );
//    }
//    else
//   {
//        strcpy( dis_drt_checked, " checked" );
//    }

    if ( testEntry.napt == 1 )
    {
        strcpy( en_napt_checked, " checked" );
    }
    //else
    //  strcpy(dis_napt_checked," checked");

    if ( testEntry.ipunnumbered == 1 )
    {
        strcpy( en_ipunnumbered_checked, " checked" );
    }
    //else
    //  strcpy(dis_ipunnumbered_checked," checked");

    char ipaddr[20], remoteaddr[20];
    memset( ipaddr, 0, 20 );
    memset( remoteaddr, 0, 20 );
    temp = inet_ntoa( *( ( struct in_addr * ) testEntry.ipAddr ) );
    strncpy( ipaddr, temp, 19 );
    DEBUG( "\natmRouteList3(:ipaddr:%s\n", ipaddr );

    tempremote = inet_ntoa( *( ( struct in_addr * ) testEntry.remoteIpAddr ) );
    strncpy( remoteaddr, tempremote, 19 );
    DEBUG( "\natmRouteList3(:remoteaddr:%s\n", remoteaddr );



    int nBytesSent = 0;
    nBytesSent += websWrite( wp,
                             T( "<tr>       	"
                                "<td width=\"11%%\" class=\"bgblue\" nowrap>Enable NAPT:</td>"
                                " <td width=\"89%%\" class=\"bggrey\" nowrap>"
                        //"  <input type=\"checkbox\" name=\"naptEnabled\" size=\"2\" maxlength=\"2\" value=\"ON\" onClick=naptClicked()>"
                        "  <input type=\"checkbox\" name=\"naptEnabled\" size=\"2\" maxlength=\"2\" %s  onClick=naptClicked()>"
                                "</td>"
                                "</tr>"
                                "<tr>       	"
                                "<td width=\"11%%\" class=\"bgblue\" nowrap>Local IP Address:</td>"
                                " <td width=\"89%%\" class=\"bggrey\" nowrap>"
                                "  <input type=\"text\" name=\"ip\" size=15 maxlength=15 value=%s >"
                                "</td>"
                                "</tr>"
                                "<tr>          	"
                                "     <td width=\"11%%\" class=\"bgblue\" nowrap>Gateway IP Address:</td>"
                                "     <td width=\"89%%\" class=\"bggrey\" nowrap>"
                                "  <input type=\"text\" name=\"remoteIp\" size=15 maxlength=15 value=%s >"
                                "       </td>"
                                "</tr>" ),
                             en_napt_checked,
                             ipaddr,
                             remoteaddr );




    nBytesSent += websWrite( wp,
                             T( "<tr>"
                                "   <td width=\"11%%\" class=\"bgblue\" nowrap>Unnumbered</td>"
                                "      <td width=\"89%%\" class=\"bggrey\" nowrap>"
                  //"      <input type=\"checkbox\" name=\"ipUnnum\" size=\"2\" maxlength=\"2\" value=\"ON\"  onClick=\"ipModeSelection()\">"
                  "      <input type=\"checkbox\" name=\"ipUnnum\" size=\"2\" maxlength=\"2\" %s onClick=\"ipModeSelection()\">"
                                "      </td>"
                                "</tr>"
                                "<tr>      	"
                                "  <td width=\"11%%\" class=\"bgblue\" nowrap>Default Route:</td>"
                                "    <td width=\"89%%\" class=\"bggrey\" nowrap>"
                                " <input type=\"radio\" value=\"0\" name=\"droute\" %s >Disable&nbsp;&nbsp;"
                                " <input type=\"radio\" value=\"1\" name=\"droute\" %s >Enable&nbsp;&nbsp;"
                                " </td>"
                                " </tr>" ),
                             en_ipunnumbered_checked,
                             dis_drt_checked,
                             en_drt_checked );

    return nBytesSent;
}


int
atmPPPList3( int eid, webs_t wp, int argc, char_t** argv )
{
    //carpenter
    DEBUG( "\n  atmPPPList3 ---1\n" );
    MIB_CE_ATM_VC_T myEntry;

    char en_drt_checked[10] = "";
    char dis_drt_checked[10] = "";
    char Continuous_select[10] = "";
    char Demand_select[10] = "";
    char Manual_select[10] = "";
    char pppUsername[MAX_PPP_NAME_LEN + 1] = "";
    char pppPassword[MAX_PPP_NAME_LEN] = "";
    char pppIdleTime[10] = "";
    unsigned char vchar;
    vchar = getSelectPVCIndex();
    DEBUG( "\n  atmPPPList3:--2\n" );
    memset( &myEntry, 0, sizeof( MIB_CE_ATM_VC_T ) );
    mib_chain_get( MIB_ATM_VC_TBL, (unsigned int) vchar, ( void * ) &myEntry );

    strncpy( pppUsername, myEntry.pppUsername, MAX_PPP_NAME_LEN );
    strncpy( pppPassword, myEntry.pppPassword, MAX_PPP_NAME_LEN - 1 );
    DEBUG( "\n  atmPPPList3:--3\n" );

    snprintf( pppIdleTime, 9, "%u", myEntry.pppIdleTime );

    DEBUG( "\n  atmPPPList3:--4\n" );
    if ( myEntry.pppCtype == 0 )
    {
        strcpy( Continuous_select, "selected" );
    }
    else if ( myEntry.pppCtype == 1 )
    {
        strcpy( Demand_select, "selected" );
    }
    else if ( myEntry.pppCtype == 2 )
    {
        strcpy( Manual_select, "selected" );
    }
    else
    {
        strcpy( Continuous_select, "selected" );
    }
    DEBUG( "\n  atmPPPList3:--5\n" );
 //   if ( myEntry.dgw == 1 )
//    {
        strcpy( en_drt_checked, " checked" );
 //   }
//    else if ( myEntry.dgw == 0 )
//    {
 //       strcpy( dis_drt_checked, " checked" );
 //   }
 //   else
 //   {
  //      strcpy( en_drt_checked, " checked" );
 //   }

    DEBUG( "\n  atmPPPList3:pppUsername: %s \n", pppUsername );
    DEBUG( "\n  atmPPPList3:pppPassword: %s \n", pppPassword );
    DEBUG( "\n  atmPPPList3:pppIdleTime: %s \n", pppIdleTime );
    DEBUG( "\n  atmPPPList3:pppCtype: %u \n", myEntry.pppCtype );
    DEBUG( "\n  atmPPPList3:dgw: %u \n", myEntry.dgw );


    int nBytesSent = 0;
    nBytesSent += websWrite( wp,
                             T( "<tr>       	"
                                "<td width=\"11%%\" class=\"bgblue\" nowrap>User Name:</td>"
                                " <td width=\"89%%\" class=\"bggrey\" nowrap>"
                                " <input type=\"text\" name=\"pppUserName\" size=16  maxlength=%d value=%s >"
                                "</td>"
                                "</tr>"
                                "<tr> "
                                " <td width=\"11%%\" class=\"bgblue\" nowrap>Password</td>"
                                "  <td width=\"89%%\" class=\"bggrey\" nowrap>"
                                " <input type=\"password\" name=\"pppPassword\" size=16 maxlength=%d value=%s >"
                                "  </td>"
                                "</tr>"
                                " <tr>"
                                "<td width=\"11%%\" class=\"bgblue\" nowrap>Type</td>"
                                "<td width=\"89%%\" class=\"bggrey\" nowrap>"
                                "<select size=1 name=\"pppConnectType\" onChange=\"pppTypeSelection()\">"
                                "<option %s value=\"0\">Continuous</option>"
                                "<option %s value=\"1\">Connect on Demand</option>"
                                "<option %s value=\"2\">Manual</option>"
                                "</select>"
                                "</td>" ),
                             MAX_PPP_NAME_LEN,
                             pppUsername,
                             MAX_NAME_LEN-1,
                             pppPassword,
                             Continuous_select,
                             Demand_select,
                             Manual_select );


    nBytesSent += websWrite( wp,
                             T( "</tr>"
                                "<tr>       	"
                                "<td width=\"11%%\" class=\"bgblue\" nowrap>Idle Time (min):</td>"
                                "<td width=\"89%%\" class=\"bggrey\" nowrap>"
                         //" <input type=\"text\" name=\"pppIdleTime\" size=\"16\" maxlength=\"3\" value=%s >"
                         " <input type=\"text\" name=\"pppIdleTime\" size=\"16\" maxlength=\"3\">"
                                "</td>"
                                "</tr>"
                                "<tr>      	"
                                " <td width=\"11%%\" class=\"bgblue\" nowrap>Default Route:</td>"
                                "   <td width=\"89%%\" class=\"bggrey\" nowrap>"
                                " <input type=radio value=0 name=\"droute\" %s >Disable&nbsp;&nbsp;"
                                " <input type=radio value=1 name=\"droute\" %s >Enable"
                                "   </td>"
                                " </tr>" ),
                                              //pppIdleTime,dis_drt_checked,en_drt_checked
                             dis_drt_checked,
                             en_drt_checked );
    
#ifdef CONFIG_SPPPD_STATICIP
	//lhj, static PPPoE in wan setup web
	char dynamicIpChecked[10]="";
       char staticIpChecked[10]="";
       char strIpAddr[20]="";
       if (myEntry.pppIp == 1)
        {
            strcpy(staticIpChecked, "checked");
            strcpy(strIpAddr, inet_ntoa(*((struct in_addr *)myEntry.ipAddr)));
        }
       else
            strcpy(dynamicIpChecked, "checked");
       if (myEntry.cmode == ADSL_PPPoE)
	    nBytesSent += websWrite(wp,
                            		T("<script>\nfunction clickstatic()\n{\n\tif (document.wiz_pppoe.pppip[0].checked)"
                            		"\n\t\tdocument.wiz_pppoe.staticip.disabled=true;\n\telse\n\t\tdocument.wiz_pppoe.staticip.disabled=false;"
                            		"\n}\n</script>\n"));
       else if (myEntry.cmode == ADSL_PPPoA)
	    nBytesSent += websWrite(wp,
                            		T("<script>\nfunction clickstatic()\n{\n\tif (document.wiz_pppoa.pppip[0].checked)"
                            		"\n\t\tdocument.wiz_pppoa.staticip.disabled=true;\n\telse\n\t\tdocument.wiz_pppoa.staticip.disabled=false;"
                            		"\n}\n</script>\n"));
	nBytesSent += websWrite(wp,
                        		T("<tr>\n"
                        		"<td width=\"11%%\" class=\"bgblue\" nowrap>Type:</td>\n"
                        		"<td width=\"89%%\" class=\"bggrey\" nowrap>"
                        		"<input type=radio value=\"0\" name=\"pppip\" %s onClick=clickstatic()>%s&nbsp;&nbsp;\n"
                        		"<input type=radio value=\"1\" name=\"pppip\" %s onClick=clickstatic()>%s&nbsp;&nbsp;</td></tr>\n"),
                        		 dynamicIpChecked, Tdynamic_ip, staticIpChecked, Tstatic_ip);
	nBytesSent += websWrite(wp,
                        		T("<tr>\n"
                        		"<td width=\"11%%\" class=\"bgblue\" nowrap>IP Address:</td>\n"
                        		"<td width=\"89%%\" class=\"bggrey\" nowrap>"
                        		"<input type=text name=staticip size=10 maxlength=15 value=%s></td></tr>\n"),
                        		strIpAddr);
#endif

    return nBytesSent;
}

extern void formWizDNS(webs_t wp, char_t *path, char_t *query)
{
    formDns(wp, path, query);
    WizReboot( 0, wp, 0, NULL );
    return;
}

int isDuplicate(struct in_addr *ipAddr, const char *device);

/*uderside 3 fun from hanjin*/
void formWizLast(webs_t wp, char_t *path, char_t *query)
{    
    char *strValue;
    char strWanState[64];
    struct in_addr inAddr;
    MIB_CE_ATM_VC_T myEntry;
    int arp_ping = 1;
    unsigned char vchar;
    vchar = getSelectPVCIndex();
	
    mib_chain_get(MIB_ATM_VC_TBL, (unsigned int) vchar, (void *)&myEntry);
    strValue = websGetVar(wp, T("todo"), T(""));
    if (strncmp(strValue, "wan_test", 8) == 0)
    {
        memset(strWanState, 0, sizeof(strWanState));
        getAdslDrvInfo("state", strWanState, 64);
		
        FILE *fp;
        char line[256] = ""; 
        fp = fopen("/var/testConnection_result","w");
        if (strncmp(strWanState, "SHOWTIME", 8) == 0)
        {
			int is_up;
			char ifname[IFNAMSIZ] = "";
			strcpy(line, "Connecting Test ....\nADSL connection OK\n");
			is_up = if_wan_up2(ifname, 5);
			DEBUG("\n---%s---\n", ifname);
			if(myEntry.cmode == 1 && myEntry.ipDhcp == ( char ) DHCP_DISABLED){
				arp_ping = isDuplicate(( struct in_addr * ) myEntry.remoteIpAddr  , ifname);
	              }
			if (is_up == 1 && arp_ping == 1)
			{
//				strcat(line, ifname);
				strcat(line, "Internet connection OK");
			}
			else
			{
//				strcat(line, ifname);
				strcat(line, "Internet connection failed");
			}
        }
        else
        {
            strcpy(line, "Connecting Test ....\nADSL connection failed;\nInternet connection faild;\nPlease check connections and settings;");
        }
        fwrite(line, 1, strlen(line), fp);
        fclose(fp);
        websRedirect(wp, "/wiz_last.asp");
    }
    else if (strncmp(strValue, "page_back", 9) == 0)
    {	

	if(myEntry.cmode == 0)
            websRedirect(wp, "/wiz_chamode.asp");
	else if(myEntry.cmode == 1)
            websRedirect(wp, "/wiz_MERMode.asp");
        else if(myEntry.cmode == 2)
            websRedirect(wp, "/wiz_PPPoE.asp");
        else if(myEntry.cmode == 3)
            websRedirect(wp, "/wiz_PPPoA.asp");
        else if(myEntry.cmode == 4)
            websRedirect(wp, "/wiz_routeMode.asp");
        else
            websRedirect(wp, "/wiz_last.asp");
    }
    else
    {
        websRedirect(wp, "/wiz_last.asp");
    }
    return;
}

int display_testConnection_result(int eid, webs_t wp, int argc, char_t **argv)
{
	int nBytesSent =0;

        FILE *fp;
        char line[256] = ""; 
	fp = fopen("/var/testConnection_result","r");
	if(fp == (FILE*)0)
		return 0;
	int max_line = 256;
	for(max_line =256;max_line > 0 ;max_line--)
		{
			if(fgets(line,sizeof(line),fp) != NULL)
			{
				nBytesSent += websWrite(wp, T("%s"),line);
			}
			else break;
		}
	fclose(fp);	
	system("rm /var/testConnection_result");
	return nBytesSent;
}


void formDeviceMode(webs_t wp, char_t *path, char_t *query)
{
    unsigned char device_mode_current;
    char_t *device_mode;
    unsigned char vchar;
    if (!mib_get(MIB_DEVICE_MODE, (void *)&vchar))
        return;
    device_mode = websGetVar(wp, T("select_mode"), T(""));
    device_mode_current = device_mode[0];
    DEBUG("\nformDeviceMode--device_mode_current:%c\n",device_mode_current);
    DEBUG("\nformDeviceMode--device_mode_current:%d\n",device_mode_current);
    if (device_mode_current != vchar){
        mib_set(MIB_DEVICE_MODE, (void *)&device_mode_current);
        websHeader(wp); 
        websWrite(wp, T("<head><link rel=\"stylesheet\" href=\"/admin/style.css\" type=\"text/css\">\n"));
        websWrite(wp, T("<style type=\"text/javascript\"> classes.num.all.fontFamily = \"Courier\"; classes.num.all.fontSize = \"10pt\";</style>\n"));
        websWrite(wp, T("<script>function clickOK(){location.replace(\"/status.asp\");parent.location.reload(true);return true;}</script></head>\n"));
        websWrite(wp, T("<BODY bgcolor=\"#4b688b\" body bgcolor=\"#4b688b\" style=\"padding: 0px 10px 0px 10px\">\n"));
        websWrite(wp, T("<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"tabBigTitle\"><tr><td align=\"center\" valign=\"top\">\n"));
        websWrite(wp, T("<table width=98%% border=0 align=\"center\" cellpadding=3 cellspacing=1><br><tr align=\"center\"><td><font color=\"#FFFFFF\">\n"));
        websWrite(wp, T("<h4>Change setting successfully!<br> You should Reboot for save setting changes!</h4></font></td></tr></table>\n"));
        websWrite(wp, T("<br><form><input type=button value=\"  OK  \" OnClick=\"return clickOK()\" class=\"ButtonSmall\">&nbsp;&nbsp;</form>\n"));
        websWrite(wp, T("</td></tr></table></body>\n"));
        websFooter(wp); 
        websDone(wp, 200); 
    }
    else
        websRedirect(wp, "/mode.asp");
    DEBUG("\nformDeviceMode--end\n");
    return 0;
}

//liujuan for br
int
atmVcBridge( int eid, webs_t wp, int argc, char_t** argv )
{
    //carpenter

    DEBUG( "\n  atmVcList3 ---1\n" );
    int nBytesSent = 0;

    unsigned int totalEntry, i;
    MIB_CE_ATM_VC_T Entry;


    char vpi[6], vci[6], * aal5Encap;
    totalEntry = mib_chain_total( MIB_ATM_VC_TBL );

    int flags;
    DEBUG( "\n  atmVcList3 ---2\n" );
    char vc_checked[10] = "";
    char llc_checked[10] = "checked";
    unsigned char vchar;
    vchar = getSelectPVCIndex();

    
    if (totalEntry == 0)
    {
        memset( &Entry, 0x00, sizeof( Entry ) );
        Entry.vpi = 5;
        Entry.vci = 35;
        Entry.encap = 1;
        mib_chain_add(MIB_ATM_VC_TBL, (unsigned char*)&Entry);
     }
    
        if ( !mib_chain_get( MIB_ATM_VC_TBL, (unsigned int) vchar, ( void * ) &Entry ) )
        {
            websError( wp, 400, T( "Get chain record error!\n" ) );
            return -1;
        }
        snprintf( vpi, 6, "%u", Entry.vpi );
        snprintf( vci, 6, "%u", Entry.vci );

        aal5Encap = 0;

        if ( Entry.encap == 0 )
        {
            strcpy( vc_checked, "checked" );
            strcpy( llc_checked, "" );
        }
        DEBUG( "\n  atmVcList3 ---3\n" );
        DEBUG( "\n  atmVcList3:%s %s %s %s \n",
               vpi,
               vci,
               llc_checked,
               vc_checked );
        nBytesSent += websWrite( wp,
                                 T( "\n<tr>\n"
                                    " <td width=\"30%%\" nowrap class=\"bgblue\">VPI: </td>\n"
                                    " <td width=\"70%%\" class=\"bggrey\">\n"
                                    "<input type=\"text\" name=\"vpi\" size=\"4\" maxlength=\"3\" value=%s>\n"
                                    "  </td>\n"
                                    " </tr>\n"
                                    "<tr>\n"
                                    "<td class=\"bgblue\">&nbsp;&nbsp;VCI:</td>\n"
                                    "	<td class=\"bggrey\">\n"
                                    "<input type=\"text\" name=\"vci\" size=\"6\" maxlength=\"5\" value=%s>\n"
                                    "	</td>\n"
                                    " </tr>\n"
                                    " <tr>\n"
                                    "		<td class=\"bgblue\">Encapsulation: </td>\n"
                                    "		<td class=\"bggrey\">\n"
                                    "	<input type=\"radio\" value=\"1\" name=\"adslEncap\"  %s >LLC &nbsp;&nbsp;\n"
                                    "			<input type=\"radio\" value=\"0\" name=\"adslEncap\" %s>VC-Mux</td>\n"
                                    "</tr>\n" ),
                                 vpi,
                                 vci,
                                 llc_checked,
                                 vc_checked );
        DEBUG( "\n  atmVcList3 ---4\n" );

        return nBytesSent;
}

void formWizBr( webs_t wp, char_t* path, char_t* query )
{
    MIB_CE_ATM_VC_T Entry;
    unsigned char vchar;
    vchar = getSelectPVCIndex();
    
    if ( retrieveVcRecordAdsl( wp, &Entry ) != 0 )
    {
        //carpenter:restartWAN();
        websError( wp, 400, T( "Get chain record error!\n" ) );
        return -1;
        //return;
    }
    
    Entry.cmode = ADSL_MER1483;
    Entry.enable = 1;
    Entry.napt = 1;
    Entry.ipDhcp = DHCP_CLIENT;
    Entry.dgw = 1;
    mib_chain_update( MIB_ATM_VC_TBL, ( void * ) &Entry, (unsigned int) vchar );

    WizReboot( 0, wp, 0, NULL );
    return;
}
void formWizFinish( webs_t wp, char_t* path, char_t* query )
{	
	websRedirect( wp, "/index.html" );
	return;
}

//void formWizReboot(webs_t wp, char_t *path, char_t *query)
int WizReboot( int eid, webs_t wp, int argc, char_t** argv )
{
   //check if is router or br mode, then give different finish page
  unsigned char deviceMode;
char finishpage[20]="wiz_last.asp";
 mib_get(MIB_DEVICE_MODE, (void *)&deviceMode);
  if (deviceMode == '0')
strcpy(finishpage,"wiz_finish.asp");
  
DEBUG("\n WizReboot :finishpage:%s\n",finishpage);
  
    //carpenter
    DEBUG( "\n  WizReboot : reboot\n" );
    websHeader( wp );
    websWrite( wp,
               T( "<head><link rel=\"stylesheet\" href=\"/style.css\" type=\"text/css\">\n"\
    "<script language=javascript>\n" \
    "var h=60;\n" \
    "function stop() { clearTimeout(id); }\n"\
    "function start() { h--; if (h >= 0) { frm.time.value = h.toString() + ' seconds.'; id=setTimeout(\"start()\",1000); }\n" \
    "if (h == 0) { location.replace(\"/%s\"); }}\n"
    "</script></head>\n" ),finishpage );
    websWrite( wp,
               T("<body onLoad=\"start();\" onUnload=\"stop();\">\n" \
    "<form name=frm>\n" \
    "<table border=\"0\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\">\n" \
  	"<tr>\n" \
    	"<td width=\"26\"><img src=\"/graphics/wiz_19.gif\" width=\"26\" height=\"49\"></td>\n" \
    	"<td width=\"527\" background=\"/graphics/wiz_30.gif\"><img src=\"/graphics/wiz_20.gif\" width=\"139\" height=\"49\"></td>\n" \
    	"<td width=\"27\"><img src=\"/graphics/wiz_4.gif\" width=\"27\" height=\"49\"></td>\n" \
  	"</tr>\n" \
  	"<tr>\n" \
    	"<td valign=\"top\" background=\"/graphics/wiz_6.gif\">\n" \
      	"<img src=\"/graphics/wiz_5.gif\" width=\"26\" height=\"20\">\n" \
    	"</td>\n" \
    	"<td background=\"/graphics/wiz_7.gif\">\n" ));
    websWrite( wp,
               T( " <table width=\"100%%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\"> \n" \
 				"<tr>\n" \
            "<td width=\"100%%\" height=\"300\" valign=\"top\" nowrap>\n" \
            "<table width=\"100%%\" border=\"0\" cellpadding=\"3\" cellspacing=\"1\" bgcolor=\"#4b688b\">\n" \
   		"<tr>\n" \
                "<td class=\"headerbg2\">Configuring</td>\n" \
              "</tr>\n" \
              "<tr>\n" \
                "<td height=\"230\" align=\"center\" valign=\"top\"><br>\n" \
                  "<table width=\"500\" border=\"0\" cellpadding=\"3\" cellspacing=\"1\"  bgcolor=\"#FFFFFF\">\n" \
                  	"<tr>\n" \
     				"<td>The DSL Router has been configured. System is rebooting. Please wait\n" \
				"<INPUT TYPE=text NAME=time size=20 bgcolor=\"#FFFFFF\" style=\"background-color:transparent;border:0;font-family:Arial, Helvetica, sans-serif;\"></td>\n" \
			"</tr>\n" \
                "</table>\n" \
               "</td>\n" \
         	"</tr>\n" \
        "</table> \n" \             
        "</td>\n" \
      "</tr>\n" \
    "</table>\n" ) );
    websWrite( wp, 
		T( "</td>\n" \
    	"<td background=\"/graphics/wiz_8.gif\">&nbsp;</td>\n" \
    "</tr>\n" \
    "<tr>\n" \
    	"<td><img src=\"/graphics/wiz_9.gif\" width=\"26\" height=\"21\"></td>\n" \
    	"<td background=\"/graphics/wiz_10.gif\">&nbsp;</td>\n" \
    	"<td><img src=\"/graphics/wiz_11.gif\" width=\"27\" height=\"21\"></td>\n" \
    "</tr>\n" \
  "</table>\n" \
 "</form></body>\n" ) );
    websFooter( wp );
    websDone( wp, 200 );
    //flash done
    DEBUG( "\n  WizReboot : flash done\n" );
    mib_update( CURRENT_SETTING, CONFIG_MIB_ALL );
    va_cmd( "/sbin/reboot", 0, 0 );
    //sem_post(&semSave);
    return 0;
}

//this asp fun not used currently
//mcj: we use this asp fun to set dut mode
int set_436_mode(int eid, webs_t wp, int argc, char_t **argv)
{
//carpenter
/*
DEBUG("\nset_436_mode--sleep>\n");
sleep(2);
DEBUG("\nset_436_mode--sleep<\n");
*/

/*
	char_t *name;

   	if (ejArgs(argc, argv, T("%s"), &name) < 1) {
   		websError(wp, 400, T("Insufficient args\n"));
   		return -1;
   	}
    unsigned char device_mode_current;
    device_mode_current = '1';


	if ( !strcmp(name, T("router")) )
		{    device_mode_current = '1';}
	else if
       ( !strcmp(name, T("bridge")) )
		{    device_mode_current = '0';}
	
	DEBUG("\nset_436_mode:%c\n",device_mode_current);
	DEBUG("\nset_436_mode:%d\n",device_mode_current);
	
	DEBUG("\nset_436_mode--name:%s\n",name);
	mib_set(MIB_DEVICE_MODE, (void *)&device_mode_current);
*/
	return 0;
}


//mcj: we use this asp fun to check the router/bridge mode page
int load_wizard_page(int eid, webs_t wp, int argc, char_t **argv)
{
//carpenter
unsigned char isRootMenuEnd = 0;
int nBytesSent = 0;
  //calc the id nums and the max children size
  //add by lhj
  unsigned char deviceMode;
 mib_get(MIB_DEVICE_MODE, (void *)&deviceMode);
//mcj
	DEBUG("\nload_wizard_page:%c\n",deviceMode);
	DEBUG("\nload_wizard_page:%d\n",deviceMode);
	
  if (deviceMode == '0')
     nBytesSent += websWrite( wp,T("location.replace(\"wiz_br.asp\");"));
  
	return nBytesSent;
}

