#include "port_trigger.h"
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <sys/wait.h>

#include "../webs.h"
#include "webform.h"
#include "mib.h"
#include "utility.h"
#include "debug.h"
#ifdef NEW_PORT_TRIGGER  //add by machuanjun
void setup_port_trigger(int if_first_time)//execute trigger command
{
/*iptables sample for setting trigger
iptables -N portTrigger
//iptables -A FORWARD -j portTrigger
iptables -t filter -A FORWARD -o br0 -j TRIGGER --trigger-type in
iptables -t nat -A PREROUTING -i ! br0 -j TRIGGER --trigger-type dnat
iptables -t filter -A portTrigger -o ! br0 -p tcp --dport 8887 -j TRIGGER --trigger-type out --trigger-proto tcp --trigger-match 8887 --trigger-relate 8888
iptables -t filter -A portTrigger -o ! br0 -p tcp --dport 8885 -j TRIGGER --trigger-type out --trigger-proto tcp --trigger-match 8885 --trigger-relate 8886
*/
unsigned char vChar;
if(if_first_time)//do only one time when system start
{
	va_cmd("/bin/iptables", 2, 1, "-N", "portTrigger");//new trigger chain
	//va_cmd("/bin/iptables", 4, 1, "-A", "FORWARD","-j","portTrigger");//mount to forward chain
}
if ( !mib_get( MIB_PORT_TRIGGER_ENABLE, (void *)&vChar) )
	return -1;
if (1 == vChar)//if trigger is enbale
{
	va_cmd("/bin/iptables", 2, 1, "-F", "portTrigger");//clear old rule
	va_cmd("/bin/iptables", 10, 1, "-t","filter","-D","FORWARD","-o","br0","-j","TRIGGER","--trigger-type","in");//refresh trigger timeout
	va_cmd("/bin/iptables", 11, 1,"-t","nat","-D","PREROUTING","-i","!","br0","-j","TRIGGER","--trigger-type","dnat");//create dnat rule
	va_cmd("/bin/iptables", 10, 1, "-t","filter","-A","FORWARD","-o","br0","-j","TRIGGER","--trigger-type","in");//refresh trigger timeout
	va_cmd("/bin/iptables", 11, 1,"-t","nat","-A","PREROUTING","-i","!","br0","-j","TRIGGER","--trigger-type","dnat");//create dnat rule
NEW_MIB_CE_PORT_TRG_T entry;
	unsigned int entryNum=0, i;

		entryNum =  mib_chain_total(NEW_MIB_PORT_TRG_TBL);
		for(i = 0;i < entryNum;i++)//create html table
			{
				if (!mib_chain_get(NEW_MIB_PORT_TRG_TBL, i, (void *)&entry))
				{
  					TRACE(STA_ERR,"setup_Get chain record error!:%d\n",i);
					return;
				}
					char_t str_match_port[13];
					char_t str_related_port[13];
					char_t str_match_port_dport[13];
					char_t str_related_port_dport[13];
					char_t tmp_m_b[6];
					char_t tmp_m_e[6];
					char_t tmp_r_b[6];
					char_t tmp_r_e[6];

					memset(str_match_port, 0, 13);
					memset(str_related_port, 0, 13);
					memset(str_match_port_dport, 0, 13);
					memset(str_related_port_dport, 0, 13);
					memset(tmp_m_b, 0, 6);
					memset(tmp_m_e, 0, 6);
					memset(tmp_r_b, 0, 6);
					memset(tmp_r_e, 0, 6);

					strncpy(tmp_m_b,entry.m_match_port_begin,5);
					strncpy(tmp_m_e,entry.m_match_port_end,5);
					strncpy(tmp_r_b,entry.m_related_port_begin,5);
					strncpy(tmp_r_e,entry.m_related_port_end,5);
					strncat(strncat(strncat(str_match_port,tmp_m_b,5),"-",1),tmp_m_e,5);
					strncat(strncat(strncat(str_related_port,tmp_r_b,5),"-",1),tmp_r_e,5);
					
					char_t tmp_m_b2[6];
					char_t tmp_m_e2[6];
					char_t tmp_r_b2[6];
					char_t tmp_r_e2[6];
					memset(tmp_m_b2, 0, 6);
					memset(tmp_m_e2, 0, 6);
					memset(tmp_r_b2, 0, 6);
					memset(tmp_r_e2, 0, 6);
					strncpy(tmp_m_b2,entry.m_match_port_begin,5);
					strncpy(tmp_m_e2,entry.m_match_port_end,5);
					strncpy(tmp_r_b2,entry.m_related_port_begin,5);
					strncpy(tmp_r_e2,entry.m_related_port_end,5);
					strncat(strncat(strncat(str_match_port_dport,tmp_m_b2,5),":",1),tmp_m_e2,5);
					strncat(strncat(strncat(str_related_port_dport,tmp_r_b2,5),":",1),tmp_r_e2,5);
					
					char_t str_related_protocol[4]="all";
					if(entry.m_realted_protocol == '0')
						strncpy(str_related_protocol,"all",4);
					else if(entry.m_realted_protocol == '1')
						strncpy(str_related_protocol,"tcp",4);
					else if(entry.m_realted_protocol == '2')
						strncpy(str_related_protocol,"udp",4);
					
					if(entry.enable == '1')//if enable 
						{
							if(entry.m_match_protocol == '0')//match port : tcp & udp
								{
								va_cmd("/bin/iptables", 21, 1,"-t","filter","-A","portTrigger","-o","!","br0","-p","tcp","--dport",str_match_port_dport,"-j","TRIGGER","--trigger-type","out","--trigger-proto",str_related_protocol,"--trigger-match",str_match_port,"--trigger-relate",str_related_port);
								va_cmd("/bin/iptables", 21, 1,"-t","filter","-A","portTrigger","-o","!","br0","-p","udp","--dport",str_match_port_dport,"-j","TRIGGER","--trigger-type","out","--trigger-proto",str_related_protocol,"--trigger-match",str_match_port,"--trigger-relate",str_related_port);
								
							}
							else if(entry.m_match_protocol == '1')//match port : tcp 
								{
								va_cmd("/bin/iptables", 21, 1,"-t","filter","-A","portTrigger","-o","!","br0","-p","tcp","--dport",str_match_port_dport,"-j","TRIGGER","--trigger-type","out","--trigger-proto",str_related_protocol,"--trigger-match",str_match_port,"--trigger-relate",str_related_port);
								}
							else if(entry.m_match_protocol == '2')//match port : udp
								{
								va_cmd("/bin/iptables", 21, 1,"-t","filter","-A","portTrigger","-o","!","br0","-p","udp","--dport",str_match_port_dport,"-j","TRIGGER","--trigger-type","out","--trigger-proto",str_related_protocol,"--trigger-match",str_match_port,"--trigger-relate",str_related_port);
								}
						}

					
			}
}
else//clean netfilter when trigger is disable
{
		va_cmd("/bin/iptables", 2, 1, "-F", "portTrigger");//clear old rule
		va_cmd("/bin/iptables", 10, 1, "-t","filter","-D","FORWARD","-o","br0","-j","TRIGGER","--trigger-type","in");
		va_cmd("/bin/iptables", 11, 1,"-t","nat","-D","PREROUTING","-i","!","br0","-j","TRIGGER","--trigger-type","dnat");
}
}
#endif
#if 0
char *trigger_get_wan_interface()//get current wan interface,defalut vc0
{

	unsigned int entryNum, i;
	MIB_CE_ATM_VC_T Entry;
	char wanif[6]="vc0";
	TRACE(STA_ERR,"trigger_get_wan_interface");
	entryNum = mib_chain_total(MIB_ATM_VC_TBL);			
	for (i = 0; i < entryNum; i++) 
	{				
			if (!mib_chain_get(MIB_ATM_VC_TBL, i, (void *)&Entry))
				{
				TRACE(STA_ERR,"restartAddressMap: cannot get ATM_VC_TBL(ch=%d) entry\n", i);
				return 0;
				}
		TRACE(STA_ERR,"\nwan_interface,enable:%d,index:%s\n",Entry.enable,VC_INDEX(Entry.ifIndex));
		//if (Entry.enable == 1)
		//	{
			//	snprintf(wanif, 6, "vc%u", VC_INDEX(Entry.ifIndex));
			//	TRACE("\nwan_interface:%s\n",wanif);
			//}
			/*continue;
		 if ( action == ACT_START) 
		 	{
				if ( !Entry->enable || ((DHCP_T)Entry->ipDhcp != DHCP_DISABLED)
				|| ((REMOTE_ACCESS_T)Entry->cmode == ACC_BRIDGED)    
				|| ((REMOTE_ACCESS_T)Entry->cmode == ACC_PPPOE)
				|| ((REMOTE_ACCESS_T)Entry->cmode == ACC_PPPOA)
				|| (!Entry->napt)
				)
				return wanif;
				TRACE("\nwan_interface:%s\n",wanif);
				snprintf(wanif, 6, "vc%u", VC_INDEX(pEntry->ifIndex));
			}*/
	}
return wanif;
	
}
#endif

