
/*
 *      MIB table declaration
 *      Authors: David Hsu	<davidhsu@realtek.com.tw>
 *      Authors: Dick Tam	<dicktam@realtek.com.tw>
 *
 */

/* Include files */
#include "mibtbl.h"
#ifdef EMBED
#include <linux/config.h>
#include <config/autoconf.h>
#else
#include "../../../../uClibc/include/linux/autoconf.h"
#include "../../../../config/autoconf.h"
#endif

/* Global variable definitions */
mib_table_entry_T mib_table[]={

//MIB_TBL_ENTRY(MIB_CS_VERSION,			CURRENT_SETTING,	"CS_VER", 		BYTE_T,		_OFFSET(version), 		_SIZE(version),			"1"),
MIB_TBL_ENTRY(MIB_ADSL_LAN_IP,			CURRENT_SETTING,	"LAN_IP_ADDR", 		IA_T,		_OFFSET(ipAddr), 		_SIZE(ipAddr),			"192.168.10.1"),
MIB_TBL_ENTRY(MIB_ADSL_LAN_SUBNET,		CURRENT_SETTING,	"LAN_SUBNET", 		IA_T,		_OFFSET(subnetMask), 		_SIZE(subnetMask),		"255.255.255.0"),
#ifdef TELEFONICA_DEFAULT_CFG
MIB_TBL_ENTRY(MIB_ADSL_LAN_ENABLE_IP2,		CURRENT_SETTING,	"LAN_ENABLE_IP2",	BYTE_T,		_OFFSET(enable_ip2), 		_SIZE(enable_ip2),		"1"),
MIB_TBL_ENTRY(MIB_ADSL_LAN_IP2,			CURRENT_SETTING,	"LAN_IP_ADDR2", 	IA_T,		_OFFSET(ipAddr2), 		_SIZE(ipAddr2),			"192.168.249.1"),
MIB_TBL_ENTRY(MIB_ADSL_LAN_SUBNET2,		CURRENT_SETTING,	"LAN_SUBNET2", 		IA_T,		_OFFSET(subnetMask2), 		_SIZE(subnetMask2),		"255.255.255.252"),
#else
MIB_TBL_ENTRY(MIB_ADSL_LAN_ENABLE_IP2,		CURRENT_SETTING,	"LAN_ENABLE_IP2",	BYTE_T,		_OFFSET(enable_ip2), 		_SIZE(enable_ip2),		"0"),
MIB_TBL_ENTRY(MIB_ADSL_LAN_IP2,			CURRENT_SETTING,	"LAN_IP_ADDR2", 	IA_T,		_OFFSET(ipAddr2), 		_SIZE(ipAddr2),			"192.168.100.1"),
MIB_TBL_ENTRY(MIB_ADSL_LAN_SUBNET2,		CURRENT_SETTING,	"LAN_SUBNET2", 		IA_T,		_OFFSET(subnetMask2), 		_SIZE(subnetMask2),		"255.255.255.0"),
#endif
MIB_TBL_ENTRY(MIB_ADSL_LAN_DHCP,		CURRENT_SETTING,	"LAN_DHCP",		BYTE_T,		_OFFSET(dhcp), 			_SIZE(dhcp),			"0"),
MIB_TBL_ENTRY(MIB_ADSL_LAN_DHCP_POOLUSE,	CURRENT_SETTING,	"LAN_DHCP_POOLUSE",	BYTE_T,		_OFFSET(dhcp_pooluse), 		_SIZE(dhcp_pooluse),		"0"),
#ifdef TELEFONICA_DEFAULT_CFG
MIB_TBL_ENTRY(MIB_ADSL_LAN_CLIENT_START,	CURRENT_SETTING,	"LAN_DHCP_START", 	BYTE_T, 	_OFFSET(dhcpClientStart), 	_SIZE(dhcpClientStart),		"33"),
MIB_TBL_ENTRY(MIB_ADSL_LAN_CLIENT_END,		CURRENT_SETTING,	"LAN_DHCP_END", 	BYTE_T,		_OFFSET(dhcpClientEnd), 	_SIZE(dhcpClientEnd),		"254"),
MIB_TBL_ENTRY(MIB_DHCP_POOL_START,		CURRENT_SETTING,	"LAN_DHCP_POOL_START", 	IA_T,		_OFFSET(ipDhcpStart), 		_SIZE(ipDhcpStart),			"192.168.1.33"),
MIB_TBL_ENTRY(MIB_DHCP_POOL_END,		CURRENT_SETTING,	"LAN_DHCP_POOL_END", 	IA_T,		_OFFSET(ipDhcpEnd), 		_SIZE(ipDhcpEnd),			"192.168.1.254"),
#else
MIB_TBL_ENTRY(MIB_ADSL_LAN_CLIENT_START,	CURRENT_SETTING,	"LAN_DHCP_START", 	BYTE_T, 	_OFFSET(dhcpClientStart), 	_SIZE(dhcpClientStart),		"2"),
MIB_TBL_ENTRY(MIB_ADSL_LAN_CLIENT_END,		CURRENT_SETTING,	"LAN_DHCP_END", 	BYTE_T,		_OFFSET(dhcpClientEnd), 	_SIZE(dhcpClientEnd),		"100"),
MIB_TBL_ENTRY(MIB_DHCP_POOL_START,		CURRENT_SETTING,	"LAN_DHCP_POOL_START", 	IA_T,		_OFFSET(ipDhcpStart), 		_SIZE(ipDhcpStart),			"192.168.10.2"),
MIB_TBL_ENTRY(MIB_DHCP_POOL_END,		CURRENT_SETTING,	"LAN_DHCP_POOL_END", 	IA_T,		_OFFSET(ipDhcpEnd), 		_SIZE(ipDhcpEnd),			"192.168.10.100"),
#endif
MIB_TBL_ENTRY(MIB_DHCP_DNS_OPTION,		CURRENT_SETTING,	"LAN_DHCP_DNS_OPT",	BYTE_T,		_OFFSET(dhcps_dns_opt), 	_SIZE(dhcps_dns_opt),		"0"),
MIB_TBL_ENTRY(MIB_DHCPS_DNS1,			CURRENT_SETTING,	"DHCPS_DNS1",		IA_T,		_OFFSET(dhcps_dns1), 		_SIZE(dhcps_dns1),		"0"),
MIB_TBL_ENTRY(MIB_DHCPS_DNS2,			CURRENT_SETTING,	"DHCPS_DNS2", 		IA_T, 		_OFFSET(dhcps_dns2), 		_SIZE(dhcps_dns2),		"0"),
MIB_TBL_ENTRY(MIB_DHCPS_DNS3,			CURRENT_SETTING,	"DHCPS_DNS3", 		IA_T,		_OFFSET(dhcps_dns3), 		_SIZE(dhcps_dns3),		"0"),
MIB_TBL_ENTRY(MIB_ADSL_LAN_DHCP_LEASE,		CURRENT_SETTING,	"LAN_DHCP_LEASE",	INTEGER_T,	_OFFSET(dhcpLTime), 		_SIZE(dhcpLTime),		"86400"),
MIB_TBL_ENTRY(MIB_ADSL_LAN_DHCP_DOMAIN,		CURRENT_SETTING,	"LAN_DHCP_DOMAIN",	STRING_T,	_OFFSET(dhcpDomain), 		_SIZE(dhcpDomain),		"domain.name"),
MIB_TBL_ENTRY(MIB_ADSL_LAN_RIP,			CURRENT_SETTING,	"LAN_RIP",		BYTE_T,		_OFFSET(rip), 			_SIZE(rip),			"0"),
MIB_TBL_ENTRY(MIB_ADSL_LAN_AUTOSEARCH,		CURRENT_SETTING,	"LAN_AUTOSEARCH",	BYTE_T,		_OFFSET(lanAutoSearch), 	_SIZE(lanAutoSearch),		"0"),

#ifdef DEFAULT_GATEWAY_V2
MIB_TBL_ENTRY(MIB_ADSL_WAN_DGW_IP,			CURRENT_SETTING,	"DGW_IP",		IA_T,		_OFFSET(defaultGateway), 		_SIZE(defaultGateway),			0),
#ifdef AUTO_PPPOE_ROUTE
MIB_TBL_ENTRY(MIB_ADSL_WAN_DGW_ITF,			CURRENT_SETTING,	"DGW_ITF",		BYTE_T,		_OFFSET(dgwItf), 		_SIZE(dgwItf),			"239"),
#else
MIB_TBL_ENTRY(MIB_ADSL_WAN_DGW_ITF,			CURRENT_SETTING,	"DGW_ITF",		BYTE_T,		_OFFSET(dgwItf), 		_SIZE(dgwItf),			"255"),
#endif
#endif
#ifdef TELEFONICA_DEFAULT_CFG
MIB_TBL_ENTRY(MIB_ADSL_WAN_DNS_MODE,		CURRENT_SETTING,	"DNS_MODE",		BYTE_T,		_OFFSET(dnsMode), 		_SIZE(dnsMode),			"1"),
MIB_TBL_ENTRY(MIB_ADSL_WAN_DNS1,		CURRENT_SETTING,	"DNS1",			IA_T,		_OFFSET(dns1), 			_SIZE(dns1),			"80.58.61.250"),
MIB_TBL_ENTRY(MIB_ADSL_WAN_DNS2,		CURRENT_SETTING,	"DNS2", 		IA_T, 		_OFFSET(dns2), 			_SIZE(dns2),			"80.58.61.254"),
#else
MIB_TBL_ENTRY(MIB_ADSL_WAN_DNS_MODE,		CURRENT_SETTING,	"DNS_MODE",		BYTE_T,		_OFFSET(dnsMode), 		_SIZE(dnsMode),			"0"),
MIB_TBL_ENTRY(MIB_ADSL_WAN_DNS1,		CURRENT_SETTING,	"DNS1",			IA_T,		_OFFSET(dns1), 			_SIZE(dns1),			"0"),
MIB_TBL_ENTRY(MIB_ADSL_WAN_DNS2,		CURRENT_SETTING,	"DNS2", 		IA_T, 		_OFFSET(dns2), 			_SIZE(dns2),			"0"),
#endif
MIB_TBL_ENTRY(MIB_ADSL_WAN_DNS3,		CURRENT_SETTING,	"DNS3", 		IA_T,		_OFFSET(dns3), 			_SIZE(dns3),			"0"),

MIB_TBL_ENTRY(MIB_ADSL_WAN_DHCPS,		CURRENT_SETTING,	"DHCPS",		IA_T,		_OFFSET(dhcps), 		_SIZE(dhcps),			"172.19.31.4"),
#if defined(ZTE_531B_BRIDGE_SC)||defined(ZTE_GENERAL_ROUTER_SC)
MIB_TBL_ENTRY(MIB_DHCP_MODE,			CURRENT_SETTING,	"DHCP_MODE",		BYTE_T,		_OFFSET(dhcpMode),		_SIZE(dhcpMode),		"0"),
#else
MIB_TBL_ENTRY(MIB_DHCP_MODE,			CURRENT_SETTING,	"DHCP_MODE",		BYTE_T,		_OFFSET(dhcpMode),		_SIZE(dhcpMode),		"2"),
#endif
#ifdef TELEFONICA_DEFAULT_CFG
MIB_TBL_ENTRY(MIB_ADSL_MODE,			CURRENT_SETTING,	"ADSL_MODE",		WORD_T,		_OFFSET(adslMode), 		_SIZE(adslMode),		"65"),
#else
#if defined(ZTE_531B_BRIDGE_SC)||defined(ZTE_GENERAL_ROUTER_SC) || defined(CONFIG_GUI_WEB)
MIB_TBL_ENTRY(MIB_ADSL_MODE,			CURRENT_SETTING,	"ADSL_MODE",		WORD_T,		_OFFSET(adslMode), 		_SIZE(adslMode),		"115"),
#else
MIB_TBL_ENTRY(MIB_ADSL_MODE,			CURRENT_SETTING,	"ADSL_MODE",		WORD_T,		_OFFSET(adslMode), 		_SIZE(adslMode),		"83"),
#endif
#endif
MIB_TBL_ENTRY(MIB_ADSL_OLR,			CURRENT_SETTING,	"ADSL_OLR",		BYTE_T,		_OFFSET(adslOlr), 		_SIZE(adslOlr),			"3"),
#ifdef CONFIG_USER_ROUTED_ROUTED
MIB_TBL_ENTRY(MIB_RIP_ENABLE,			CURRENT_SETTING,	"RIP_ENABLE",		BYTE_T,		_OFFSET(ripEnabled), 		_SIZE(ripEnabled),		"0"),
MIB_TBL_ENTRY(MIB_RIP_VERSION,			CURRENT_SETTING,	"RIP_VERSION",		BYTE_T,		_OFFSET(ripVer), 		_SIZE(ripVer),			"1"),
#endif
#ifdef CONFIG_USER_ZEBRA_OSPFD_OSPFD
MIB_TBL_ENTRY(MIB_OSPF_ENABLE,			CURRENT_SETTING,	"OSPF_ENABLE",		BYTE_T,		_OFFSET(ospfEnabled),		_SIZE(ospfEnabled),		"0"),
#endif
#ifdef CONFIG_IGMP_FORBID
MIB_TBL_ENTRY(MIB_IGMP_FORBID_ENABLE,			CURRENT_SETTING,	"IGMP_FORBID_ENABLE",		BYTE_T,		_OFFSET(igmpforbidEnable), 		_SIZE(igmpforbidEnable),		"1"),
#endif
MIB_TBL_ENTRY(MIB_IPF_OUT_ACTION,		CURRENT_SETTING,	"IPF_OUT_ACTION",	BYTE_T,		_OFFSET(ipfOutAction),	 	_SIZE(ipfOutAction),		"1"),
MIB_TBL_ENTRY(MIB_IPF_IN_ACTION,		CURRENT_SETTING,	"IPF_IN_ACTION",	BYTE_T,		_OFFSET(ipfInAction),	 	_SIZE(ipfInAction),		"0"),
MIB_TBL_ENTRY(MIB_MACF_OUT_ACTION,		CURRENT_SETTING,	"MACF_OUT_ACTION",	BYTE_T,		_OFFSET(macfOutAction),	 	_SIZE(macfOutAction),		"1"),
MIB_TBL_ENTRY(MIB_MACF_IN_ACTION,		CURRENT_SETTING,	"MACF_IN_ACTION",	BYTE_T,		_OFFSET(macfInAction),	 	_SIZE(macfInAction),		"1"),
MIB_TBL_ENTRY(MIB_PORT_FW_ENABLE,		CURRENT_SETTING,	"PORT_FW_ENABLE",	BYTE_T,		_OFFSET(portFwEnabled), 	_SIZE(portFwEnabled),		"0"),
#ifdef NEW_PORT_TRIGGER //add by machuanjun
MIB_TBL_ENTRY(MIB_PORT_TRIGGER_ENABLE,		CURRENT_SETTING,	"PORT_TRIGGER_ENABLE",	BYTE_T,		_OFFSET(ipTriggerEnabled), 	_SIZE(ipTriggerEnabled),		"0"),
#endif
#ifdef NATIP_FORWARDING
MIB_TBL_ENTRY(MIB_IP_FW_ENABLE,			CURRENT_SETTING,	"IP_FW_ENABLE",		BYTE_T,		_OFFSET(ipFwEnabled), 		_SIZE(ipFwEnabled),		"0"),
#endif
MIB_TBL_ENTRY(MIB_DMZ_ENABLE,			CURRENT_SETTING,	"DMZ_ENABLE",		BYTE_T,		_OFFSET(dmzEnabled), 		_SIZE(dmzEnabled),		"0"),
MIB_TBL_ENTRY(MIB_DMZ_IP,			CURRENT_SETTING,	"DMZ_IP",		IA_T,		_OFFSET(dmzHost), 		_SIZE(dmzHost),			"0"),

MIB_TBL_ENTRY(MIB_USER_NAME,			CURRENT_SETTING,	"USER_NAME",		STRING_T,	_OFFSET(userName), 		_SIZE(userName),		"user"),
MIB_TBL_ENTRY(MIB_USER_PASSWORD,		CURRENT_SETTING,	"USER_PASSWORD",	STRING_T,	_OFFSET(userPassword), 		_SIZE(userPassword),		"user"),
#ifdef BRIDGE_ONLY	// DEVICE_TYPE: 0
MIB_TBL_ENTRY(MIB_DEVICE_TYPE,			CURRENT_SETTING,	"DEVICE_TYPE",		BYTE_T,		_OFFSET(deviceType), 		_SIZE(deviceType),		"0"),
#elif defined(DEVICE_TYPE_5)	// DEVICE_TYPE: 1
MIB_TBL_ENTRY(MIB_DEVICE_TYPE,			CURRENT_SETTING,	"DEVICE_TYPE",		BYTE_T,		_OFFSET(deviceType), 		_SIZE(deviceType),		"5"),
#else
MIB_TBL_ENTRY(MIB_DEVICE_TYPE,			CURRENT_SETTING,	"DEVICE_TYPE",		BYTE_T,		_OFFSET(deviceType), 		_SIZE(deviceType),		"3"),
#endif
MIB_TBL_ENTRY(MIB_INIT_LINE,			CURRENT_SETTING,	"INIT_LINE",		BYTE_T,		_OFFSET(initLine), 		_SIZE(initLine),		"1"),
MIB_TBL_ENTRY(MIB_INIT_SCRIPT,			CURRENT_SETTING,	"INIT_SCRIPT",		BYTE_T,		_OFFSET(initScript), 		_SIZE(initScript),		"1"),



MIB_TBL_ENTRY(MIB_SUPER_NAME,			HW_SETTING,		"SUPER_NAME", 		STRING_T,	_OFFSET_HW(superName),		_SIZE_HW(superName),		"adsl"),
MIB_TBL_ENTRY(MIB_SUPER_PASSWORD,		HW_SETTING,		"SUPER_PASSWORD",	STRING_T,	_OFFSET_HW(superPassword), 	_SIZE_HW(superPassword),	"realtek"),
MIB_TBL_ENTRY(MIB_BOOT_MODE,			HW_SETTING,		"BOOT_MODE",		BYTE_T,		_OFFSET_HW(bootMode),		_SIZE_HW(bootMode),		"0"),
MIB_TBL_ENTRY(MIB_ELAN_MAC_ADDR, 		HW_SETTING,		"ELAN_MAC_ADDR",	BYTE6_T, 	_OFFSET_HW(elanMacAddr),	_SIZE_HW(elanMacAddr),		"00E04C867009"),
MIB_TBL_ENTRY(MIB_WLAN_MAC_ADDR, 		HW_SETTING,		"WLAN_MAC_ADDR",	BYTE6_T, 	_OFFSET_HW(wlanMacAddr),	_SIZE_HW(wlanMacAddr),		"00E04C076802"),
//#if WLAN_SUPPORT
MIB_TBL_ENTRY(MIB_HW_REG_DOMAIN, 		HW_SETTING,		"HW_REG_DOMAIN",	BYTE_T, 	_OFFSET_HW(regDomain),		_SIZE_HW(regDomain),		"1"),
#ifdef CONFIG_USB_RTL8192SU_SOFTAP
MIB_TBL_ENTRY(MIB_HW_RF_TYPE, 			HW_SETTING,		"HW_RF_TYPE",		BYTE_T, 	_OFFSET_HW(rfType),		_SIZE_HW(rfType),		"10"),
#else
MIB_TBL_ENTRY(MIB_HW_RF_TYPE, 			HW_SETTING,		"HW_RF_TYPE",		BYTE_T, 	_OFFSET_HW(rfType),		_SIZE_HW(rfType),		"7"),
#endif
//#ifdef WLAN_8185AG
#ifdef CONFIG_USB_RTL8187SU_SOFTAP
MIB_TBL_ENTRY(MIB_HW_TX_POWER_CCK, 		HW_SETTING,		"HW_TX_POWER_CCK",	BYTE_ARRAY_T, 	_OFFSET_HW(txPowerCCK),		_SIZE_HW(txPowerCCK),		"20 20 20 20 20 20 20 20 20 20 20 20 20 20"),
MIB_TBL_ENTRY(MIB_HW_TX_POWER_OFDM, 		HW_SETTING,		"HW_TX_POWER_OFDM",	BYTE_ARRAY_T, 	_OFFSET_HW(txPowerOFDM),	_SIZE_HW(txPowerOFDM),		"23 23 23 23 23 23 23 23 23 23 23 23 23 23"),
#elif defined(CONFIG_USB_RTL8192SU_SOFTAP)
MIB_TBL_ENTRY(MIB_HW_TX_POWER_CCK, 		HW_SETTING,		"HW_TX_POWER_CCK",	BYTE_ARRAY_T, 	_OFFSET_HW(txPowerCCK),		_SIZE_HW(txPowerCCK),		"00 00 00 00 00 00 00 00 00 00 00 00 00 00"),
MIB_TBL_ENTRY(MIB_HW_TX_POWER_OFDM_1S, 		HW_SETTING,		"HW_TX_POWER_OFDM_1S",	BYTE_ARRAY_T, 	_OFFSET_HW(txPowerOFDM_HT_OFDM_1S),		_SIZE_HW(txPowerOFDM_HT_OFDM_1S),		"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00"),
MIB_TBL_ENTRY(MIB_HW_TX_POWER_OFDM_2S, 		HW_SETTING,		"HW_TX_POWER_OFDM_2S",	BYTE_ARRAY_T, 	_OFFSET_HW(txPowerOFDM_HT_OFDM_2S),		_SIZE_HW(txPowerOFDM_HT_OFDM_2S),		"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00"),
MIB_TBL_ENTRY(MIB_HW_11N_LOFDMPWDA, 			HW_SETTING,		"HW_11N_LOFDMPWDA",		BYTE_T, 	_OFFSET_HW(LOFDMPwDiffA),		_SIZE_HW(LOFDMPwDiffA),		"0"),
MIB_TBL_ENTRY(MIB_HW_11N_LOFDMPWDB, 			HW_SETTING,		"HW_11N_LOFDMPWDB",		BYTE_T, 	_OFFSET_HW(LOFDMPwDiffB),		_SIZE_HW(LOFDMPwDiffB),		"0"),
MIB_TBL_ENTRY(MIB_HW_11N_TSSI1, 			HW_SETTING,		"HW_11N_TSSI1",		BYTE_T, 	_OFFSET_HW(TSSI1),		_SIZE_HW(TSSI1),		"0"),
MIB_TBL_ENTRY(MIB_HW_11N_TSSI2, 			HW_SETTING,		"HW_11N_TSSI2",		BYTE_T, 	_OFFSET_HW(TSSI2),		_SIZE_HW(TSSI2),		"0"),
MIB_TBL_ENTRY(MIB_HW_11N_THER, 			HW_SETTING,		"HW_11N_THER",		BYTE_T, 	_OFFSET_HW(Ther),		_SIZE_HW(Ther),		"0"),

#else
MIB_TBL_ENTRY(MIB_HW_TX_POWER_CCK, 		HW_SETTING,		"HW_TX_POWER_CCK",	BYTE_ARRAY_T, 	_OFFSET_HW(txPowerCCK),		_SIZE_HW(txPowerCCK),		"12 12 12 12 12 12 12 12 12 12 12 12 12 12"),
MIB_TBL_ENTRY(MIB_HW_TX_POWER_OFDM, 		HW_SETTING,		"HW_TX_POWER_OFDM",	BYTE_ARRAY_T, 	_OFFSET_HW(txPowerOFDM),	_SIZE_HW(txPowerOFDM),		"22 22 22 22 22 22 22 22 22 22 22 22 22 22"),
#endif
//#else
//MIB_TBL_ENTRY(MIB_HW_TX_POWER, 			HW_SETTING,		"HW_TX_POWER",		BYTE_ARRAY_T, 	_OFFSET_HW(txPower),		_SIZE_HW(txPower),		"6 6 6 6 6 6 6 6 6 6 6 6 6 6"),
//#endif
MIB_TBL_ENTRY(MIB_HW_ANT_DIVERSITY, 		HW_SETTING,		"HW_ANT_DIVERSITY",	BYTE_T, 	_OFFSET_HW(antDiversity),	_SIZE_HW(antDiversity),		"0"),
MIB_TBL_ENTRY(MIB_HW_TX_ANT, 			HW_SETTING,		"HW_TX_ANT",		BYTE_T, 	_OFFSET_HW(txAnt),		_SIZE_HW(txAnt),		"0"),
MIB_TBL_ENTRY(MIB_HW_CS_THRESHOLD, 		HW_SETTING,		"HW_CS_THRESHOLD",	BYTE_T, 	_OFFSET_HW(csThreshold),	_SIZE_HW(csThreshold),		"11"),
MIB_TBL_ENTRY(MIB_HW_CCA_MODE, 			HW_SETTING,		"HW_CCA_MODE",		BYTE_T, 	_OFFSET_HW(ccaMode),		_SIZE_HW(ccaMode),		"1"),
MIB_TBL_ENTRY(MIB_HW_PHY_TYPE, 			HW_SETTING,		"HW_PHY_TYPE",		BYTE_T, 	_OFFSET_HW(phyType),		_SIZE_HW(phyType),		"0"),
MIB_TBL_ENTRY(MIB_HW_LED_TYPE, 			HW_SETTING,		"HW_WLAN_LED_TYPE",	BYTE_T, 	_OFFSET_HW(ledType),		_SIZE_HW(ledType),		"7"),
//#endif // of WLAN_SUPPORT
MIB_TBL_ENTRY(MIB_BYTE_TEST,			HW_SETTING,		"BYTE",			BYTE_T,		_OFFSET_HW(byte_test), 		_SIZE_HW(byte_test),		"255"),
MIB_TBL_ENTRY(MIB_WORD_TEST,			HW_SETTING,		"WORD",			WORD_T,		_OFFSET_HW(word_test), 		_SIZE_HW(word_test),		"65535"),
MIB_TBL_ENTRY(MIB_DWORD_TEST,			HW_SETTING,		"DWORD",		DWORD_T,	_OFFSET_HW(dword_test), 	_SIZE_HW(dword_test),		"4294967295"),
MIB_TBL_ENTRY(MIB_INTERGER_TEST1,		HW_SETTING,		"INT1",			INTEGER_T,	_OFFSET_HW(int_test1), 		_SIZE_HW(int_test1),		"2147483647"),
MIB_TBL_ENTRY(MIB_INTERGER_TEST2,		HW_SETTING,		"INT2",			INTEGER_T,	_OFFSET_HW(int_test2), 		_SIZE_HW(int_test2),		"-2147483648"),
//star zhang to support WIFI logo test Mode...
//#ifdef WLAN_SUPPORT
MIB_TBL_ENTRY(MIB_WIFI_SUPPORT,		HW_SETTING,		"WIFI_SUPPORT",			BYTE_T,	_OFFSET_HW(wifi_support), 		_SIZE_HW(wifi_support),		"0"),
//#endif
MIB_TBL_ENTRY(MIB_HW_SERIAL_NUMBER,		HW_SETTING,		"HW_SERIAL_NO",		STRING_T,	_OFFSET_HW(serialNumber), 	_SIZE_HW(serialNumber),		"000000000002"),
// add by Chenxu 2009-2-19, 1 - MP mode(startup run UDPserver)
MIB_TBL_ENTRY(MIB_MP_TEST_MODE,			HW_SETTING,		"MP_TEST_MODE",		BYTE_T,		_OFFSET_HW(mpTestMode), 	_SIZE_HW(mpTestMode),		"1"),

/*mcj: add custom flag for upgrade 2009.9.2 */
//#ifdef CUSTOM_FLAG_436
MIB_TBL_ENTRY(MIB_CUSTOM_FLAG,			HW_SETTING,		"CUSTOM_FLAG",		BYTE_T,		_OFFSET_HW(custom_flag), 	_SIZE_HW(custom_flag),		"1"),
//#endif

#if defined(CONFIG_USER_SNMPD_SNMPD_V2CTRAP) || defined(_CWMP_MIB_)
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
MIB_TBL_ENTRY(MIB_SNMP_SYS_DESCR,		CURRENT_SETTING,	"SNMP_SYS_DESCR",	STRING_T,	_OFFSET(snmpSysDescr), 		_SIZE(snmpSysDescr),		"ZXDSL 531B"),
#else
MIB_TBL_ENTRY(MIB_SNMP_SYS_DESCR,		CURRENT_SETTING,	"SNMP_SYS_DESCR",	STRING_T,	_OFFSET(snmpSysDescr), 		_SIZE(snmpSysDescr),		"System Description"),
#endif
#endif //defined(CONFIG_USER_SNMPD_SNMPD_V2CTRAP) || defined(_CWMP_MIB_)
#ifdef CONFIG_USER_SNMPD_SNMPD_V2CTRAP
MIB_TBL_ENTRY(MIB_SNMP_SYS_OID,			CURRENT_SETTING,	"SNMP_SYS_OID",		STRING_T,	_OFFSET(snmpSysObjectID), 	_SIZE(snmpSysObjectID),		"1.3.6.1.4.1.16972"),
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
MIB_TBL_ENTRY(MIB_SNMP_SYS_CONTACT,		CURRENT_SETTING,	"SNMP_SYS_CONTACT",	STRING_T,	_OFFSET(snmpSysContact), 	_SIZE(snmpSysContact),		"WWW.ZTE.COM.CN"),
#else
MIB_TBL_ENTRY(MIB_SNMP_SYS_CONTACT,		CURRENT_SETTING,	"SNMP_SYS_CONTACT",	STRING_T,	_OFFSET(snmpSysContact), 	_SIZE(snmpSysContact),		"System Contact"),
#endif

#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
MIB_TBL_ENTRY(MIB_SNMP_SYS_LOCATION,		CURRENT_SETTING,	"SNMP_SYS_LOCATION",	STRING_T,	_OFFSET(snmpSysLocation), 	_SIZE(snmpSysLocation),		"WWW.ZTE.COM.CN"),
#else
MIB_TBL_ENTRY(MIB_SNMP_SYS_LOCATION,		CURRENT_SETTING,	"SNMP_SYS_LOCATION",	STRING_T,	_OFFSET(snmpSysLocation), 	_SIZE(snmpSysLocation),		"System Location"),
#endif
MIB_TBL_ENTRY(MIB_SNMP_TRAP_IP,			CURRENT_SETTING,	"SNMP_TRAP_IP",		IA_T,		_OFFSET(snmpTrapIpAddr), 	_SIZE(snmpTrapIpAddr),		"192.168.10.254"),
MIB_TBL_ENTRY(MIB_SNMP_COMM_RO,			CURRENT_SETTING,	"SNMP_COMM_RO",		STRING_T,	_OFFSET(snmpCommunityRO),	_SIZE(snmpCommunityRO),		"public"),
MIB_TBL_ENTRY(MIB_SNMP_COMM_RW,			CURRENT_SETTING,	"SNMP_COMM_RW",		STRING_T,	_OFFSET(snmpCommunityRW),	_SIZE(snmpCommunityRW),		"public"),
#endif

#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
MIB_TBL_ENTRY(MIB_SNMP_SYS_NAME,		CURRENT_SETTING,	"SNMP_SYS_NAME",	STRING_T,	_OFFSET(snmpSysName), 		_SIZE(snmpSysName),		"ZXDSL 531B"),
#else
MIB_TBL_ENTRY(MIB_SNMP_SYS_NAME,		CURRENT_SETTING,	"SNMP_SYS_NAME",	STRING_T,	_OFFSET(snmpSysName), 		_SIZE(snmpSysName),		"TEW-436BRM"),
#endif

// Kao
MIB_TBL_ENTRY(MIB_ATM_VC_AUTOSEARCH,		CURRENT_SETTING,	"VC_AUTOSEARCH",	BYTE_T,		_OFFSET(atmVcAutoSearch), 	_SIZE(atmVcAutoSearch),		"0"),

MIB_TBL_ENTRY(MIB_BRCTL_AGEINGTIME,		CURRENT_SETTING,	"BR_AGEING_TIME",	WORD_T,		_OFFSET(brctlAgeingTime), 	_SIZE(brctlAgeingTime),		"300"),
MIB_TBL_ENTRY(MIB_BRCTL_STP,			CURRENT_SETTING,	"BR_STP_ENABLED",	BYTE_T,		_OFFSET(brctlStp), 		_SIZE(brctlStp),		"0"),
#ifdef TELEFONICA_DEFAULT_CFG
MIB_TBL_ENTRY(MIB_MPMODE,			CURRENT_SETTING,	"MP_MODE",		BYTE_T,		_OFFSET(mpMode), 		_SIZE(mpMode),			"2"),
#else
MIB_TBL_ENTRY(MIB_MPMODE,			CURRENT_SETTING,	"MP_MODE",		BYTE_T,		_OFFSET(mpMode), 		_SIZE(mpMode),			"0"),
#endif
#ifdef IP_QOS
MIB_TBL_ENTRY(MIB_QOS_DEFAULT_QUEUE,		CURRENT_SETTING,	"QOS_DEFAULT_QUEUE",	INTEGER_T,	_OFFSET(qosDefaultQueue),	_SIZE(qosDefaultQueue),		"0"),
MIB_TBL_ENTRY(MIB_QOS_DOMAIN,			CURRENT_SETTING,	"QOS_DOMAIN",		BYTE_T,		_OFFSET(qosDomain), 		_SIZE(qosDomain),		"0"),
#endif
#ifdef QOS_DIFFSERV
MIB_TBL_ENTRY(MIB_QOS_DIFFSERV,			CURRENT_SETTING,	"QOS_DIFFSERV",		BYTE_T, 	_OFFSET(qosDiffServ), 		_SIZE(qosDiffServ),		"0"),
MIB_TBL_ENTRY(MIB_DIFFSERV_PHBCLASS, 		CURRENT_SETTING,	"DIFFSERV_PHBCLASS", 	BYTE_T, 	_OFFSET(phbClass),		_SIZE(phbClass), 	"0"),
#endif
/*ql:20080917 START: new IP QoS*/
#ifdef NEW_IP_QOS_SUPPORT
MIB_TBL_ENTRY(MIB_QOS_UPRATE, CURRENT_SETTING, "QOS_UPRATE", INTEGER_T, _OFFSET(qosUprate), _SIZE(qosUprate), "0"),
MIB_TBL_ENTRY(MIB_QOS_POLICY, CURRENT_SETTING, "QOS_POLICY", BYTE_T, _OFFSET(qosPolicy), _SIZE(qosPolicy), "0"),
MIB_TBL_ENTRY(MIB_TOTAL_BANDWIDTH, CURRENT_SETTING, "TOTAL_BANDWIDTH", WORD_T, _OFFSET(TotalBandWidth), _SIZE(TotalBandWidth), "1024"),
MIB_TBL_ENTRY(MIB_TOTAL_BANDWIDTH_LIMIT_EN, CURRENT_SETTING, "TOTAL_BANDWIDTH_LIMIT", BYTE_T, _OFFSET(TotalBandWidthEn), _SIZE(TotalBandWidthEn), "0"),
MIB_TBL_ENTRY(MIB_QOS_MODE, CURRENT_SETTING, "QOS_MODE", BYTE_T, _OFFSET(qosmode), _SIZE(qosmode), "0"),
#endif
/*ql:20080917 END*/
#ifdef CONFIG_USER_IGMPPROXY
MIB_TBL_ENTRY(MIB_IGMP_PROXY,			CURRENT_SETTING,	"IGMP_PROXY",		BYTE_T,		_OFFSET(igmpProxy), 		_SIZE(igmpProxy),		"0"),
MIB_TBL_ENTRY(MIB_IGMP_PROXY_ITF,		CURRENT_SETTING,	"IGMP_PROXY_ITF",	BYTE_T,		_OFFSET(igmpProxyItf), 		_SIZE(igmpProxyItf),		"255"),
#endif
#ifdef IP_PASSTHROUGH
MIB_TBL_ENTRY(MIB_IPPT_ITF,			CURRENT_SETTING,	"IPPT_ITF",		BYTE_T,		_OFFSET(ipptItf), 		_SIZE(ipptItf),			"255"),
MIB_TBL_ENTRY(MIB_IPPT_LEASE,			CURRENT_SETTING,	"IPPT_LEASE",		INTEGER_T,	_OFFSET(ipptLTime), 		_SIZE(ipptLTime),		"600"),
MIB_TBL_ENTRY(MIB_IPPT_LANACC,			CURRENT_SETTING,	"IPPT_LANACC",		BYTE_T,		_OFFSET(ipptLanacc), 		_SIZE(ipptLanacc),		"0"),
#endif
MIB_TBL_ENTRY(MIB_SPC_ENABLE,			CURRENT_SETTING,	"SPC_ENABLED",		BYTE_T,		_OFFSET(spcEnable), 		_SIZE(spcEnable),		"0"),
MIB_TBL_ENTRY(MIB_SPC_IPTYPE,			CURRENT_SETTING,	"SPC_IPTYPE",		BYTE_T,		_OFFSET(spcIPType), 		_SIZE(spcIPType),		"0"),
#ifdef TELEFONICA_DEFAULT_CFG
MIB_TBL_ENTRY(MIB_ACL_CAPABILITY,		CURRENT_SETTING,	"ACL_CAPABILITY",	BYTE_T,		_OFFSET(aclcapability),		_SIZE(aclcapability),		"1"),
#else
MIB_TBL_ENTRY(MIB_ACL_CAPABILITY,		CURRENT_SETTING,	"ACL_CAPABILITY",	BYTE_T,		_OFFSET(aclcapability),		_SIZE(aclcapability),		"0"),
#endif
#ifdef NAT_CONN_LIMIT
MIB_TBL_ENTRY(MIB_NAT_CONN_LIMIT,		CURRENT_SETTING,	"CONN_LIMIT",		BYTE_T,		_OFFSET(connlimit),			_SIZE(connlimit),		"0"),
#endif
#ifdef URL_BLOCKING_SUPPORT
MIB_TBL_ENTRY(MIB_URL_CAPABILITY,		CURRENT_SETTING,	"URL_CAPABILITY",	BYTE_T,		_OFFSET(urlcapability),		_SIZE(urlcapability),		"0"),  // Mason Yu for URL Blocking
#endif
#if defined(ZTE_GENERAL_ROUTER_SC) || defined(TIME_ZONE)
#ifndef CONFIG_GUI_WEB
MIB_TBL_ENTRY(MIB_NTP_ENABLED, 			CURRENT_SETTING,	"NTP_ENABLED",		BYTE_T, 	_OFFSET(ntpEnabled),		_SIZE(ntpEnabled),		"0"),
MIB_TBL_ENTRY(MIB_NTP_TIMEZONE, 		CURRENT_SETTING,	"NTP_TIMEZONE",		STRING_T, 	_OFFSET(ntpTimeZone),		_SIZE(ntpTimeZone),		"+5 2"), //lhj change timezone default setting to US  
#else
MIB_TBL_ENTRY(MIB_NTP_ENABLED, 			CURRENT_SETTING,	"NTP_ENABLED",		BYTE_T, 	_OFFSET(ntpEnabled),		_SIZE(ntpEnabled),		"1"),
MIB_TBL_ENTRY(MIB_NTP_TIMEZONE, 		CURRENT_SETTING,	"NTP_TIMEZONE",		STRING_T, 	_OFFSET(ntpTimeZone),		_SIZE(ntpTimeZone),		"-8 3"),
#endif
MIB_TBL_ENTRY(MIB_NTP_SERVER_ID, 		CURRENT_SETTING,	"NTP_SERVER_ID",	BYTE_T, 	_OFFSET(ntpServerId),		_SIZE(ntpServerId),		"0"),
MIB_TBL_ENTRY(MIB_NTP_SERVER_IP1, 		CURRENT_SETTING,	"NTP_SERVER_IP1",	IA_T, 		_OFFSET(ntpServerIp1),		_SIZE(ntpServerIp1),		"203.117.180.36"),
MIB_TBL_ENTRY(MIB_NTP_SERVER_IP2, 		CURRENT_SETTING,	"NTP_SERVER_IP2",	IA_T, 		_OFFSET(ntpServerIp2),		_SIZE(ntpServerIp2),		"220.130.158.52"),
MIB_TBL_ENTRY(MIB_NTP_SERVER_HOST1, 		CURRENT_SETTING,	"NTP_SERVER_HOST1",	STRING_T,	_OFFSET(ntpServerHost1),	_SIZE(ntpServerHost1),		"203.117.180.36"),
MIB_TBL_ENTRY(MIB_NTP_SERVER_HOST2, 		CURRENT_SETTING,	"NTP_SERVER_HOST2",	STRING_T, 	_OFFSET(ntpServerHost2),	_SIZE(ntpServerHost2),		"220.130.158.52"),
#ifdef DAYLIGHT_SAVING
MIB_TBL_ENTRY(MIB_DST_ENABLED, 			CURRENT_SETTING,	"DST_ENABLED",		BYTE_T, 	_OFFSET(dstEnabled),		_SIZE(dstEnabled),		"0"),
MIB_TBL_ENTRY(MIB_DST_OFFSET, 			CURRENT_SETTING,	"DST_OFFSET",		WORD_T, 	_OFFSET(dstOffset),		_SIZE(dstOffset),		"3600"),
MIB_TBL_ENTRY(MIB_DST_START, 			CURRENT_SETTING,	"DST_START",		STRING_T,	_OFFSET(dstStart),		_SIZE(dstStart),		"03-02-00-02"),// lhj change timezone default start Mar 2nd Week
MIB_TBL_ENTRY(MIB_DST_END, 			CURRENT_SETTING,	"DST_END",		STRING_T, 	_OFFSET(dstEnd),		_SIZE(dstEnd),			"11-01-00-02"),// lhj change timezone default stop Nov 1st Week
#endif
#endif
MIB_TBL_ENTRY(MIB_UPNP_DAEMON,			CURRENT_SETTING,	"UPNP",			BYTE_T,		_OFFSET(upnp), 			_SIZE(upnp),			"0"),
MIB_TBL_ENTRY(MIB_UPNP_EXT_ITF,			CURRENT_SETTING,	"UPNP_EXT_ITF",		BYTE_T,		_OFFSET(upnpExtItf), 		_SIZE(upnpExtItf),		"255"),
#ifdef DOMAIN_BLOCKING_SUPPORT
MIB_TBL_ENTRY(MIB_DOMAINBLK_CAPABILITY,		CURRENT_SETTING,	"DOMAINBLK_CAPABILITY",	BYTE_T,		_OFFSET(domainblkcap),		_SIZE(domainblkcap),		"0"),  // Mason Yu for Domain Blocking
#endif


#ifdef WLAN_SUPPORT
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
MIB_TBL_ENTRY(MIB_WLAN_SSID,			CURRENT_SETTING,	"SSID", 		STRING_T,	_OFFSET(ssid),			_SIZE(ssid),			""),
#else
		MIB_TBL_ENTRY(MIB_WLAN_SSID,			CURRENT_SETTING,	"SSID", 		STRING_T,	_OFFSET(ssid),			_SIZE(ssid),			"TRENDnet436"), 
#endif
MIB_TBL_ENTRY(MIB_WLAN_CHAN_NUM,		CURRENT_SETTING,	"CHANNEL", 		BYTE_T, 	_OFFSET(channel),		_SIZE(channel),			"0"),
MIB_TBL_ENTRY(MIB_WLAN_WEP,			CURRENT_SETTING,	"WEP", 			BYTE_T,		_OFFSET(wep),			_SIZE(wep),			"0"),
MIB_TBL_ENTRY(MIB_WLAN_WEP64_KEY1,		CURRENT_SETTING,	"WEP64_KEY1", 		BYTE5_T,	_OFFSET(wep64Key1),		_SIZE(wep64Key1),		"0000000000"),
MIB_TBL_ENTRY(MIB_WLAN_WEP64_KEY2,		CURRENT_SETTING,	"WEP64_KEY2", 		BYTE5_T,	_OFFSET(wep64Key2),		_SIZE(wep64Key2),		"0000000000"),
MIB_TBL_ENTRY(MIB_WLAN_WEP64_KEY3,		CURRENT_SETTING,	"WEP64_KEY3", 		BYTE5_T,	_OFFSET(wep64Key3),		_SIZE(wep64Key3),		"0000000000"),
MIB_TBL_ENTRY(MIB_WLAN_WEP64_KEY4,		CURRENT_SETTING,	"WEP64_KEY4", 		BYTE5_T,	_OFFSET(wep64Key4),		_SIZE(wep64Key4),		"0000000000"),
MIB_TBL_ENTRY(MIB_WLAN_WEP128_KEY1,		CURRENT_SETTING,	"WEP128_KEY1", 		BYTE13_T,	_OFFSET(wep128Key1),		_SIZE(wep128Key1),		"00000000000000000000000000"),
MIB_TBL_ENTRY(MIB_WLAN_WEP128_KEY2,		CURRENT_SETTING,	"WEP128_KEY2", 		BYTE13_T,	_OFFSET(wep128Key2),		_SIZE(wep128Key2),		"00000000000000000000000000"),
MIB_TBL_ENTRY(MIB_WLAN_WEP128_KEY3,		CURRENT_SETTING,	"WEP128_KEY3", 		BYTE13_T,	_OFFSET(wep128Key3),		_SIZE(wep128Key3),		"00000000000000000000000000"),
MIB_TBL_ENTRY(MIB_WLAN_WEP128_KEY4,		CURRENT_SETTING,	"WEP128_KEY4", 		BYTE13_T,	_OFFSET(wep128Key4),		_SIZE(wep128Key4),		"00000000000000000000000000"),
MIB_TBL_ENTRY(MIB_WLAN_WEP_DEFAULT_KEY,		CURRENT_SETTING,	"WEP_DEFAULT_KEY", 	BYTE_T,		_OFFSET(wepDefaultKey),		_SIZE(wepDefaultKey),		"0"),
MIB_TBL_ENTRY(MIB_WLAN_WEP_KEY_TYPE,		CURRENT_SETTING,	"WEP_KEY_TYPE", 	BYTE_T,		_OFFSET(wepKeyType),		_SIZE(wepKeyType),		"0"),
MIB_TBL_ENTRY(MIB_WLAN_FRAG_THRESHOLD,		CURRENT_SETTING,	"FRAG_THRESHOLD", 	WORD_T,		_OFFSET(fragThreshold),		_SIZE(fragThreshold),		"2346"),
MIB_TBL_ENTRY(MIB_WLAN_SUPPORTED_RATE,		CURRENT_SETTING,	"SUPPORTED_RATES", 	WORD_T,		_OFFSET(supportedRates),	_SIZE(supportedRates),		"4095"),
MIB_TBL_ENTRY(MIB_WLAN_BEACON_INTERVAL,		CURRENT_SETTING,	"BEACON_INTERVAL", 	WORD_T,		_OFFSET(beaconInterval),	_SIZE(beaconInterval),		"100"),
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
MIB_TBL_ENTRY(MIB_WLAN_PREAMBLE_TYPE,		CURRENT_SETTING,	"PREAMBLE_TYPE", 	BYTE_T,		_OFFSET(preambleType),		_SIZE(preambleType),		"2"),
#else
MIB_TBL_ENTRY(MIB_WLAN_PREAMBLE_TYPE,		CURRENT_SETTING,	"PREAMBLE_TYPE", 	BYTE_T,		_OFFSET(preambleType),		_SIZE(preambleType),		"0"),
#endif
MIB_TBL_ENTRY(MIB_WLAN_BASIC_RATE,		CURRENT_SETTING,	"BASIC_RATES", 		WORD_T, 	_OFFSET(basicRates),		_SIZE(basicRates),		"15"),
MIB_TBL_ENTRY(MIB_WLAN_RTS_THRESHOLD,		CURRENT_SETTING,	"RTS_THRESHOLD", 	WORD_T, 	_OFFSET(rtsThreshold),		_SIZE(rtsThreshold),		"2347"),
MIB_TBL_ENTRY(MIB_WLAN_AUTH_TYPE,		CURRENT_SETTING,	"AUTH_TYPE", 		BYTE_T,		_OFFSET(authType),		_SIZE(authType),		"2"),
MIB_TBL_ENTRY(MIB_WLAN_HIDDEN_SSID,		CURRENT_SETTING,	"HIDDEN_SSID", 		BYTE_T,		_OFFSET(hiddenSSID),		_SIZE(hiddenSSID),		"0"),
MIB_TBL_ENTRY(MIB_WLAN_DISABLED,		CURRENT_SETTING,	"WLAN_DISABLED", 	BYTE_T,		_OFFSET(wlanDisabled),		_SIZE(wlanDisabled),		"0"),
// Added by Mason Yu for TxPower
//modified by xl_yue
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
MIB_TBL_ENTRY(MIB_TX_POWER,			CURRENT_SETTING,	"TX_POWER", 		BYTE_T,		_OFFSET(txPower),		_SIZE(txPower),			"0"),	//default 100%
#else
MIB_TBL_ENTRY(MIB_TX_POWER,			CURRENT_SETTING,	"TX_POWER", 		BYTE_T,		_OFFSET(txPower),		_SIZE(txPower),			"2"),	//default 60mW
#endif
MIB_TBL_ENTRY(MIB_WLAN_INACTIVITY_TIME,		CURRENT_SETTING,	"INACTIVITY_TIME",	DWORD_T,	_OFFSET(inactivityTime),	_SIZE(inactivityTime),		"30000"),
MIB_TBL_ENTRY(MIB_WLAN_RATE_ADAPTIVE_ENABLED,	CURRENT_SETTING,	"RATE_ADAPTIVE_ENABLED",BYTE_T,		_OFFSET(rateAdaptiveEnabled),	_SIZE(rateAdaptiveEnabled),	"1"),
MIB_TBL_ENTRY(MIB_WLAN_DTIM_PERIOD,		CURRENT_SETTING,	"DTIM_PERIOD", 		BYTE_T,		_OFFSET(dtimPeriod),		_SIZE(dtimPeriod),		"1"),
MIB_TBL_ENTRY(MIB_WLAN_MODE,			CURRENT_SETTING,	"WLAN_MODE", 		BYTE_T,		_OFFSET(wlanMode),		_SIZE(wlanMode),		"0"),
MIB_TBL_ENTRY(MIB_WLAN_NETWORK_TYPE,		CURRENT_SETTING,	"NETWORK_TYPE",		BYTE_T,		_OFFSET(networkType),		_SIZE(networkType),		"0"),
#ifdef WLAN_IAPP
MIB_TBL_ENTRY(MIB_WLAN_IAPP_DISABLED,		CURRENT_SETTING,	"IAPP_DISABLED",	BYTE_T,		_OFFSET(iappDisabled),		_SIZE(iappDisabled),		"0"),
#endif

#ifdef WLAN_WDS
MIB_TBL_ENTRY(MIB_WLAN_WDS_ENABLED,		CURRENT_SETTING,	"WLAN_WDS_ENABLED",	BYTE_T,		_OFFSET(wdsEnabled),		_SIZE(wdsEnabled),		"0"),
MIB_TBL_ENTRY(MIB_WLAN_WDS_NUM,			CURRENT_SETTING,	"WLAN_WDS_NUM",		BYTE_T,		_OFFSET(wdsNum),		_SIZE(wdsNum),			"0"),
MIB_TBL_ENTRY(MIB_WLAN_WDS,			CURRENT_SETTING,	"WLAN_WDS",		WDS_ARRAY_T,	_OFFSET(wdsArray),		_SIZE(wdsArray),		""),
MIB_TBL_ENTRY(MIB_WLAN_WDS_WEP,			CURRENT_SETTING,	"WDS_WEP", 		BYTE_T,		_OFFSET(wdsWep),		_SIZE(wdsWep),			"0"),
MIB_TBL_ENTRY(MIB_WLAN_WDS_WEP64_KEY1,		CURRENT_SETTING,	"WDS_WEP64_KEY1", 	BYTE5_T,	_OFFSET(wdsWep64Key1),		_SIZE(wdsWep64Key1),		"0000000000"),
MIB_TBL_ENTRY(MIB_WLAN_WDS_WEP64_KEY2,		CURRENT_SETTING,	"WDS_WEP64_KEY2", 	BYTE5_T,	_OFFSET(wdsWep64Key2),		_SIZE(wdsWep64Key2),		"0000000000"),
MIB_TBL_ENTRY(MIB_WLAN_WDS_WEP64_KEY3,		CURRENT_SETTING,	"WDS_WEP64_KEY3", 	BYTE5_T,	_OFFSET(wdsWep64Key3),		_SIZE(wdsWep64Key3),		"0000000000"),
MIB_TBL_ENTRY(MIB_WLAN_WDS_WEP64_KEY4,		CURRENT_SETTING,	"WDS_WEP64_KEY4", 	BYTE5_T,	_OFFSET(wdsWep64Key4),		_SIZE(wdsWep64Key4),		"0000000000"),
MIB_TBL_ENTRY(MIB_WLAN_WDS_WEP128_KEY1,		CURRENT_SETTING,	"WDS_WEP128_KEY1",	BYTE13_T,	_OFFSET(wdsWep128Key1),		_SIZE(wdsWep128Key1),		"00000000000000000000000000"),
MIB_TBL_ENTRY(MIB_WLAN_WDS_WEP128_KEY2,		CURRENT_SETTING,	"WDS_WEP128_KEY2", 	BYTE13_T,	_OFFSET(wdsWep128Key2),		_SIZE(wdsWep128Key2),		"00000000000000000000000000"),
MIB_TBL_ENTRY(MIB_WLAN_WDS_WEP128_KEY3,		CURRENT_SETTING,	"WDS_WEP128_KEY3", 	BYTE13_T,	_OFFSET(wdsWep128Key3),		_SIZE(wdsWep128Key3),		"00000000000000000000000000"),
MIB_TBL_ENTRY(MIB_WLAN_WDS_WEP128_KEY4,		CURRENT_SETTING,	"WDS_WEP128_KEY4", 	BYTE13_T,	_OFFSET(wdsWep128Key4),		_SIZE(wdsWep128Key4),		"00000000000000000000000000"),
MIB_TBL_ENTRY(MIB_WLAN_WDS_WEP_DEFAULT_KEY,	CURRENT_SETTING,	"WDS_WEP_DEFAULT_KEY", 	BYTE_T,		_OFFSET(wdsWepDefaultKey),	_SIZE(wdsWepDefaultKey),	"0"),
MIB_TBL_ENTRY(MIB_WLAN_WDS_WEP_KEY_TYPE,	CURRENT_SETTING,	"WDS_WEP_KEY_TYPE", 	BYTE_T,		_OFFSET(wdsWepKeyType),		_SIZE(wdsWepKeyType),		"1"),
#endif

#ifdef WLAN_WPA
MIB_TBL_ENTRY(MIB_WLAN_ENCRYPT,			CURRENT_SETTING,	"WLAN_ENCRYPT",		BYTE_T,		_OFFSET(encrypt),		_SIZE(encrypt),			"0"),
MIB_TBL_ENTRY(MIB_WLAN_ENABLE_SUPP_NONWPA,	CURRENT_SETTING,	"WLAN_ENABLE_SUPP_NONWPA", BYTE_T,	_OFFSET(enableSuppNonWpa),	_SIZE(enableSuppNonWpa),	"0"),
MIB_TBL_ENTRY(MIB_WLAN_SUPP_NONWPA,		CURRENT_SETTING,	"WLAN_SUPP_NONWPA", 	BYTE_T,		_OFFSET(suppNonWpa),		_SIZE(suppNonWpa),		"0"),
MIB_TBL_ENTRY(MIB_WLAN_WPA_AUTH,		CURRENT_SETTING,	"WLAN_WPA_AUTH", 	BYTE_T,		_OFFSET(wpaAuth),		_SIZE(wpaAuth),			"2"),
MIB_TBL_ENTRY(MIB_WLAN_WPA_CIPHER_SUITE,	CURRENT_SETTING,	"WLAN_WPA_CIPHER_SUITE",BYTE_T,		_OFFSET(wpaCipher),		_SIZE(wpaCipher),		"1"),
MIB_TBL_ENTRY(MIB_WLAN_WPA_PSK,			CURRENT_SETTING,	"WLAN_WPA_PSK",		STRING_T,	_OFFSET(wpaPSK),		_SIZE(wpaPSK),			"0"),
MIB_TBL_ENTRY(MIB_WLAN_WPA_GROUP_REKEY_TIME,	CURRENT_SETTING,	"WLAN_WPA_GROUP_REKEY_TIME",DWORD_T,	_OFFSET(wpaGroupRekeyTime),	_SIZE(wpaGroupRekeyTime),	"86400"),
MIB_TBL_ENTRY(MIB_WLAN_ENABLE_MAC_AUTH,		CURRENT_SETTING,	"MAC_AUTH_ENABLED",     BYTE_T,         _OFFSET(macAuthEnabled),	_SIZE(macAuthEnabled),		"0"),
#ifdef WLAN_1x
MIB_TBL_ENTRY(MIB_WLAN_RS_IP,			CURRENT_SETTING,	"RS_IP",		IA_T,		_OFFSET(rsIpAddr),		_SIZE(rsIpAddr),		"0.0.0.0"),
MIB_TBL_ENTRY(MIB_WLAN_RS_PORT,			CURRENT_SETTING,	"RS_PORT",		WORD_T,		_OFFSET(rsPort),		_SIZE(rsPort),			"1812"),
MIB_TBL_ENTRY(MIB_WLAN_RS_PASSWORD,		CURRENT_SETTING,	"RS_PASSWORD",		STRING_T,	_OFFSET(rsPassword),		_SIZE(rsPassword),		0),
MIB_TBL_ENTRY(MIB_WLAN_RS_RETRY,		CURRENT_SETTING,	"RS_MAXRETRY",		BYTE_T,		_OFFSET(rsMaxRetry),		_SIZE(rsMaxRetry),		"3"),
MIB_TBL_ENTRY(MIB_WLAN_RS_INTERVAL_TIME,	CURRENT_SETTING,	"RS_INTERVAL_TIME",	WORD_T,		_OFFSET(rsIntervalTime),	_SIZE(rsIntervalTime),		"5"),
MIB_TBL_ENTRY(MIB_WLAN_ACCOUNT_RS_ENABLED,	CURRENT_SETTING,	"ACCOUNT_RS_ENABLED", 	BYTE_T,		_OFFSET(accountRsEnabled),	_SIZE(accountRsEnabled),	"0"),
MIB_TBL_ENTRY(MIB_WLAN_ACCOUNT_RS_IP,		CURRENT_SETTING,	"ACCOUNT_RS_IP",	IA_T,		_OFFSET(accountRsIpAddr),	_SIZE(accountRsIpAddr),		0),
MIB_TBL_ENTRY(MIB_WLAN_ACCOUNT_RS_PORT,		CURRENT_SETTING,	"ACCOUNT_RS_PORT",	WORD_T,		_OFFSET(accountRsPort),		_SIZE(accountRsPort),		"0"),
MIB_TBL_ENTRY(MIB_WLAN_ACCOUNT_RS_PASSWORD,	CURRENT_SETTING,	"ACCOUNT_RS_PASSWORD",	STRING_T,	_OFFSET(accountRsPassword),	_SIZE(accountRsPassword),	0),
MIB_TBL_ENTRY(MIB_WLAN_ACCOUNT_UPDATE_ENABLED,	CURRENT_SETTING,	"ACCOUNT_RS_UPDATE_ENABLED",BYTE_T,	_OFFSET(accountRsUpdateEnabled),_SIZE(accountRsUpdateEnabled),	"0"),
MIB_TBL_ENTRY(MIB_WLAN_ACCOUNT_UPDATE_DELAY,	CURRENT_SETTING,	"ACCOUNT_RS_UPDATE_DELAY",WORD_T,	_OFFSET(accountRsUpdateDelay),	_SIZE(accountRsUpdateDelay),	"0"),
MIB_TBL_ENTRY(MIB_WLAN_ACCOUNT_RS_RETRY,	CURRENT_SETTING,	"ACCOUNT_RS_MAXRETRY",	BYTE_T,		_OFFSET(accountRsMaxRetry),	_SIZE(accountRsMaxRetry),	"0"),
MIB_TBL_ENTRY(MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME,CURRENT_SETTING,	"ACCOUNT_RS_INTERVAL_TIME",	WORD_T,	_OFFSET(accountRsIntervalTime),	_SIZE(accountRsIntervalTime),	"0"),
MIB_TBL_ENTRY(MIB_WLAN_ENABLE_1X,		CURRENT_SETTING,	"WLAN_ENABLE_1X", 	BYTE_T,		_OFFSET(enable1X),		_SIZE(enable1X),		"0"),
#endif
MIB_TBL_ENTRY(MIB_WLAN_WPA_PSK_FORMAT,		CURRENT_SETTING,	"WLAN_PSK_FORMAT", 	BYTE_T,		_OFFSET(wpaPSKFormat),		_SIZE(wpaPSKFormat),		"0"),
MIB_TBL_ENTRY(MIB_WLAN_WPA2_CIPHER_SUITE,	CURRENT_SETTING,	"WPA2_CIPHER_SUITE",	BYTE_T,		_OFFSET(wpa2Cipher),		_SIZE(wpa2Cipher),		"2"),
#endif

#ifdef WLAN_ACL
MIB_TBL_ENTRY(MIB_WLAN_AC_ENABLED,		CURRENT_SETTING,	"WLAN_MACAC_ENABLED",	BYTE_T,		_OFFSET(acEnabled),		_SIZE(acEnabled),		"0"),
#endif

MIB_TBL_ENTRY(MIB_WLAN_BLOCK_RELAY,		CURRENT_SETTING,	"WLAN_BLOCK_RELAY",	BYTE_T,		_OFFSET(blockRelay),		_SIZE(blockRelay),		"0"),
MIB_TBL_ENTRY(MIB_WLAN_BLOCK_ETH2WIR,		CURRENT_SETTING,	"WLAN_BLOCK_ETH2WIR",	BYTE_T,		_OFFSET(BlockEth2Wir),		_SIZE(BlockEth2Wir),		"0"),
MIB_TBL_ENTRY(MIB_WLAN_ITF_GROUP,		CURRENT_SETTING,	"WLAN_ITF_GROUP",	BYTE_T,		_OFFSET(itfGroup),		_SIZE(itfGroup),		"0"),
#ifdef WLAN_MBSSID
MIB_TBL_ENTRY(MIB_WLAN_BLOCK_MBSSID,		CURRENT_SETTING,	"WLAN_BLOCK_MBSSID",	BYTE_T,		_OFFSET(BlockMbssid),		_SIZE(BlockMbssid),		"0"),
#endif
#ifdef WLAN_8185AG
#ifdef CONFIG_USB_RTL8192SU_SOFTAP
MIB_TBL_ENTRY(MIB_WLAN_BAND,			CURRENT_SETTING,	"WLAN_BAND",		BYTE_T,		_OFFSET(wlanBand),		_SIZE(wlanBand),		"11"),
MIB_TBL_ENTRY(MIB_WLAN_FIX_RATE,		CURRENT_SETTING,	"WLAN_FIX_RATE",	DWORD_T,		_OFFSET(fixedTxRate),		_SIZE(fixedTxRate),		"1"),
#else
MIB_TBL_ENTRY(MIB_WLAN_BAND,			CURRENT_SETTING,	"WLAN_BAND",		BYTE_T,		_OFFSET(wlanBand),		_SIZE(wlanBand),		"3"),
MIB_TBL_ENTRY(MIB_WLAN_FIX_RATE,		CURRENT_SETTING,	"WLAN_FIX_RATE",	WORD_T,		_OFFSET(fixedTxRate),		_SIZE(fixedTxRate),		"1"),
#endif
#ifdef CONFIG_USB_RTL8187SU_SOFTAP
MIB_TBL_ENTRY(MIB_WLAN_MLCSTRATE,		CURRENT_SETTING,	"WLAN_MLCSTRATE",	WORD_T,		_OFFSET(mlcstRate),		_SIZE(mlcstRate),		"0"),	//cathy
#endif
#endif
#ifdef WLAN_WEB_REDIRECT  //jiunming,web_redirect
MIB_TBL_ENTRY(MIB_WLAN_WEB_REDIR_URL,		CURRENT_SETTING,	"WLAN_WEB_REDIR_URL",	STRING_T,	_OFFSET(WlanWebRedirURL),	_SIZE(WlanWebRedirURL),		"http://192.168.1.1/"),
#endif
#ifdef WLAN_QoS
MIB_TBL_ENTRY(MIB_WLAN_QoS, 			CURRENT_SETTING, 	"WLAN_QoS", BYTE_T,	_OFFSET(wlanqos), 	_SIZE(wlanqos), 	"0"),
#endif
MIB_TBL_ENTRY(MIB_WLAN_DIG, 			CURRENT_SETTING, 	"WLAN_DIG", BYTE_T,	_OFFSET(wlanDIG), 	_SIZE(wlanDIG), 	"0"),
MIB_TBL_ENTRY(MIB_WLAN_BEACON_ADVERTISEMENT, 			CURRENT_SETTING, 	"WLAN_BEACON_ADVERTISEMENT", BYTE_T,	_OFFSET(wlanBcnAdvtisement), 	_SIZE(wlanBcnAdvtisement), 	"1"),
MIB_TBL_ENTRY(MIB_WIFI_TEST, 			CURRENT_SETTING, 	"WIFI_TEST", BYTE_T,	_OFFSET(wifitest), 	_SIZE(wifitest), 	"0"),

MIB_TBL_ENTRY(MIB_WLAN_PROTECTION_DISABLED, CURRENT_SETTING, "WLAN_PROTECTON", BYTE_T, _OFFSET(wlanProtectionDisabled), _SIZE(wlanProtectionDisabled), "1"),  
#ifdef CONFIG_USB_RTL8192SU_SOFTAP		// add by yq_zhou 2.10
MIB_TBL_ENTRY(MIB_WLAN_AGGREGATION, CURRENT_SETTING, "WLAN_AGGREGATION", BYTE_T, _OFFSET(wlanAggregation), _SIZE(wlanAggregation), "1"), 
MIB_TBL_ENTRY(MIB_WLAN_SHORTGI_ENABLED, CURRENT_SETTING, "WLAN_SHORTGI", BYTE_T, _OFFSET(wlanShortGIEnabled), _SIZE(wlanShortGIEnabled), "0"), 
MIB_TBL_ENTRY(MIB_WLAN_CONTROL_BAND, CURRENT_SETTING, "WLAN_CONTROLBAND", BYTE_T, _OFFSET(wlanContrlBand), _SIZE(wlanContrlBand), "0"), 	      
MIB_TBL_ENTRY(MIB_WLAN_CHANNEL_WIDTH, CURRENT_SETTING, "WLAN_CHANNELWIDTH", BYTE_T, _OFFSET(wlanChannelWidth), _SIZE(wlanChannelWidth), "1"),  
	

#endif
#endif // of WLAN_SUPPORT

// Jenny, system log
MIB_TBL_ENTRY(MIB_SYSLOG_LOG_LEVEL,	CURRENT_SETTING, 	"SYSLOG_LOG_LEVEL", BYTE_T,	_OFFSET(syslogslevel), 	_SIZE(syslogslevel), 	"0"),
MIB_TBL_ENTRY(MIB_SYSLOG_DISPLAY_LEVEL, 	CURRENT_SETTING,	"SYSLOG_DISPLAY_LEVEL", BYTE_T, _OFFSET(syslogdlevel),	_SIZE(syslogdlevel), 	"0"),
#ifdef SYSLOG_REMOTE_LOG
MIB_TBL_ENTRY(MIB_SYSLOG_MODE, 			CURRENT_SETTING,	"SYSLOG_MODE", BYTE_T, _OFFSET(syslogmode),	_SIZE(syslogmode), 	"0"),
MIB_TBL_ENTRY(MIB_SYSLOG_SERVER_IP,		CURRENT_SETTING,	"SYSLOG_SERVER_IP",	IA_T,		_OFFSET(syslogServerIpAddr),		_SIZE(syslogServerIpAddr),		0),
MIB_TBL_ENTRY(MIB_SYSLOG_SERVER_PORT, 	CURRENT_SETTING,	"SYSLOG_SERVER_PORT",	WORD_T, 	_OFFSET(syslogServerPort), 	_SIZE(syslogServerPort),		"0"),
#endif
// Added by Mason Yu for write superUser into Current Setting
#ifdef TELEFONICA_DEFAULT_CFG
MIB_TBL_ENTRY(MIB_SUSER_NAME,			CURRENT_SETTING,	"SUSER_NAME",		STRING_T,	_OFFSET(suserName), 		_SIZE(suserName),		"1234"),
MIB_TBL_ENTRY(MIB_SUSER_PASSWORD,		CURRENT_SETTING,	"SUSER_PASSWORD",	STRING_T,	_OFFSET(suserPassword), 	_SIZE(suserPassword),		"1234"),
#else
MIB_TBL_ENTRY(MIB_SUSER_NAME,			CURRENT_SETTING,	"SUSER_NAME",		STRING_T,	_OFFSET(suserName), 		_SIZE(suserName),		"admin"),
#if defined(ZTE_531B_BRIDGE_SC)||defined(ZTE_GENERAL_ROUTER_SC)
MIB_TBL_ENTRY(MIB_SUSER_PASSWORD,		CURRENT_SETTING,	"SUSER_PASSWORD",	STRING_T,	_OFFSET(suserPassword), 	_SIZE(suserPassword),		"admin"),
#else
#ifndef CONFIG_GUI_WEB
MIB_TBL_ENTRY(MIB_SUSER_PASSWORD,		CURRENT_SETTING,	"SUSER_PASSWORD",	STRING_T,	_OFFSET(suserPassword), 	_SIZE(suserPassword),		"admin"),
#else
MIB_TBL_ENTRY(MIB_SUSER_PASSWORD,		CURRENT_SETTING,	"SUSER_PASSWORD",	STRING_T,	_OFFSET(suserPassword), 	_SIZE(suserPassword),		"password"),
#endif
#endif
#endif
MIB_TBL_ENTRY(MIB_ADSL_TONE,	 	 	CURRENT_SETTING,	"ADSL_TONE",		BYTE_ARRAY_T,	_OFFSET(adslTone), 		_SIZE(adslTone),		"00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00"),    // Added by Mason Yu for correct Tone Mib Type
// ioctl for direct bridge mode, jiunming
MIB_TBL_ENTRY(MIB_DIRECT_BRIDGE_MODE,		CURRENT_SETTING,	"DIRECT_BRIDGE_MODE",	BYTE_T,		_OFFSET(DirectBridgeMode), 	_SIZE(DirectBridgeMode),	"1"),
MIB_TBL_ENTRY(MIB_ADSL_HIGH_INP,		CURRENT_SETTING,	"ADSL_HIGH_INP",	BYTE_T,		_OFFSET(adslHighInp), 		_SIZE(adslHighInp),		"0"),
#ifdef AUTO_PROVISIONING
// Jenny, configuration file version
MIB_TBL_ENTRY(MIB_CONFIG_VERSION,		CURRENT_SETTING,	"CONFIG_VERSION",	STRING_T,		_OFFSET(configFileVersion), 		_SIZE(configFileVersion),		"0.0.0"),
// Jenny, http server IP for auto-provisioning
MIB_TBL_ENTRY(MIB_HTTP_SERVER_IP,		CURRENT_SETTING,	"HTTP_SERVER_IP",	IA_T,		_OFFSET(httpServerIpAddr), 		_SIZE(httpServerIpAddr),		"192.168.1.6"),
#endif
#if 0
// Jenny, PPPoE AC MAC address
MIB_TBL_ENTRY(MIB_PPPOE_AC_MAC_ADDR,	CURRENT_SETTING,	"PPPOE_AC_MAC_ADDR",	BYTE6_T, 	_OFFSET(pppoeACMacAddr),	_SIZE(pppoeACMacAddr),		"000000000000"),
// Jenny,identifier for PPPoE session
MIB_TBL_ENTRY(MIB_PPPOE_SESSION,		CURRENT_SETTING,	"PPPOE_SESSION", 		WORD_T, 	_OFFSET(pppoeSession),		_SIZE(pppoeSession),		"0"),
#endif

#ifdef _CWMP_MIB_ /*jiunming, mib for cwmp-tr069*/
MIB_TBL_ENTRY(CWMP_PROVISIONINGCODE,		CURRENT_SETTING,	"CWMP_PROVISIONINGCODE",	STRING_T,		_OFFSET(cwmp_ProvisioningCode), 	_SIZE(cwmp_ProvisioningCode),	""),
MIB_TBL_ENTRY(CWMP_ACS_URL,			CURRENT_SETTING,	"CWMP_ACS_URL",			STRING_T,		_OFFSET(cwmp_ACSURL), 			_SIZE(cwmp_ACSURL),		"http://"),
MIB_TBL_ENTRY(CWMP_ACS_USERNAME,		CURRENT_SETTING,	"CWMP_ACS_USERNAME",		STRING_T,		_OFFSET(cwmp_ACSUserName), 		_SIZE(cwmp_ACSUserName),	"username"),
MIB_TBL_ENTRY(CWMP_ACS_PASSWORD,		CURRENT_SETTING,	"CWMP_ACS_PASSWORD",		STRING_T,		_OFFSET(cwmp_ACSPassword), 		_SIZE(cwmp_ACSPassword),	"password"),
MIB_TBL_ENTRY(CWMP_INFORM_ENABLE,		CURRENT_SETTING,	"CWMP_INFORM_ENABLE",		BYTE_T,			_OFFSET(cwmp_InformEnable), 		_SIZE(cwmp_InformEnable),	"1"),
MIB_TBL_ENTRY(CWMP_INFORM_INTERVAL,		CURRENT_SETTING,	"CWMP_INFORM_INTERVAL",		INTEGER_T,		_OFFSET(cwmp_InformInterval), 		_SIZE(cwmp_InformInterval),	"300"),
MIB_TBL_ENTRY(CWMP_INFORM_TIME,			CURRENT_SETTING,	"CWMP_INFORM_TIME",		INTEGER_T,		_OFFSET(cwmp_InformTime), 		_SIZE(cwmp_InformTime),		"0"),
MIB_TBL_ENTRY(CWMP_CONREQ_USERNAME,		CURRENT_SETTING,	"CWMP_CONREQ_USERNAME",		STRING_T,		_OFFSET(cwmp_ConnReqUserName), 		_SIZE(cwmp_ConnReqUserName),	""),
MIB_TBL_ENTRY(CWMP_CONREQ_PASSWORD,		CURRENT_SETTING,	"CWMP_CONREQ_PASSWORD",		STRING_T,		_OFFSET(cwmp_ConnReqPassword), 		_SIZE(cwmp_ConnReqPassword),	""),
MIB_TBL_ENTRY(CWMP_ACS_UPGRADESMANAGED,		CURRENT_SETTING,	"CWMP_ACS_UPGRADESMANAGED",	BYTE_T,			_OFFSET(cwmp_UpgradesManaged), 		_SIZE(cwmp_UpgradesManaged),	"1"),
MIB_TBL_ENTRY(CWMP_LAN_CONFIGPASSWD,		CURRENT_SETTING,	"CWMP_LAN_CONFIGPASSWD",	STRING_T,		_OFFSET(cwmp_LANConfPassword), 		_SIZE(cwmp_LANConfPassword),	""),
MIB_TBL_ENTRY(CWMP_SERIALNUMBER,		CURRENT_SETTING,	"CWMP_SERIALNUMBER",		STRING_T,		_OFFSET(cwmp_SerialNumber), 		_SIZE(cwmp_SerialNumber),	"00000001"),
MIB_TBL_ENTRY(CWMP_DHCP_SERVERCONF,		CURRENT_SETTING,	"CWMP_DHCP_SERVERCONF",		BYTE_T,			_OFFSET(cwmp_DHCP_ServerConf), 		_SIZE(cwmp_DHCP_ServerConf),	"1"),
MIB_TBL_ENTRY(CWMP_LAN_IPIFENABLE,		CURRENT_SETTING,	"CWMP_LAN_IPIFENABLE",		BYTE_T,			_OFFSET(cwmp_LAN_IPIFEnable), 		_SIZE(cwmp_LAN_IPIFEnable),	"1"),
MIB_TBL_ENTRY(CWMP_LAN_ETHIFENABLE,		CURRENT_SETTING,	"CWMP_LAN_ETHIFENABLE",		BYTE_T,			_OFFSET(cwmp_LAN_EthIFEnable), 		_SIZE(cwmp_LAN_EthIFEnable),	"1"),
MIB_TBL_ENTRY(CWMP_WLAN_BASICENCRY,		CURRENT_SETTING,	"CWMP_WLAN_BASICENCRY",		BYTE_T,			_OFFSET(cwmp_WLAN_BasicEncry), 		_SIZE(cwmp_WLAN_BasicEncry),	"0"),
MIB_TBL_ENTRY(CWMP_WLAN_WPAENCRY,		CURRENT_SETTING,	"CWMP_WLAN_WPAENCRY",		BYTE_T,			_OFFSET(cwmp_WLAN_WPAEncry), 		_SIZE(cwmp_WLAN_WPAEncry),	"0"),

MIB_TBL_ENTRY(CWMP_DL_COMMANDKEY,		CURRENT_SETTING,	"CWMP_DL_COMMANDKEY",		STRING_T,		_OFFSET(cwmp_DL_CommandKey), 		_SIZE(cwmp_DL_CommandKey),	""),
MIB_TBL_ENTRY(CWMP_DL_STARTTIME,		CURRENT_SETTING,	"CWMP_DL_STARTTIME",		INTEGER_T,		_OFFSET(cwmp_DL_StartTime), 		_SIZE(cwmp_DL_StartTime),	"0"),
MIB_TBL_ENTRY(CWMP_DL_COMPLETETIME,		CURRENT_SETTING,	"CWMP_DL_COMPLETETIME",		INTEGER_T,		_OFFSET(cwmp_DL_CompleteTime), 		_SIZE(cwmp_DL_CompleteTime),	"0"),
MIB_TBL_ENTRY(CWMP_DL_FAULTCODE,		CURRENT_SETTING,	"CWMP_DL_FAULTCODE",		INTEGER_T,		_OFFSET(cwmp_DL_FaultCode), 		_SIZE(cwmp_DL_FaultCode),	"0"),
MIB_TBL_ENTRY(CWMP_INFORM_EVENTCODE,		CURRENT_SETTING,	"CWMP_INFORM_EVENTCODE",	INTEGER_T,		_OFFSET(cwmp_Inform_EventCode), 	_SIZE(cwmp_Inform_EventCode),	"1"),
MIB_TBL_ENTRY(CWMP_RB_COMMANDKEY,		CURRENT_SETTING,	"CWMP_RB_COMMANDKEY",		STRING_T,		_OFFSET(cwmp_RB_CommandKey), 		_SIZE(cwmp_RB_CommandKey),	""),
MIB_TBL_ENTRY(CWMP_ACS_PARAMETERKEY,		CURRENT_SETTING,	"CWMP_ACS_PARAMETERKEY",	STRING_T,		_OFFSET(cwmp_ACS_ParameterKey), 	_SIZE(cwmp_ACS_ParameterKey),	""),
MIB_TBL_ENTRY(CWMP_CERT_PASSWORD,		CURRENT_SETTING,	"CWMP_CERT_PASSWORD",		STRING_T,		_OFFSET(cwmp_CERT_Password), 		_SIZE(cwmp_CERT_Password),	"client"),
#ifdef TELEFONICA_DEFAULT_CFG
MIB_TBL_ENTRY(CWMP_FLAG,			CURRENT_SETTING,	"CWMP_FLAG",			BYTE_T,			_OFFSET(cwmp_Flag), 			_SIZE(cwmp_Flag),		"80"),
#else
#ifndef CONFIG_GUI_WEB
			MIB_TBL_ENTRY(CWMP_FLAG,			CURRENT_SETTING,	"CWMP_FLAG",			BYTE_T,			_OFFSET(cwmp_Flag), 			_SIZE(cwmp_Flag),		"112"),
#else
MIB_TBL_ENTRY(CWMP_FLAG,			CURRENT_SETTING,	"CWMP_FLAG",			BYTE_T,			_OFFSET(cwmp_Flag), 			_SIZE(cwmp_Flag),		"80"),
#endif
#endif // of TELEFONICA_DEFAULT_CFG
#ifdef TELEFONICA_DEFAULT_CFG
MIB_TBL_ENTRY(CWMP_FLAG2,			CURRENT_SETTING,	"CWMP_FLAG2",			BYTE_T,			_OFFSET(cwmp_Flag2), 			_SIZE(cwmp_Flag2),		"2"),
#else
MIB_TBL_ENTRY(CWMP_FLAG2,			CURRENT_SETTING,	"CWMP_FLAG2",			BYTE_T,			_OFFSET(cwmp_Flag2), 			_SIZE(cwmp_Flag2),		"0"),
#endif // of TELEFONICA_DEFAULT_CFG

MIB_TBL_ENTRY(CWMP_SI_COMMANDKEY,		CURRENT_SETTING,	"CWMP_SI_COMMANDKEY",		STRING_T,		_OFFSET(cwmp_SI_CommandKey), 		_SIZE(cwmp_SI_CommandKey),	""),
#ifdef _PRMT_USERINTERFACE_
MIB_TBL_ENTRY(UIF_PW_REQUIRED,			CURRENT_SETTING,	"UIF_PW_REQUIRED",		BYTE_T,			_OFFSET(UIF_PW_Required), 		_SIZE(UIF_PW_Required),		"1"),
MIB_TBL_ENTRY(UIF_PW_USER_SEL,			CURRENT_SETTING,	"UIF_PW_USER_SEL",		BYTE_T,			_OFFSET(UIF_PW_User_Sel), 		_SIZE(UIF_PW_User_Sel),		"0"),
MIB_TBL_ENTRY(UIF_UPGRADE,			CURRENT_SETTING,	"UIF_UPGRADE",			BYTE_T,			_OFFSET(UIF_Upgrade), 			_SIZE(UIF_Upgrade),		"0"),
MIB_TBL_ENTRY(UIF_WARRANTYDATE,			CURRENT_SETTING,	"UIF_WARRANTYDATE",		INTEGER_T,		_OFFSET(UIF_WarrantyDate), 		_SIZE(UIF_WarrantyDate),	"0"),
MIB_TBL_ENTRY(UIF_AUTOUPDATESERVER,		CURRENT_SETTING,	"UIF_AUTOUPDATESERVER",		STRING_T,		_OFFSET(UIF_AutoUpdateServer), 		_SIZE(UIF_AutoUpdateServer),	""),
MIB_TBL_ENTRY(UIF_USERUPDATESERVER,		CURRENT_SETTING,	"UIF_USERUPDATESERVER",		STRING_T,		_OFFSET(UIF_UserUpdateServer), 		_SIZE(UIF_UserUpdateServer),	""),
#endif //#ifdef _PRMT_USERINTERFACE_
#ifdef  _PRMT_X_CT_COM_IPTV_
MIB_TBL_ENTRY(CWMP_CT_IPTV_IGMPENABLE,		CURRENT_SETTING,	"CWMP_CT_IPTV_IGMPENABLE",	BYTE_T,			_OFFSET(cwmp_CT_IPTV_IGMPEnable), 	_SIZE(cwmp_CT_IPTV_IGMPEnable),	"0"),
MIB_TBL_ENTRY(CWMP_CT_IPTV_STBNUMBER,		CURRENT_SETTING,	"CWMP_CT_IPTV_STBNUMBER",	INTEGER_T,		_OFFSET(cwmp_CT_IPTV_STBNumber), 	_SIZE(cwmp_CT_IPTV_STBNumber),	"0"),
#endif //#ifdef  _PRMT_X_CT_COM_IPTV_
#ifdef  _PRMT_X_CT_COM_RECON_
MIB_TBL_ENTRY(CWMP_CT_RECON_ENABLE,		CURRENT_SETTING,	"CWMP_CT_RECON_ENABLE",		BYTE_T,			_OFFSET(cwmp_CT_ReCon_Enable), 		_SIZE(cwmp_CT_ReCon_Enable),	"0"),
#endif //_PRMT_X_CT_COM_RECON_
#ifdef  _PRMT_X_CT_COM_MWBAND_
MIB_TBL_ENTRY(CWMP_CT_MWBAND_MODE,		CURRENT_SETTING,	"CWMP_CT_MWBAND_MODE",		INTEGER_T,		_OFFSET(cwmp_CT_MWBAND_Mode), 		_SIZE(cwmp_CT_MWBAND_Mode),	"1"),
MIB_TBL_ENTRY(CWMP_CT_MWBAND_STB_ENABLE,	CURRENT_SETTING,	"CWMP_CT_MWBAND_STB_ENABLE",	BYTE_T,			_OFFSET(cwmp_CT_MWBAND_STB_Enable), 	_SIZE(cwmp_CT_MWBAND_STB_Enable),"0"),
MIB_TBL_ENTRY(CWMP_CT_MWBAND_CMR_ENABLE,	CURRENT_SETTING,	"CWMP_CT_MWBAND_CMR_ENABLE",	BYTE_T,			_OFFSET(cwmp_CT_MWBAND_CMR_Enable), 	_SIZE(cwmp_CT_MWBAND_CMR_Enable),"0"),
MIB_TBL_ENTRY(CWMP_CT_MWBAND_PC_ENABLE,		CURRENT_SETTING,	"CWMP_CT_MWBAND_PC_ENABLE",	BYTE_T,			_OFFSET(cwmp_CT_MWBAND_PC_Enable), 	_SIZE(cwmp_CT_MWBAND_PC_Enable),"0"),
MIB_TBL_ENTRY(CWMP_CT_MWBAND_PHN_ENABLE,	CURRENT_SETTING,	"CWMP_CT_MWBAND_PHN_ENABLE",	BYTE_T,			_OFFSET(cwmp_CT_MWBAND_PHN_Enable), 	_SIZE(cwmp_CT_MWBAND_PHN_Enable),"0"),
MIB_TBL_ENTRY(CWMP_CT_MWBAND_NUMBER,		CURRENT_SETTING,	"CWMP_CT_MWBAND_NUMBER",	INTEGER_T,		_OFFSET(cwmp_CT_MWBAND_Number),		_SIZE(cwmp_CT_MWBAND_Number),	"1"),
MIB_TBL_ENTRY(CWMP_CT_MWBAND_STB_NUM,		CURRENT_SETTING,	"CWMP_CT_MWBAND_STB_NUM",	INTEGER_T,		_OFFSET(cwmp_CT_MWBAND_STB_Num),	_SIZE(cwmp_CT_MWBAND_STB_Num),	"0"),
MIB_TBL_ENTRY(CWMP_CT_MWBAND_CMR_NUM,		CURRENT_SETTING,	"CWMP_CT_MWBAND_CMR_NUM",	INTEGER_T,		_OFFSET(cwmp_CT_MWBAND_CMR_Num),	_SIZE(cwmp_CT_MWBAND_CMR_Num),	"0"),
MIB_TBL_ENTRY(CWMP_CT_MWBAND_PC_NUM,		CURRENT_SETTING,	"CWMP_CT_MWBAND_PC_NUM",	INTEGER_T,		_OFFSET(cwmp_CT_MWBAND_PC_Num),		_SIZE(cwmp_CT_MWBAND_PC_Num),	"1"),
MIB_TBL_ENTRY(CWMP_CT_MWBAND_PHN_NUM,		CURRENT_SETTING,	"CWMP_CT_MWBAND_PHN_NUM",	INTEGER_T,		_OFFSET(cwmp_CT_MWBAND_PHN_Num),	_SIZE(cwmp_CT_MWBAND_PHN_Num),	"0"),
#endif //#ifdef  _PRMT_X_CT_COM_MWBAND_
#ifdef _PRMT_X_CT_COM_PORTALMNT_
MIB_TBL_ENTRY(CWMP_CT_PM_ENABLE,		CURRENT_SETTING,	"CWMP_CT_PM_ENABLE",		BYTE_T,			_OFFSET(cwmp_CT_PM_Enable), 		_SIZE(cwmp_CT_PM_Enable),	"0"),
MIB_TBL_ENTRY(CWMP_CT_PM_URL4PC,		CURRENT_SETTING,	"CWMP_CT_PM_URL4PC",		STRING_T,		_OFFSET(cwmp_CT_PM_URL4PC), 		_SIZE(cwmp_CT_PM_URL4PC),	""),
MIB_TBL_ENTRY(CWMP_CT_PM_URL4STB,		CURRENT_SETTING,	"CWMP_CT_PM_URL4STB",		STRING_T,		_OFFSET(cwmp_CT_PM_URL4STB), 		_SIZE(cwmp_CT_PM_URL4STB),	""),
MIB_TBL_ENTRY(CWMP_CT_PM_URL4MOBILE,		CURRENT_SETTING,	"CWMP_CT_PM_URL4MOBILE",	STRING_T,		_OFFSET(cwmp_CT_PM_URL4MOBILE), 	_SIZE(cwmp_CT_PM_URL4MOBILE),	""),
#endif //_PRMT_X_CT_COM_PORTALMNT_

#if defined( _PRMT_X_CT_COM_DHCP_)||defined(IP_BASED_CLIENT_TYPE)
#if 1
MIB_TBL_ENTRY(CWMP_CT_PC_MINADDR,		CURRENT_SETTING,	"CWMP_CT_PC_MINADDR", 		IA_T,			_OFFSET(cwmp_CT_PC_MinAddr), 		_SIZE(cwmp_CT_PC_MinAddr),	"192.168.1.20"),
MIB_TBL_ENTRY(CWMP_CT_PC_MAXADDR,		CURRENT_SETTING,	"CWMP_CT_PC_MAXADDR", 		IA_T,			_OFFSET(cwmp_CT_PC_MaxAddr), 		_SIZE(cwmp_CT_PC_MaxAddr),	"192.168.1.29"),
MIB_TBL_ENTRY(CWMP_CT_CMR_MINADDR,		CURRENT_SETTING,	"CWMP_CT_CMR_MINADDR", 		IA_T,			_OFFSET(cwmp_CT_CMR_MinAddr), 		_SIZE(cwmp_CT_CMR_MinAddr),	"192.168.1.30"),
MIB_TBL_ENTRY(CWMP_CT_CMR_MAXADDR,		CURRENT_SETTING,	"CWMP_CT_CMR_MAXADDR", 		IA_T,			_OFFSET(cwmp_CT_CMR_MaxAddr), 		_SIZE(cwmp_CT_CMR_MaxAddr),	"192.168.1.39"),
MIB_TBL_ENTRY(CWMP_CT_STB_MINADDR,		CURRENT_SETTING,	"CWMP_CT_STB_MINADDR", 		IA_T,			_OFFSET(cwmp_CT_STB_MinAddr), 		_SIZE(cwmp_CT_STB_MinAddr),	"192.168.1.40"),
MIB_TBL_ENTRY(CWMP_CT_STB_MAXADDR,		CURRENT_SETTING,	"CWMP_CT_STB_MAXADDR", 		IA_T,			_OFFSET(cwmp_CT_STB_MaxAddr), 		_SIZE(cwmp_CT_STB_MaxAddr),	"192.168.1.49"),
MIB_TBL_ENTRY(CWMP_CT_PHN_MINADDR,		CURRENT_SETTING,	"CWMP_CT_PHN_MINADDR", 		IA_T,			_OFFSET(cwmp_CT_PHN_MinAddr), 		_SIZE(cwmp_CT_PHN_MinAddr),	"192.168.1.50"),
MIB_TBL_ENTRY(CWMP_CT_PHN_MAXADDR,		CURRENT_SETTING,	"CWMP_CT_PHN_MAXADDR", 		IA_T,			_OFFSET(cwmp_CT_PHN_MaxAddr), 		_SIZE(cwmp_CT_PHN_MaxAddr),	"192.168.1.59"),
MIB_TBL_ENTRY(CWMP_CT_HGW_MINADDR,	    CURRENT_SETTING,	"CWMP_CT_HGW_MINADDR", 	    IA_T, 	        _OFFSET(cwmp_CT_HGW_MinAddr), 	    _SIZE(cwmp_CT_HGW_MinAddr),	"192.168.1.60"),
MIB_TBL_ENTRY(CWMP_CT_HGW_MAXADDR,	    CURRENT_SETTING,	"CWMP_CT_HGW_MAXADDR", 	    IA_T, 	        _OFFSET(cwmp_CT_HGW_MaxAddr), 	    _SIZE(cwmp_CT_HGW_MaxAddr),	"192.168.1.69"),
#else
MIB_TBL_ENTRY(CWMP_CT_PC_MINADDR,	CURRENT_SETTING,	"CWMP_CT_PC_MINADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_PC_MinAddr), 	_SIZE(cwmp_CT_PC_MinAddr),		"20"),
MIB_TBL_ENTRY(CWMP_CT_PC_MAXADDR,	CURRENT_SETTING,	"CWMP_CT_PC_MAXADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_PC_MaxAddr), 	_SIZE(cwmp_CT_PC_MaxAddr),		"29"),
MIB_TBL_ENTRY(CWMP_CT_CMR_MINADDR,	CURRENT_SETTING,	"CWMP_CT_CMR_MINADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_CMR_MinAddr), 	_SIZE(cwmp_CT_CMR_MinAddr),		"30"),
MIB_TBL_ENTRY(CWMP_CT_CMR_MAXADDR,	CURRENT_SETTING,	"CWMP_CT_CMR_MAXADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_CMR_MaxAddr), 	_SIZE(cwmp_CT_CMR_MaxAddr),		"39"),
MIB_TBL_ENTRY(CWMP_CT_STB_MINADDR,	CURRENT_SETTING,	"CWMP_CT_STB_MINADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_STB_MinAddr), 	_SIZE(cwmp_CT_STB_MinAddr),		"40"),
MIB_TBL_ENTRY(CWMP_CT_STB_MAXADDR,	CURRENT_SETTING,	"CWMP_CT_STB_MAXADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_STB_MaxAddr), 	_SIZE(cwmp_CT_STB_MaxAddr),		"49"),
MIB_TBL_ENTRY(CWMP_CT_PHN_MINADDR,	CURRENT_SETTING,	"CWMP_CT_PHN_MINADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_PHN_MinAddr), 	_SIZE(cwmp_CT_PHN_MinAddr),		"50"),
MIB_TBL_ENTRY(CWMP_CT_PHN_MAXADDR,	CURRENT_SETTING,	"CWMP_CT_PHN_MAXADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_PHN_MaxAddr), 	_SIZE(cwmp_CT_PHN_MaxAddr),		"59"),
MIB_TBL_ENTRY(CWMP_CT_HGW_MINADDR,	CURRENT_SETTING,	"CWMP_CT_HGW_MINADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_HGW_MinAddr), 	_SIZE(cwmp_CT_HGW_MinAddr),		"60"),
MIB_TBL_ENTRY(CWMP_CT_HGW_MAXADDR,	CURRENT_SETTING,	"CWMP_CT_HGW_MAXADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_HGW_MaxAddr), 	_SIZE(cwmp_CT_HGW_MaxAddr),		"69"),
#endif
#endif //_PRMT_X_CT_COM_DHCP_
#ifdef  _PRMT_X_CT_COM_MONITOR_
MIB_TBL_ENTRY(CWMP_CT_MNT_ENABLE,		CURRENT_SETTING,	"CWMP_CT_MNT_ENABLE",		BYTE_T,			_OFFSET(cwmp_CT_MNT_Enable), 		_SIZE(cwmp_CT_MNT_Enable),	"0"),
MIB_TBL_ENTRY(CWMP_CT_MNT_NUMBER,		CURRENT_SETTING,	"CWMP_CT_MNT_NUMBER",		INTEGER_T,		_OFFSET(cwmp_CT_MNT_Number), 		_SIZE(cwmp_CT_MNT_Number),	"1"),
#endif //#ifdef  _PRMT_X_CT_COM_MONITOR_
#ifdef  _PRMT_X_CT_COM_VPDN_
MIB_TBL_ENTRY(CWMP_CT_VPDN_ENABLE,		CURRENT_SETTING,	"CWMP_CT_VPDN_ENABLE",		BYTE_T,			_OFFSET(cwmp_CT_VPDN_Enable), 		_SIZE(cwmp_CT_VPDN_Enable),	"0"),
#endif //#ifdef  _PRMT_X_CT_COM_VPDN_
MIB_TBL_ENTRY(CWMP_ACS_KICKURL,			CURRENT_SETTING,	"CWMP_ACS_KICKURL",		STRING_T,		_OFFSET(cwmp_ACS_KickURL), 		_SIZE(cwmp_ACS_KickURL),	""),
MIB_TBL_ENTRY(CWMP_ACS_DOWNLOADURL,		CURRENT_SETTING,	"CWMP_ACS_DOWNLOADURL",		STRING_T,		_OFFSET(cwmp_ACS_DownloadURL), 		_SIZE(cwmp_ACS_DownloadURL),	""),
MIB_TBL_ENTRY(CWMP_CONREQ_PORT,			CURRENT_SETTING,	"CWMP_CONREQ_PORT",		INTEGER_T,		_OFFSET(cwmp_ConnReqPort), 		_SIZE(cwmp_ConnReqPort),	"7547"),
MIB_TBL_ENTRY(CWMP_CONREQ_PATH,			CURRENT_SETTING,	"CWMP_CONREQ_PATH",		STRING_T,		_OFFSET(cwmp_ConnReqPath), 		_SIZE(cwmp_ConnReqPath),	"/tr069"),
#ifdef _PRMT_TR143_
MIB_TBL_ENTRY(TR143_UDPECHO_ENABLE,		CURRENT_SETTING,	"TR143_UDPECHO_ENABLE",		BYTE_T,			_OFFSET(tr143_udpecho_enable), 		_SIZE(tr143_udpecho_enable),	"0"),
MIB_TBL_ENTRY(TR143_UDPECHO_ITFTYPE,		CURRENT_SETTING,	"TR143_UDPECHO_ITFTYPE",	BYTE_T,			_OFFSET(tr143_udpecho_itftype),		_SIZE(tr143_udpecho_itftype),	"0"),
MIB_TBL_ENTRY(TR143_UDPECHO_SRCIP,		CURRENT_SETTING,	"TR143_UDPECHO_SRCIP",		IA_T,			_OFFSET(tr143_udpecho_srcip), 		_SIZE(tr143_udpecho_srcip),	"0.0.0.0"),
MIB_TBL_ENTRY(TR143_UDPECHO_PORT,		CURRENT_SETTING,	"TR143_UDPECHO_PORT",		WORD_T,			_OFFSET(tr143_udpecho_port), 		_SIZE(tr143_udpecho_port),	"0"),
MIB_TBL_ENTRY(TR143_UDPECHO_PLUS,		CURRENT_SETTING,	"TR143_UDPECHO_PLUS",		BYTE_T,			_OFFSET(tr143_udpecho_plus), 		_SIZE(tr143_udpecho_plus),	"0"),
#endif //_PRMT_TR143_
#else/*_CWMP_MIB_*/
#if defined( _PRMT_X_CT_COM_DHCP_)||defined(IP_BASED_CLIENT_TYPE)
#if 1
MIB_TBL_ENTRY(CWMP_CT_PC_MINADDR,		CURRENT_SETTING,	"CWMP_CT_PC_MINADDR", 		IA_T,			_OFFSET(cwmp_CT_PC_MinAddr), 		_SIZE(cwmp_CT_PC_MinAddr),	"192.168.1.20"),
MIB_TBL_ENTRY(CWMP_CT_PC_MAXADDR,		CURRENT_SETTING,	"CWMP_CT_PC_MAXADDR", 		IA_T,			_OFFSET(cwmp_CT_PC_MaxAddr), 		_SIZE(cwmp_CT_PC_MaxAddr),	"192.168.1.29"),
MIB_TBL_ENTRY(CWMP_CT_CMR_MINADDR,		CURRENT_SETTING,	"CWMP_CT_CMR_MINADDR", 		IA_T,			_OFFSET(cwmp_CT_CMR_MinAddr), 		_SIZE(cwmp_CT_CMR_MinAddr),	"192.168.1.30"),
MIB_TBL_ENTRY(CWMP_CT_CMR_MAXADDR,		CURRENT_SETTING,	"CWMP_CT_CMR_MAXADDR", 		IA_T,			_OFFSET(cwmp_CT_CMR_MaxAddr), 		_SIZE(cwmp_CT_CMR_MaxAddr),	"192.168.1.39"),
MIB_TBL_ENTRY(CWMP_CT_STB_MINADDR,		CURRENT_SETTING,	"CWMP_CT_STB_MINADDR", 		IA_T,			_OFFSET(cwmp_CT_STB_MinAddr), 		_SIZE(cwmp_CT_STB_MinAddr),	"192.168.1.40"),
MIB_TBL_ENTRY(CWMP_CT_STB_MAXADDR,		CURRENT_SETTING,	"CWMP_CT_STB_MAXADDR", 		IA_T,			_OFFSET(cwmp_CT_STB_MaxAddr), 		_SIZE(cwmp_CT_STB_MaxAddr),	"192.168.1.49"),
MIB_TBL_ENTRY(CWMP_CT_PHN_MINADDR,		CURRENT_SETTING,	"CWMP_CT_PHN_MINADDR", 		IA_T,			_OFFSET(cwmp_CT_PHN_MinAddr), 		_SIZE(cwmp_CT_PHN_MinAddr),	"192.168.1.50"),
MIB_TBL_ENTRY(CWMP_CT_PHN_MAXADDR,		CURRENT_SETTING,	"CWMP_CT_PHN_MAXADDR", 		IA_T,			_OFFSET(cwmp_CT_PHN_MaxAddr), 		_SIZE(cwmp_CT_PHN_MaxAddr),	"192.168.1.59"),
MIB_TBL_ENTRY(CWMP_CT_HGW_MINADDR,	    CURRENT_SETTING,	"CWMP_CT_HGW_MINADDR", 	    IA_T, 	        _OFFSET(cwmp_CT_HGW_MinAddr), 	    _SIZE(cwmp_CT_HGW_MinAddr),	"192.168.1.60"),
MIB_TBL_ENTRY(CWMP_CT_HGW_MAXADDR,	    CURRENT_SETTING,	"CWMP_CT_HGW_MAXADDR", 	    IA_T, 	        _OFFSET(cwmp_CT_HGW_MaxAddr), 	    _SIZE(cwmp_CT_HGW_MaxAddr),	"192.168.1.69"),
#else
MIB_TBL_ENTRY(CWMP_CT_PC_MINADDR,	CURRENT_SETTING,	"CWMP_CT_PC_MINADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_PC_MinAddr), 	_SIZE(cwmp_CT_PC_MinAddr),		"20"),
MIB_TBL_ENTRY(CWMP_CT_PC_MAXADDR,	CURRENT_SETTING,	"CWMP_CT_PC_MAXADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_PC_MaxAddr), 	_SIZE(cwmp_CT_PC_MaxAddr),		"29"),
MIB_TBL_ENTRY(CWMP_CT_CMR_MINADDR,	CURRENT_SETTING,	"CWMP_CT_CMR_MINADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_CMR_MinAddr), 	_SIZE(cwmp_CT_CMR_MinAddr),		"30"),
MIB_TBL_ENTRY(CWMP_CT_CMR_MAXADDR,	CURRENT_SETTING,	"CWMP_CT_CMR_MAXADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_CMR_MaxAddr), 	_SIZE(cwmp_CT_CMR_MaxAddr),		"39"),
MIB_TBL_ENTRY(CWMP_CT_STB_MINADDR,	CURRENT_SETTING,	"CWMP_CT_STB_MINADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_STB_MinAddr), 	_SIZE(cwmp_CT_STB_MinAddr),		"40"),
MIB_TBL_ENTRY(CWMP_CT_STB_MAXADDR,	CURRENT_SETTING,	"CWMP_CT_STB_MAXADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_STB_MaxAddr), 	_SIZE(cwmp_CT_STB_MaxAddr),		"49"),
MIB_TBL_ENTRY(CWMP_CT_PHN_MINADDR,	CURRENT_SETTING,	"CWMP_CT_PHN_MINADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_PHN_MinAddr), 	_SIZE(cwmp_CT_PHN_MinAddr),		"50"),
MIB_TBL_ENTRY(CWMP_CT_PHN_MAXADDR,	CURRENT_SETTING,	"CWMP_CT_PHN_MAXADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_PHN_MaxAddr), 	_SIZE(cwmp_CT_PHN_MaxAddr),		"59"),
MIB_TBL_ENTRY(CWMP_CT_HGW_MINADDR,	CURRENT_SETTING,	"CWMP_CT_HGW_MINADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_HGW_MinAddr), 	_SIZE(cwmp_CT_HGW_MinAddr),		"60"),
MIB_TBL_ENTRY(CWMP_CT_HGW_MAXADDR,	CURRENT_SETTING,	"CWMP_CT_HGW_MAXADDR", 	BYTE_T, 	_OFFSET(cwmp_CT_HGW_MaxAddr), 	_SIZE(cwmp_CT_HGW_MaxAddr),		"69"),
#endif
#endif //_PRMT_X_CT_COM_DHCP_
#endif

//for log
#ifndef CONFIG_GUI_WEB
MIB_TBL_ENTRY(MIB_SYSLOG,			CURRENT_SETTING,	"SYSLOG",			BYTE_T,			_OFFSET(syslog), 			_SIZE(syslog),			"0"),
#else
MIB_TBL_ENTRY(MIB_SYSLOG,			CURRENT_SETTING,	"SYSLOG",			BYTE_T,			_OFFSET(syslog), 			_SIZE(syslog),			"1"),
#endif
#ifdef CONFIG_8M_SDRAM
MIB_TBL_ENTRY(MIB_MAXLOGLEN,			CURRENT_SETTING,	"MAXLOGLEN",			INTEGER_T,		_OFFSET(maxmsglen), 			_SIZE(maxmsglen),		"8000"),
#else
MIB_TBL_ENTRY(MIB_MAXLOGLEN,			CURRENT_SETTING,	"MAXLOGLEN",			INTEGER_T,		_OFFSET(maxmsglen), 			_SIZE(maxmsglen),		"16384"),
#endif
MIB_TBL_ENTRY(MIB_ADSL_DEBUG,			CURRENT_SETTING,	"ADSLDBG",			BYTE_T,			_OFFSET(adsldbg), 			_SIZE(adsldbg),			"0"),
MIB_TBL_ENTRY(MIB_ETH_MAC_CTRL,			CURRENT_SETTING,	"MIB_ETH_MAC_CTRL",		BYTE_T,			_OFFSET(eth_mac_ctrl), 			_SIZE(eth_mac_ctrl),		"0"),
MIB_TBL_ENTRY(MIB_WLAN_MAC_CTRL,		CURRENT_SETTING,	"MIB_WLAN_MAC_CTRL",		BYTE_T,			_OFFSET(wlan_mac_ctrl), 		_SIZE(wlan_mac_ctrl),		"0"),

#ifdef DOS_SUPPORT
MIB_TBL_ENTRY(MIB_DOS_ENABLED,		CURRENT_SETTING,	"DOS_ENABLED",		INTEGER_T,	_OFFSET(dos_enable),		_SIZE(dos_enable),		"0"),
MIB_TBL_ENTRY(MIB_DOS_SYSSYN_FLOOD,	CURRENT_SETTING,	"DOS_SYSSYN_FLOOD",	INTEGER_T,	_OFFSET(dos_syssyn_flood), 	_SIZE(dos_syssyn_flood),		"100"),
MIB_TBL_ENTRY(MIB_DOS_SYSFIN_FLOOD,	CURRENT_SETTING,	"DOS_SYSFIN_FLOOD",	INTEGER_T,	_OFFSET(dos_sysfin_flood), 	_SIZE(dos_sysfin_flood),		"100"),
MIB_TBL_ENTRY(MIB_DOS_SYSUDP_FLOOD,	CURRENT_SETTING,	"DOS_SYSUDP_FLOOD",	INTEGER_T,	_OFFSET(dos_sysudp_flood), 	_SIZE(dos_sysfin_flood),		"100"),
MIB_TBL_ENTRY(MIB_DOS_SYSICMP_FLOOD,	CURRENT_SETTING,	"DOS_SYSICMP_FLOOD",	INTEGER_T,	_OFFSET(dos_sysicmp_flood), 	_SIZE(dos_sysfin_flood),		"100"),
MIB_TBL_ENTRY(MIB_DOS_PIPSYN_FLOOD,	CURRENT_SETTING,	"DOS_PIPSYN_FLOOD",	INTEGER_T,	_OFFSET(dos_pipsyn_flood), 	_SIZE(dos_sysfin_flood),		"100"),
MIB_TBL_ENTRY(MIB_DOS_PIPFIN_FLOOD,	CURRENT_SETTING,	"DOS_PIPFIN_FLOOD",	INTEGER_T,	_OFFSET(dos_pipfin_flood), 	_SIZE(dos_sysfin_flood),		"100"),
MIB_TBL_ENTRY(MIB_DOS_PIPUDP_FLOOD,	CURRENT_SETTING,	"DOS_PIPUDP_FLOOD",	INTEGER_T,	_OFFSET(dos_pipudp_flood), 	_SIZE(dos_sysfin_flood),		"100"),
MIB_TBL_ENTRY(MIB_DOS_PIPICMP_FLOOD,	CURRENT_SETTING,	"DOS_PIPICMP_FLOOD",	INTEGER_T,	_OFFSET(dos_pipicmp_flood), 	_SIZE(dos_sysfin_flood),		"100"),
MIB_TBL_ENTRY(MIB_DOS_BLOCK_TIME,	CURRENT_SETTING,	"DOS_BLOCK_TIME",	INTEGER_T,	_OFFSET(dos_block_time), 	_SIZE(dos_sysfin_flood),		"300"),
#endif

#ifdef CONFIG_WIFI_SIMPLE_CONFIG //WPS
MIB_TBL_ENTRY(MIB_WSC_DISABLE,		CURRENT_SETTING,"WSC_DISABLE",		BYTE_T,		_OFFSET(wscDisable), _SIZE(wscDisable), "0"),
MIB_TBL_ENTRY(MIB_WSC_METHOD,		CURRENT_SETTING,"WSC_METHOD",		BYTE_T,		_OFFSET(wscMethod), _SIZE(wscMethod), "3"),
MIB_TBL_ENTRY(MIB_WSC_CONFIGURED,	CURRENT_SETTING,"WSC_CONFIGURED",	BYTE_T,		_OFFSET(wscConfigured), _SIZE(wscConfigured), "0"),
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
//xl_yue:create a random PIN in WPS_updateWscConf();
MIB_TBL_ENTRY(MIB_WSC_PIN,			CURRENT_SETTING,"WSC_PIN",			STRING_T,	_OFFSET(wscPin), _SIZE(wscPin), "\0"),
#else
MIB_TBL_ENTRY(MIB_WSC_PIN,			CURRENT_SETTING,"WSC_PIN",			STRING_T,	_OFFSET(wscPin), _SIZE(wscPin), "12345670"),
#endif
MIB_TBL_ENTRY(MIB_WSC_AUTH,			CURRENT_SETTING,"WSC_AUTH",			BYTE_T,		_OFFSET(wscAuth), _SIZE(wscAuth), "1"),
MIB_TBL_ENTRY(MIB_WSC_ENC,			CURRENT_SETTING,"WSC_ENC",			BYTE_T,		_OFFSET(wscEnc), _SIZE(wscEnc), "1"),
MIB_TBL_ENTRY(MIB_WSC_MANUAL_ENABLED, CURRENT_SETTING,"WSC_MANUAL_ENABLED",	BYTE_T,	_OFFSET(wscManualEnabled), _SIZE(wscManualEnabled), "0"),
MIB_TBL_ENTRY(MIB_WSC_UPNP_ENABLED,CURRENT_SETTING, "WSC_UPNP_ENABLED",	BYTE_T,	_OFFSET(wscUpnpEnabled), _SIZE(wscUpnpEnabled), "1"),
MIB_TBL_ENTRY(MIB_WSC_REGISTRAR_ENABLED, CURRENT_SETTING,"WSC_REGISTRAR_ENABLED",	BYTE_T,	_OFFSET(wscRegistrarEnabled), _SIZE(wscRegistrarEnabled), "0"),
MIB_TBL_ENTRY(MIB_WSC_PSK,			CURRENT_SETTING,"WSC_PSK",			STRING_T,		_OFFSET(wscPsk), _SIZE(wscPsk), "0"),
MIB_TBL_ENTRY(MIB_WSC_SSID,			CURRENT_SETTING,"WSC_SSID",			STRING_T,		_OFFSET(wscSsid), _SIZE(wscSsid), "0"),
MIB_TBL_ENTRY(MIB_WSC_CONFIG_BY_EXT_REG,		CURRENT_SETTING,"WSC_CONFIGBYEXTREG",	BYTE_T,		_OFFSET(wscConfigByExtReg), _SIZE(wscConfigByExtReg), "0"),
#endif

MIB_TBL_ENTRY(MIB_ADSL_LAN_DHCP_GATEWAY,	CURRENT_SETTING,	"LAN_DHCP_GATEWAY", 		IA_T,			_OFFSET(dhcp_GatewayAddr), 		_SIZE(dhcp_GatewayAddr),	"192.168.10.1"),
#ifdef WLAN_MBSSID
MIB_TBL_ENTRY(MIB_WLAN_VAP0_ITF_GROUP,		CURRENT_SETTING,	"WLAN_VAP0_ITF_GROUP",		BYTE_T,			_OFFSET(itfGroupVap0),			_SIZE(itfGroupVap0),		"0"),
MIB_TBL_ENTRY(MIB_WLAN_VAP1_ITF_GROUP,		CURRENT_SETTING,	"WLAN_VAP1_ITF_GROUP",		BYTE_T,			_OFFSET(itfGroupVap1),			_SIZE(itfGroupVap1),		"0"),
MIB_TBL_ENTRY(MIB_WLAN_VAP2_ITF_GROUP,		CURRENT_SETTING,	"WLAN_VAP2_ITF_GROUP",		BYTE_T,			_OFFSET(itfGroupVap2),			_SIZE(itfGroupVap2),		"0"),
MIB_TBL_ENTRY(MIB_WLAN_VAP3_ITF_GROUP,		CURRENT_SETTING,	"WLAN_VAP3_ITF_GROUP",		BYTE_T,			_OFFSET(itfGroupVap3),			_SIZE(itfGroupVap3),		"0"),
#endif
#ifdef CTC_TELECOM_ACCOUNT
MIB_TBL_ENTRY(MIB_CTC_ACCOUNT_ENABLE,		CURRENT_SETTING,	"MIB_CTC_ACCOUNT_ENABLE",	BYTE_T,			_OFFSET(CTCAccountEnable),		_SIZE(CTCAccountEnable),	"1"),
#endif //CTC_TELECOM_ACCOUNT
//added by xl_yue
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
MIB_TBL_ENTRY(MIB_WLAN_COUNTRY_AREA,		CURRENT_SETTING,	"MIB_WLAN_COUNTRY_AREA",	BYTE_T,			_OFFSET(WlanCountryOrArea),	_SIZE(WlanCountryOrArea),	"0"),
MIB_TBL_ENTRY(MIB_WLAN_REG_DOMAIN, 			CURRENT_SETTING,	"WLAN_REG_DOMAIN",		BYTE_T, 			_OFFSET(WlanRegDomain),		_SIZE(WlanRegDomain),		"1"),
#endif
#ifdef IP_QOS
MIB_TBL_ENTRY(MIB_8021P_PRIO,		CURRENT_SETTING,	"8021P_PRIO",		BYTE_ARRAY_T,		_OFFSET(set8021p_prio),		_SIZE(set8021p_prio),		"02 03 03 02 01 01 00 00"),
MIB_TBL_ENTRY(MIB_PRED_PRIO,		CURRENT_SETTING,	"PRED_PRIO",			BYTE_ARRAY_T,		_OFFSET(setpred_prio),		_SIZE(setpred_prio),		"02 03 03 02 01 01 00 00"),
#endif
//add by ramen for the ALG on-off
#ifdef CONFIG_IP_NF_ALG_ONOFF
#ifdef CONFIG_IP_NF_FTP
MIB_TBL_ENTRY(MIB_IP_ALG_FTP,		CURRENT_SETTING,	"MIB_IP_ALG_FTP",	BYTE_T,	_OFFSET(ipAlgFTP),	_SIZE(ipAlgFTP),	"1"),
#endif
#ifdef CONFIG_IP_NF_H323
MIB_TBL_ENTRY(MIB_IP_ALG_H323,		CURRENT_SETTING,	"MIB_IP_ALG_H323",	BYTE_T,	_OFFSET(ipAlgH323),	_SIZE(ipAlgH323),	"1"),
#endif
#ifdef CONFIG_IP_NF_IRC
MIB_TBL_ENTRY(MIB_IP_ALG_IRC,		CURRENT_SETTING,	"MIB_IP_ALG_IRC",	BYTE_T,	_OFFSET(ipAlgIRC),	_SIZE(ipAlgIRC),	"1"),
#endif
#ifdef CONFIG_IP_NF_RTSP
MIB_TBL_ENTRY(MIB_IP_ALG_RTSP,		CURRENT_SETTING,	"MIB_IP_ALG_RTSP",	BYTE_T,	_OFFSET(ipAlgRTSP),	_SIZE(ipAlgRTSP),	"1"),
#endif
#ifdef CONFIG_IP_NF_QUAKE3
MIB_TBL_ENTRY(MIB_IP_ALG_QUAKE3,		CURRENT_SETTING,	"MIB_IP_ALG_QUAKE3",	BYTE_T,	_OFFSET(ipAlgQUAKE3),	_SIZE(ipAlgQUAKE3),	"1"),
#endif
#ifdef CONFIG_IP_NF_CUSEEME
MIB_TBL_ENTRY(MIB_IP_ALG_CUSEEME,		CURRENT_SETTING,	"MIB_IP_ALG_CUSEEME",	BYTE_T,	_OFFSET(ipAlgCUSEEME),	_SIZE(ipAlgCUSEEME),	"1"),
#endif
#ifdef CONFIG_IP_NF_L2TP
MIB_TBL_ENTRY(MIB_IP_ALG_L2TP,		CURRENT_SETTING,	"MIB_IP_ALG_L2TP",	BYTE_T,	_OFFSET(ipAlgL2TP),	_SIZE(ipAlgL2TP),	"1"),
#endif
#ifdef CONFIG_IP_NF_IPSEC
MIB_TBL_ENTRY(MIB_IP_ALG_IPSEC,CURRENT_SETTING,	"MIB_IP_ALG_IPSEC",	BYTE_T,	_OFFSET(ipAlgIPSEC),	_SIZE(ipAlgIPSEC),	"1"),
#endif
#ifdef CONFIG_IP_NF_SIP
MIB_TBL_ENTRY(MIB_IP_ALG_SIP,		CURRENT_SETTING,	"MIB_IP_ALG_SIP",	BYTE_T,	_OFFSET(ipAlgSIP),	_SIZE(ipAlgSIP),	"1"),
#endif
#ifdef CONFIG_IP_NF_PPTP
MIB_TBL_ENTRY(MIB_IP_ALG_PPTP,		CURRENT_SETTING,	"MIB_IP_ALG_PPTP",	BYTE_T,	_OFFSET(ipAlgPPTP),	_SIZE(ipAlgPPTP),	"1"),
#endif
#endif
//add by ramen for DNS bind pvc
#ifdef DNS_BIND_PVC_SUPPORT
MIB_TBL_ENTRY(MIB_DNS_BIND_PVC_ENABLE,		CURRENT_SETTING,	"MIB_DNS_BIND_ENABLE",	BYTE_T,	_OFFSET(dns1PvcEnable),	_SIZE(dns1PvcEnable),	"0"),
MIB_TBL_ENTRY(MIB_DNS_BIND_PVC1,		CURRENT_SETTING,	"MIB_DNS_BIND_PVC1",	BYTE_T,	_OFFSET(dns1PvcIfIndex),	_SIZE(dns1PvcIfIndex),	"255"),
MIB_TBL_ENTRY(MIB_DNS_BIND_PVC2,		CURRENT_SETTING,	"MIB_DNS_BIND_PVC2",	BYTE_T,	_OFFSET(dns2PvcIfIndex),	_SIZE(dns2PvcIfIndex),	"255"),
MIB_TBL_ENTRY(MIB_DNS_BIND_PVC3,		CURRENT_SETTING,	"MIB_DNS_BIND_PVC3",	BYTE_T,	_OFFSET(dns3PvcIfIndex),	_SIZE(dns3PvcIfIndex),	"255"),
#endif
//alex for 802.1P
#ifdef QOS_SPEED_LIMIT_SUPPORT
MIB_TBL_ENTRY(MIB_PVC_TOTAL_BANDWIDTH,CURRENT_SETTING,	"MIB_PVC_TOTAL_BANDWIDTH",	WORD_T,	_OFFSET(upbandwidth),	_SIZE(upbandwidth),	"0"),
#endif

#ifdef ADDRESS_MAPPING
#ifndef MULTI_ADDRESS_MAPPING
MIB_TBL_ENTRY(MIB_ADDRESS_MAP_TYPE,		CURRENT_SETTING,	"ADDRESS_MAP_TYPE",		BYTE_T,			_OFFSET(addressMapType),		_SIZE(addressMapType),		"0"),
MIB_TBL_ENTRY(MIB_LOCAL_START_IP,		CURRENT_SETTING,	"LOCAL_START_IP",		IA_T,			_OFFSET(lsip), 				_SIZE(lsip),			"192.168.10.101"),
MIB_TBL_ENTRY(MIB_LOCAL_END_IP,			CURRENT_SETTING,	"LOCAL_END_IP",			IA_T,			_OFFSET(leip), 				_SIZE(leip),			"192.168.10.200"),
MIB_TBL_ENTRY(MIB_GLOBAL_START_IP,		CURRENT_SETTING,	"GLOBAL_START_IP",		IA_T,			_OFFSET(gsip), 				_SIZE(gsip),			"172.19.30.2"),
MIB_TBL_ENTRY(MIB_GLOBAL_END_IP,		CURRENT_SETTING,	"GLOBAL_END_IP",		IA_T,			_OFFSET(geip), 				_SIZE(geip),			"172.19.30.250"),
#endif //end of !MULTI_ADDRESS_MAPPING
#endif
#if defined(ZTE_531B_BRIDGE_SC)||defined(ZTE_GENERAL_ROUTER_SC)
MIB_TBL_ENTRY(MIB_REFRESH_TIME,			CURRENT_SETTING,	"REFRESH_TIME_INTERV",	WORD_T,			_OFFSET(rfTime),			_SIZE(rfTime),			"15"),
#endif
#ifdef MIB_WLAN_RESTART_SUPPORT
MIB_TBL_ENTRY(MIB_WLAN_RESTART,			CURRENT_SETTING,	"MIB_WLAN_RESTART",	BYTE_T,			_OFFSET(restartwlan),			_SIZE(restartwlan),			"0"),
#endif
#if defined(ZTE_531B_BRIDGE_SC)||defined(ZTE_GENERAL_ROUTER_SC)
MIB_TBL_ENTRY(MIB_SNMP_AUTORUN,			CURRENT_SETTING,	"MIB_SNMP_AUTORUN",	BYTE_T,			_OFFSET(snmpautorun),			_SIZE(snmpautorun),			"0"),
MIB_TBL_ENTRY(MIB_CWMP_AUTORUN,			CURRENT_SETTING,	"MIB_CWMP_AUTORUN",	BYTE_T,			_OFFSET(cwmpautorun),			_SIZE(cwmpautorun),			"0"),
#endif

#ifndef CONFIG_EXT_SWITCH 
#ifdef ELAN_LINK_MODE_INTRENAL_PHY
MIB_TBL_ENTRY(MIB_ETH_MODE,		CURRENT_SETTING,	"MIB_ETH_MODE",			BYTE_T,		_OFFSET(ethMode),	_SIZE(ethMode), "4"),
#endif
#endif 
	
#ifdef SYSLOG_SUPPORT
#ifdef SEND_LOG
MIB_TBL_ENTRY(MIB_LOG_SERVER_IP,		CURRENT_SETTING,	"LOG_SERVER_IP", 		IA_T,		_OFFSET(logServer), 		_SIZE(logServer),			"172.21.1.10"),
MIB_TBL_ENTRY(MIB_LOG_SERVER_NAME,		CURRENT_SETTING,	"LOG_SERVER_NAME",		STRING_T,	_OFFSET(logNmae), 		_SIZE(logNmae),				"log"),
MIB_TBL_ENTRY(MIB_LOG_SERVER_PASSWORD,		CURRENT_SETTING,	"SERVER_PASSWORD",		STRING_T,	_OFFSET(logPassword), 		_SIZE(logPassword),			"1234"),
#endif
#endif
//#ifdef QSETUP_WEB_REDIRECT
//MIB_TBL_ENTRY(MIB_QSETUP_REDIRECT,		CURRENT_SETTING,	"MIB_QSETUP_REDIRECT",			BYTE_T,		_OFFSET(startRedirect),	_SIZE(startRedirect), "0"),
//#endif

#ifdef CONFIG_USER_SNMPD_SNMPD_V2CTRAP
MIB_TBL_ENTRY(MIB_SNMPD_ENABLE,			CURRENT_SETTING,	"SNMPD_ENABLE",		BYTE_T,		_OFFSET(snmpdEnabled), 		_SIZE(snmpdEnabled),		"1"),
#endif
#ifdef TCP_UDP_CONN_LIMIT
MIB_TBL_ENTRY(MIB_CONNLIMIT_ENABLE,			CURRENT_SETTING,	"CONNLIMIT_ENABLE",		BYTE_T,		_OFFSET(connlimitEn), 	_SIZE(connlimitEn),		"0"),
MIB_TBL_ENTRY(MIB_CONNLIMIT_UDP,			CURRENT_SETTING,	"CONNLIMIT_UDP",		INTEGER_T,		_OFFSET(connlimitUdp), 		_SIZE(connlimitUdp),		"0"),
MIB_TBL_ENTRY(MIB_CONNLIMIT_TCP,			CURRENT_SETTING,	"CONNLIMIT_TCP",		INTEGER_T,		_OFFSET(connlimitTcp), 		_SIZE(connlimitTcp),		"0"),
#endif

#ifdef WEB_REDIRECT_BY_MAC
MIB_TBL_ENTRY(MIB_WEB_REDIR_BY_MAC_URL,		CURRENT_SETTING,	"WEB_REDIR_BY_MAC_URL",	STRING_T,	_OFFSET(WebRedirByMACURL),	_SIZE(WebRedirByMACURL),		"http://www.truecorp.co.th/"),
MIB_TBL_ENTRY(MIB_WEB_REDIR_BY_MAC_INTERVAL,	CURRENT_SETTING,	"WEB_REDIR_BY_MAC_INTERVAL",	INTEGER_T,		_OFFSET(landingPageTime), 	_SIZE(landingPageTime),			"43200"),
#endif

#ifdef CONFIG_USB_ETH
MIB_TBL_ENTRY(MIB_USBETH_ITF_GROUP,		CURRENT_SETTING,	"USBETH_ITF_GROUP",	BYTE_T,		_OFFSET(usbeth_itfgrp),		_SIZE(usbeth_itfgrp),		"0"),
#endif //CONFIG_USB_ETH
// Mason Yu. combine_1p_4p_PortMapping
#if (defined( ITF_GROUP_1P) && defined(ITF_GROUP))
MIB_TBL_ENTRY(MIB_ETH_ITF_GROUP,		CURRENT_SETTING,	"ETH_ITF_GROUP",	BYTE_T,		_OFFSET(ethitfGroup),		_SIZE(ethitfGroup),		"0"),
#endif
//#ifdef DHCPS_POOL_COMPLETE_IP
MIB_TBL_ENTRY(MIB_DHCP_SUBNET_MASK, CURRENT_SETTING, "DHCP_SUBNET_MASK", IA_T, _OFFSET(dhcpSubnetMask), _SIZE(dhcpSubnetMask), "255.255.255.0"),
//#endif
//ql 20090119 START: for imagenio service
#ifdef IMAGENIO_IPTV_SUPPORT
MIB_TBL_ENTRY(MIB_OPCH_ADDRESS, CURRENT_SETTING, "OPCH_CH_ADDR", IA_T, _OFFSET(dhcpOpchAddr), _SIZE(dhcpOpchAddr), "239.0.2.10"),
MIB_TBL_ENTRY(MIB_OPCH_PORT, CURRENT_SETTING, "OPCH_CH_PORT", WORD_T, _OFFSET(dhcpOpchPort), _SIZE(dhcpOpchPort), "22222"),
MIB_TBL_ENTRY(MIB_IMAGENIO_DNS1, CURRENT_SETTING, "IMAGENIO_DNS1", IA_T, _OFFSET(imagenioDns1), _SIZE(imagenioDns1), "172.26.23.3 "),
MIB_TBL_ENTRY(MIB_IMAGENIO_DNS2, CURRENT_SETTING, "IMAGENIO_DNS2", IA_T, _OFFSET(imagenioDns2), _SIZE(imagenioDns2), "255.255.255.255"),
#endif
//ql 20090119 END

#ifdef _SUPPORT_CAPTIVEPORTAL_PROFILE_
MIB_TBL_ENTRY(MIB_CAPTIVEPORTAL_ENABLE, CURRENT_SETTING, "CAPTIVEPORTAL_ENABLE", BYTE_T, _OFFSET(captivePortalEnable), _SIZE(captivePortalEnable), "0"),
MIB_TBL_ENTRY(MIB_CAPTIVEPORTAL_URL, CURRENT_SETTING, "CAPTIVEPORTAL_URL", STRING_T, _OFFSET(captivePortalURL), _SIZE(captivePortalURL), ""),
#endif

#ifdef WLAN_QoS
MIB_TBL_ENTRY(MIB_WLAN_APSD_ENABLE, 			CURRENT_SETTING, 	"WLAN_APSD_ENABLE", BYTE_T,	_OFFSET(wlanqos_apsd), 	_SIZE(wlanqos_apsd), 	"0"),
#endif

//for wizard,add by liujuan
MIB_TBL_ENTRY(MIB_WIZ_CONN_TYPE, 	CURRENT_SETTING, 	"DETECT_TYPE", BYTE_T, _OFFSET(detect_type), 	_SIZE(detect_type), "1"),
//end:add by liujuan
//add by lhj
MIB_TBL_ENTRY(MIB_DEVICE_MODE, 	CURRENT_SETTING, 	"DEVICE_TYPE", BYTE_T, _OFFSET(device_mode), 	_SIZE(device_mode), "1"),
MIB_TBL_ENTRY(MIB_WIZ_MULTIPVC, 	CURRENT_SETTING, 	"WIZ_MULTIPVC",   BYTE_T, _OFFSET(wiz_multipvc), 	_SIZE(wiz_multipvc), "0"),
{0}
};

#ifdef INCLUDE_DEFAULT_VALUE
#if defined(ZTE_531B_BRIDGE_SC)||defined(ZTE_GENERAL_ROUTER_SC)
MIB_CE_ATM_VC_T mib_atm_vc_default_table[] = {
	// 1. 8/81
	{0xf0, 8 , 0, 81, ATM_MAX_US_PCR, 0, 0, 0 , 1, 1, 0, 0, "\0", "\0", 0, "\0",
	 0, 0, 0, 0, "\0", "\0", 0, 1500, 1, "\0", 0
// Mason Yu. combine_1p_4p_PortMapping
#if defined( CONFIG_EXT_SWITCH) || (defined( ITF_GROUP_1P) && defined(ITF_GROUP))
	 , 0, 0, 0, 0, 0
#endif
	, 0, 0
#ifdef _CWMP_MIB_ /*jiunming, for cwmp-tr069*/
	, 0, 1, 1, 0, 0, 0, "\0", "\0"  /*connDisable, ConDevInstNum, ConIPInstNum, ConPPPInstNum, autoDisTime, warnDisDelay, pppServiceName, WanName*/
#ifdef _PRMT_TR143_
	, 0 /*TR143UDPEchoItf*/
#endif //_PRMT_TR143_
#ifdef _PRMT_X_CT_COM_PPPOEv2_
	, 0, 0 /*PPPoEProxyEnable, PPPoEProxyMaxUser*/
#endif //_PRMT_X_CT_COM_PPPOEv2_
#ifdef _PRMT_X_CT_COM_WANEXT_
	, 0 /*ServiceList*/
#endif //_PRMT_X_CT_COM_WANEXT_
#endif //_CWMP_MIB_
#ifdef CTC_WAN_NAME
	, 0  //TR069, INTERNET, TR069_INTERNET, Other
#endif
#ifdef CONFIG_SPPPD_STATICIP
	, 0 /*Static PPPoE*/
#endif //CONFIG_SPPPD_STATICIP
	},
	// 1. 0/35
	{0xf1, 0 , 0, 35, ATM_MAX_US_PCR, 0, 0, 0 , 1, 1, 0, 0, "\0", "\0", 0, "\0",
	 0, 0, 0, 0, "\0", "\0", 0, 1500, 1, "\0", 0
// Mason Yu. combine_1p_4p_PortMapping
#if defined( CONFIG_EXT_SWITCH) || (defined( ITF_GROUP_1P) && defined(ITF_GROUP))
	 , 0, 0, 0, 0, 0
#endif
	, 0, 0
#ifdef _CWMP_MIB_ /*jiunming, for cwmp-tr069*/
	, 0, 2, 1, 0, 0, 0, "\0", "\0"  /*connDisable, ConDevInstNum, ConIPInstNum, ConPPPInstNum, autoDisTime, warnDisDelay, pppServiceName, WanName*/
#ifdef _PRMT_TR143_
	, 0 /*TR143UDPEchoItf*/
#endif //_PRMT_TR143_
#ifdef _PRMT_X_CT_COM_PPPOEv2_
	, 0, 0 /*PPPoEProxyEnable, PPPoEProxyMaxUser*/
#endif //_PRMT_X_CT_COM_PPPOEv2_
#ifdef _PRMT_X_CT_COM_WANEXT_
	, 0 /*ServiceList*/
#endif //_PRMT_X_CT_COM_WANEXT_
#endif //_CWMP_MIB_
#ifdef CTC_WAN_NAME
	, 0  //TR069, INTERNET, TR069_INTERNET, Other
#endif
#ifdef CONFIG_SPPPD_STATICIP
	, 0 /*Static PPPoE*/
#endif //CONFIG_SPPPD_STATICIP
	},
	// 1. 8/35
	{0xf2, 8 , 0, 35, ATM_MAX_US_PCR, 0, 0, 0 , 1, 1, 0, 0, "\0", "\0", 0, "\0",
	 0, 0, 0, 0, "\0", "\0", 0, 1500, 1, "\0", 0
// Mason Yu. combine_1p_4p_PortMapping
#if defined( CONFIG_EXT_SWITCH) || (defined( ITF_GROUP_1P) && defined(ITF_GROUP))
	 , 0, 0, 0, 0, 0
#endif
	, 0, 0
#ifdef _CWMP_MIB_ /*jiunming, for cwmp-tr069*/
	, 0, 3, 1, 0, 0, 0, "\0", "\0"  /*connDisable, ConDevInstNum, ConIPInstNum, ConPPPInstNum, autoDisTime, warnDisDelay, pppServiceName, WanName*/
#ifdef _PRMT_TR143_
	, 0 /*TR143UDPEchoItf*/
#endif //_PRMT_TR143_
#ifdef _PRMT_X_CT_COM_PPPOEv2_
	, 0, 0 /*PPPoEProxyEnable, PPPoEProxyMaxUser*/
#endif //_PRMT_X_CT_COM_PPPOEv2_
#ifdef _PRMT_X_CT_COM_WANEXT_
	, 0 /*ServiceList*/
#endif //_PRMT_X_CT_COM_WANEXT_
#endif //_CWMP_MIB_
#ifdef CTC_WAN_NAME
	, 0  //TR069, INTERNET, TR069_INTERNET, Other
#endif
#ifdef CONFIG_SPPPD_STATICIP
	, 0 /*Static PPPoE*/
#endif //CONFIG_SPPPD_STATICIP
	},
	// 1. 0/32
	{0xf3, 0 , 0, 32, ATM_MAX_US_PCR, 0, 0, 0 , 1, 1, 0, 0, "\0", "\0", 0, "\0",
	 0, 0, 0, 0, "\0", "\0", 0, 1500, 1, "\0", 0
// Mason Yu. combine_1p_4p_PortMapping
#if defined( CONFIG_EXT_SWITCH) || (defined( ITF_GROUP_1P) && defined(ITF_GROUP))
	 , 0, 0, 0, 0, 0
#endif
	, 0, 0
#ifdef _CWMP_MIB_ /*jiunming, for cwmp-tr069*/
	, 0, 4, 1, 0, 0, 0, "\0", "\0"  /*connDisable, ConDevInstNum, ConIPInstNum, ConPPPInstNum, autoDisTime, warnDisDelay, pppServiceName, WanName*/
#ifdef _PRMT_TR143_
	, 0 /*TR143UDPEchoItf*/
#endif //_PRMT_TR143_
#ifdef _PRMT_X_CT_COM_PPPOEv2_
	, 0, 0 /*PPPoEProxyEnable, PPPoEProxyMaxUser*/
#endif //_PRMT_X_CT_COM_PPPOEv2_
#ifdef _PRMT_X_CT_COM_WANEXT_
	, 0 /*ServiceList*/
#endif //_PRMT_X_CT_COM_WANEXT_
#endif //_CWMP_MIB_
#ifdef CTC_WAN_NAME
	, 0  //TR069, INTERNET, TR069_INTERNET, Other
#endif
#ifdef CONFIG_SPPPD_STATICIP
	, 0 /*Static PPPoE*/
#endif //CONFIG_SPPPD_STATICIP
	},
	// 1. 0/100
	{0xf4, 0 , 0, 100, ATM_MAX_US_PCR, 0, 0, 0 , 1, 1, 0, 0, "\0", "\0", 0, "\0",
	 0, 0, 0, 0, "\0", "\0", 0, 1500, 1, "\0", 0
// Mason Yu. combine_1p_4p_PortMapping
#if defined( CONFIG_EXT_SWITCH) || (defined( ITF_GROUP_1P) && defined(ITF_GROUP))
	 , 0, 0, 0, 0, 0
#endif
	, 0, 0
#ifdef _CWMP_MIB_ /*jiunming, for cwmp-tr069*/
	, 0, 5, 1, 0, 0, 0, "\0", "\0"  /*connDisable, ConDevInstNum, ConIPInstNum, ConPPPInstNum, autoDisTime, warnDisDelay, pppServiceName, WanName*/
#ifdef _PRMT_TR143_
	, 0 /*TR143UDPEchoItf*/
#endif //_PRMT_TR143_
#ifdef _PRMT_X_CT_COM_PPPOEv2_
	, 0, 0 /*PPPoEProxyEnable, PPPoEProxyMaxUser*/
#endif //_PRMT_X_CT_COM_PPPOEv2_
#ifdef _PRMT_X_CT_COM_WANEXT_
	, 0 /*ServiceList*/
#endif //_PRMT_X_CT_COM_WANEXT_
#endif //_CWMP_MIB_
#ifdef CTC_WAN_NAME
	, 0  //TR069, INTERNET, TR069_INTERNET, Other
#endif
#ifdef CONFIG_SPPPD_STATICIP
	, 0 /*Static PPPoE*/
#endif //CONFIG_SPPPD_STATICIP
	},
	// 1. 8/36
	{0xf5, 8 , 0, 36, ATM_MAX_US_PCR, 0, 0, 0 , 1, 1, 0, 0, "\0", "\0", 0, "\0",
	 0, 0, 0, 0, "\0", "\0", 0, 1500, 1, "\0", 0
// Mason Yu. combine_1p_4p_PortMapping
#if defined( CONFIG_EXT_SWITCH) || (defined( ITF_GROUP_1P) && defined(ITF_GROUP))
	 , 0, 0, 0, 0, 0
#endif
	, 0, 0
#ifdef _CWMP_MIB_ /*jiunming, for cwmp-tr069*/
	, 0, 6, 1, 0, 0, 0, "\0", "\0"  /*connDisable, ConDevInstNum, ConIPInstNum, ConPPPInstNum, autoDisTime, warnDisDelay, pppServiceName, WanName*/
#ifdef _PRMT_TR143_
	, 0 /*TR143UDPEchoItf*/
#endif //_PRMT_TR143_
#ifdef _PRMT_X_CT_COM_PPPOEv2_
	, 0, 0 /*PPPoEProxyEnable, PPPoEProxyMaxUser*/
#endif //_PRMT_X_CT_COM_PPPOEv2_
#ifdef _PRMT_X_CT_COM_WANEXT_
	, 0 /*ServiceList*/
#endif //_PRMT_X_CT_COM_WANEXT_
#endif //_CWMP_MIB_
#ifdef CTC_WAN_NAME
	, 0  //TR069, INTERNET, TR069_INTERNET, Other
#endif
#ifdef CONFIG_SPPPD_STATICIP
	, 0 /*Static PPPoE*/
#endif //CONFIG_SPPPD_STATICIP
	},
	// 1. 0/33
	{0xf6, 0 , 0, 33, ATM_MAX_US_PCR, 0, 0, 0 , 1, 1, 0, 0, "\0", "\0", 0, "\0",
	 0, 0, 0, 0, "\0", "\0", 0, 1500, 1, "\0", 0
// Mason Yu. combine_1p_4p_PortMapping
#if defined( CONFIG_EXT_SWITCH) || (defined( ITF_GROUP_1P) && defined(ITF_GROUP))
	 , 0, 0, 0, 0, 0
#endif
	, 0, 0
#ifdef _CWMP_MIB_ /*jiunming, for cwmp-tr069*/
	, 0, 7, 1, 0, 0, 0, "\0", "\0"  /*connDisable, ConDevInstNum, ConIPInstNum, ConPPPInstNum, autoDisTime, warnDisDelay, pppServiceName, WanName*/
#ifdef _PRMT_TR143_
	, 0 /*TR143UDPEchoItf*/
#endif //_PRMT_TR143_
#ifdef _PRMT_X_CT_COM_PPPOEv2_
	, 0, 0 /*PPPoEProxyEnable, PPPoEProxyMaxUser*/
#endif //_PRMT_X_CT_COM_PPPOEv2_
#ifdef _PRMT_X_CT_COM_WANEXT_
	, 0 /*ServiceList*/
#endif //_PRMT_X_CT_COM_WANEXT_
#endif //_CWMP_MIB_
#ifdef CTC_WAN_NAME
	, 0  //TR069, INTERNET, TR069_INTERNET, Other
#endif
#ifdef CONFIG_SPPPD_STATICIP
	, 0 /*Static PPPoE*/
#endif //CONFIG_SPPPD_STATICIP
	},

};
#else    //ZTE_531B_BRIDGE_SC
MIB_CE_ATM_VC_T mib_atm_vc_default_table[] = {
	// 1. 5/35
#ifdef TELEFONICA_DEFAULT_CFG
    {0x0, 8 , 0, 32, ATM_MAX_US_PCR, 0, 0, 0 , 1, 1, 2, 2, "adslppp@telefonicanetpa", "adslppp", 0, "\0",
     0, 0, 0, 0, "\0", "\0", 1, 1492, 1, "\0", 0
#else
#ifndef CONFIG_GUI_WEB
	{0xf0, 5 , 0, 35, ATM_MAX_US_PCR, 0, 0, 0 , 1, 1, 0, 0, "\0", "\0", 0, "\0",
	 0, 0
	#ifdef IP_QOS
	 , 0
	#endif
	#ifdef CONFIG_IGMPPROXY_MULTIWAN
	 , 0
	#endif
	 , 0, 0, "\0", "\0", 0, 1500, 1, "\0", 0
 #else
	{0x0, 0 , 0, 35, ATM_MAX_US_PCR, 0, 0, 0 , 1, 1, 2, 2, "\0", "\0", 0, "\0",
	 0, 0, 0, 0, "\0", "\0", 0, 1492, 1, "\0", 0
#endif
#endif
// Mason Yu. combine_1p_4p_PortMapping
#if defined( CONFIG_EXT_SWITCH) || (defined( ITF_GROUP_1P) && defined(ITF_GROUP))
	 , 0, 0, 0, 0, 0
#endif
	, 0, 0
#ifdef _CWMP_MIB_ /*jiunming, for cwmp-tr069*/
	, 0, 1, 1, 0, 0, 0, "\0", "\0"  /*connDisable, ConDevInstNum, ConIPInstNum, ConPPPInstNum, autoDisTime, warnDisDelay, pppServiceName, WanName*/
#ifdef _PRMT_TR143_
	, 0 /*TR143UDPEchoItf*/
#endif //_PRMT_TR143_
#ifdef _PRMT_X_CT_COM_PPPOEv2_
	, 0, 0 /*PPPoEProxyEnable, PPPoEProxyMaxUser*/
#endif //_PRMT_X_CT_COM_PPPOEv2_
#ifdef _PRMT_X_CT_COM_WANEXT_
	, 0 /*ServiceList*/
#endif //_PRMT_X_CT_COM_WANEXT_
#endif //_CWMP_MIB_
#ifdef CTC_WAN_NAME
	, 0  //TR069, INTERNET, TR069_INTERNET, Other
#endif
#ifdef CONFIG_SPPPD_STATICIP
	, 0 /*Static PPPoE*/
#endif //CONFIG_SPPPD_STATICIP
	},

// Channel 2
#ifdef TELEFONICA_DEFAULT_CFG
    {0x11, 8 , 0, 36, 301, 0, 0, 0 , 1, 1, 2, 2, "tec01001@telefonicanetpi", "adslppp", 0, "\0",
     0, 0, 0, 0, "\0", "\0", 0, 1492, 1, "\0", 0
// Mason Yu. combine_1p_4p_PortMapping
#if defined( CONFIG_EXT_SWITCH) || (defined( ITF_GROUP_1P) && defined(ITF_GROUP))
	 , 0, 0, 0, 0, 0
#endif
	, 0, 0
#ifdef _CWMP_MIB_ /*jiunming, for cwmp-tr069*/
	, 0, 1, 1, 0, 0, 0, "\0", "\0"  /*connDisable, ConDevInstNum, ConIPInstNum, ConPPPInstNum, autoDisTime, warnDisDelay, pppServiceName, WanName*/
#ifdef _PRMT_TR143_
	, 0 /*TR143UDPEchoItf*/
#endif //_PRMT_TR143_
#ifdef _PRMT_X_CT_COM_PPPOEv2_
	, 0, 0 /*PPPoEProxyEnable, PPPoEProxyMaxUser*/
#endif //_PRMT_X_CT_COM_PPPOEv2_
#ifdef _PRMT_X_CT_COM_WANEXT_
	, 0 /*ServiceList*/
#endif //_PRMT_X_CT_COM_WANEXT_
#endif //_CWMP_MIB_
#ifdef CTC_WAN_NAME
	, 0  //TR069, INTERNET, TR069_INTERNET, Other
#endif
#ifdef CONFIG_SPPPD_STATICIP
	, 0 /*Static PPPoE*/
#endif //CONFIG_SPPPD_STATICIP
       , 0   //lhj, wan mac
	},
#endif // of TELEFONICA_DEFAULT_CFG
};
#endif


#ifdef CONFIG_EXT_SWITCH
#ifdef CONFIG_USBCLIENT
MIB_CE_SW_PORT_T mib_sw_port_default_table[SW_PORT_NUM] = {
	{0xff, 0, 0, 1, 4}, {0xff, 0, 1, 1, 4}, {0xff, 0, 2, 1, 4}, {0xff, 0, 3, 1, 4},{0xff,0,4,1,4}
};
#else
MIB_CE_SW_PORT_T mib_sw_port_default_table[SW_PORT_NUM] = {
	{0xff, 0, 0, 1, 4}, {0xff, 0, 1, 1, 4}, {0xff, 0, 2, 1, 4}, {0xff, 0, 3, 1, 4}
};
#endif

MIB_CE_VLAN_T mib_vlan_default_table[VLAN_NUM] = {
	{0, 0, 1, 1}, {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}
};
#endif

#ifdef TELEFONICA_DEFAULT_CFG
MIB_CE_ACL_IP_T mib_acl_default_table[] = {
	{{0,0,0,0}, 0, 1, 16}, {{193,152,37,192}, 28, 1, 128},
	{{80,58,63,128}, 25, 1, 128}, {{172,20,25,0}, 24, 1, 128},
	{{172,20,45,0}, 24, 1, 128}
};

MIB_CE_IP_QOS_T mib_ipqos_default_table[] = {
	{{0,0,0,0}, 0, 0, {81,47,224,0}, 22, 0, 2, 255, 0, 0,
#ifdef QOS_DSCP
	0,
#endif
	0, 255, 0, 
#ifdef _CWMP_MIB_
	1, 0,
#endif
	}
};
#endif // of TELEFONICA_DEFAULT_CFG

	#ifdef ZTE_GENERAL_ROUTER_SC
MIB_CE_ACC_T mib_acc_default_table[] = {
	{0, 0, 0, 0x02, 0x03, 0, 0x02, 0, ACC_TELNET_PORT, ACC_HTTP_PORT, ACC_FTP_PORT,0xf0,8,81,0},
	{0, 0, 0, 0x02, 0x03, 0, 0x02, 0, ACC_TELNET_PORT, ACC_HTTP_PORT, ACC_FTP_PORT,0xf1,0,35,0},
	{0, 0, 0, 0x02, 0x03, 0, 0x02, 0, ACC_TELNET_PORT, ACC_HTTP_PORT, ACC_FTP_PORT,0xf2,8,35,0},
	{0, 0, 0, 0x02, 0x03, 0, 0x02, 0, ACC_TELNET_PORT, ACC_HTTP_PORT, ACC_FTP_PORT,0xf3,0,32,0},
	{0, 0, 0, 0x02, 0x03, 0, 0x02, 0, ACC_TELNET_PORT, ACC_HTTP_PORT, ACC_FTP_PORT,0xf4,0,100,0},
	{0, 0, 0, 0x02, 0x03, 0, 0x02, 0, ACC_TELNET_PORT, ACC_HTTP_PORT, ACC_FTP_PORT,0xf5,8,36,0},
	{0, 0, 0, 0x02, 0x03, 0, 0x02, 0, ACC_TELNET_PORT, ACC_HTTP_PORT, ACC_FTP_PORT,0xf6,0,33,0}
};
#else
#ifdef ZTE_531B_BRIDGE_SC
MIB_CE_ACC_T mib_acc_default_table[1] = {
	{0, 0, 0, 0x02, 0x03, 0, 0x02, 0, 23, 80, 21}
};
#else
MIB_CE_ACC_T mib_acc_default_table[1] = {
#ifdef TELEFONICA_DEFAULT_CFG
	{0x03, 0x03, 0, 0x03, 0x03, 0, 0x02, 23, 80, 21, 0x03, 443}
#else
	{0x02, 0x02, 0, 0x02, 0x03, 0, 0x02, 23, 80, 21, 0x02, 443}
#endif
};
#endif
#endif



// add for auto-pvc-search  TR068 defined
MIB_AUTO_PVC_SEARCH_T mib_auto_pvc_search_default_table[8] = {
    {0,32},{0,33},{0,35},{5,35},{8,35},{8,36},{0,100},{8,81}
};
#ifdef WLAN_QoS
MIB_WLAN_QOS_T mib_wlan_qos_default_ap_table[4] = {
	{47, 3, 2, 1, 1}, {94, 4, 3, 1, 1}, {0, 6, 4, 3, 1}, {0, 10, 4, 7, 1}
};
MIB_WLAN_QOS_T mib_wlan_qos_default_sta_table[4] = {
	{47, 3, 2, 2, 1}, {94,4, 3, 2, 1}, {0, 10, 4, 3, 1}, {0, 10, 4, 7, 1}
};
#endif

// Added by mason Yu
#ifdef WLAN_MBSSID
MIB_CE_MBSSIB_T mib_mbssid_default_table[] = {
#if !(defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC))

#ifdef E8A_CHINA
	{0, 1, 0, 0, 1, 0, "\0", 1812, "\0", "\0", 1, "CTC-0000", 2
#else
	{0, 0, 0, 0, 1, 0, "\0", 1812, "\0", "\0", 1, "CTC-0000", 2
#endif
#ifdef _CWMP_MIB_
	,0
#endif
#ifdef ENABLE_WPAAES_WPA2TKIP
	,1,2
#endif
	,0,0	//isolation, added by Julia 090713
	,0	//userisolation
	},
	{1, 0, 0, 0, 1, 0, "\0", 1812, "\0", "\0", 1, "TRENDnet436-0", 2
#ifdef _CWMP_MIB_
	,0
#endif
#ifdef ENABLE_WPAAES_WPA2TKIP
	,1,2
#endif
	,0,0	//isolation, added by Julia 090713
	,0	//userisolation
	},
	{2, 0, 0, 0, 1, 0, "\0", 1812, "\0", "\0", 1, "TRENDnet436-1", 2
#ifdef _CWMP_MIB_
	,0
#endif
#ifdef ENABLE_WPAAES_WPA2TKIP
	,1,2
#endif
	,0,0	//isolation, added by Julia 090713
	,0	//userisolation
	},
	{3, 0, 0, 0, 1, 0, "\0", 1812, "\0", "\0", 1, "TRENDnet436-2", 2
#ifdef _CWMP_MIB_
	,0
#endif
#ifdef ENABLE_WPAAES_WPA2TKIP
	,1,2
#endif
	,0,0	//isolation, added by Julia 090713
	,0	//userisolation
	},
	{4, 0, 0, 0, 1, 0, "\0", 1812, "\0", "\0", 1, "TRENDnet436-3", 2
#ifdef _CWMP_MIB_
	,0
#endif
#ifdef ENABLE_WPAAES_WPA2TKIP
	,1,2
#endif
	,0,0	//isolation, added by Julia 090713
	,0	//userisolation
	},

#else

#ifdef E8A_CHINA
	{0, 1, 0, 0, 1, 0, "\0", 1812, "\0", "\0", 1, "", 2
#else
	{0, 0, 0, 0, 1, 0, "\0", 1812, "\0", "\0", 1, "", 2
#endif
#ifdef _CWMP_MIB_
	,0
#endif
#ifdef ENABLE_WPAAES_WPA2TKIP
	,1,2
#endif
	,0	//userisolation
	},
	{1, 0, 0, 0, 1, 0, "\0", 1812, "\0", "\0", 1, "", 2
#ifdef _CWMP_MIB_
	,0
#endif
#ifdef ENABLE_WPAAES_WPA2TKIP
	,1,2
#endif
	,0	//userisolation
	},
	{2, 0, 0, 0, 1, 0, "\0", 1812, "\0", "\0", 1, "", 2
#ifdef _CWMP_MIB_
	,0
#endif
#ifdef ENABLE_WPAAES_WPA2TKIP
	,1,2
#endif
	,0	//userisolation
	},
	{3, 0, 0, 0, 1, 0, "\0", 1812, "\0", "\0", 1, "", 2
#ifdef _CWMP_MIB_
	,0
#endif
#ifdef ENABLE_WPAAES_WPA2TKIP
	,1,2
#endif
	,0	//userisolation
	},
	{4, 0, 0, 0, 1, 0, "\0", 1812, "\0", "\0", 1, "", 2
#ifdef _CWMP_MIB_
	,0
#endif
#ifdef ENABLE_WPAAES_WPA2TKIP
	,1,2
#endif
	,0	//userisolation
	},
#endif
};

MIB_CE_MBSSIB_WEP_T mib_mbssid_wep_default_table[] = {
#if defined(ZTE_531B_BRIDGE_SC) || defined(ZTE_GENERAL_ROUTER_SC)
  {"\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0", 0, 0},
  {"\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0", 0, 0},
  {"\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0", 0, 0},
  {"\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0", 0, 0},
  {"\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0", 0, 0},
#else
#ifdef E8A_CHINA
	{"3131313131", "3232323232", "3333333333", "3434343434", "\0", "\0", "\0", "\0", 0, 0},
	// 3131313131: key is 11111
	// 3232323232: key is 22222
	// 3333333333: key is 33333
	// 3232323232: key is 22222
	// 3434343434: key is 44444
#else
	{"\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0", 0, 0},
#endif
	{"\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0", 0, 0},
	{"\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0", 0, 0},
	{"\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0", 0, 0},
	{"\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0", 0, 0},
#endif
};
#endif

/*ping_zhang:20090319 START:replace ip range with serving pool of tr069*/
#ifdef _PRMT_X_TELEFONICA_ES_DHCPOPTION_
#ifdef IMAGENIO_IPTV_SUPPORT
DHCPS_SERVING_POOL_T mib_dhcp_sp_default_table[] = {
	{1, 1, "STBs", 3, 240, 0, "[IAL]", 0, "Substring", "\0", 0, "\0", 0, "\0", {0xff,0xff,0xff,0xff,0xff,0xff}, 0, 1, 
		{192,168,1,200}, {192,168,1,205}, {255,255,255,0},	//ip range
		{192,168,1,1},		//ip router
		"\0",	"\0",  "\0",	 //dns server
		"domain.name", 	//domain name
		86400, 			//lease time
		"\0", 			//dhcp relay ip
		0				//dns server mode	
#ifdef _CWMP_MIB_
		,1
#endif
	}
};
#if 0
MIB_CE_IP_RANGE_DHCP_T mib_ip_range_dhcp_default_table[] = {
	// Marked by Mason Yu
	//{"PCs", {192,168,1,40}, {192,168,1,49}, "MSFT"},
	//{"CAMERAs", {192,168,1,200}, {192,168,1,205}, "vdshv"},
	{"STBs", {192,168,1,200}, {192,168,1,205}, "[IAL]"
/*ping_zhang:20090313 START:Telefonica DHCP option new request*/
	, 3,	//deviceType
	240,	//option code
	"\0" 	//option string
/*ping_zhang:20090313 END*/
	},
};
#endif
#endif //IMAGENIO_IPTV_SUPPORT
#endif
/*ping_zhang:20090319 END*/

#ifdef CONFIG_USER_PPPOMODEM
MIB_WAN_3G_T mib_wan_3g_default_table[] = {
	{
	  /*enable*/	0,
	  /*auth*/	PPP_AUTH_NONE,
	  /*ctype*/	CONTINUOUS,
	  /*napt*/	1,
	  /*pin*/	NO_PINCODE,
	  /*idletime*/	60,
	  /*mtu*/	1500,
	  /*dgw*/	1,
	  /*apn*/	"internet",
	  /*dial*/	"*99#",
	  /*username*/	"",
	  /*password*/	""
	}
};
#endif //CONFIG_USER_PPPOMODEM


#else
MIB_CE_ATM_VC_Tp mib_atm_vc_default_table = (MIB_CE_ATM_VC_Tp)0;
#ifdef CONFIG_EXT_SWITCH
MIB_CE_SW_PORT_Tp mib_sw_port_default_table = (MIB_CE_SW_PORT_Tp)0;
#endif


#ifdef WLAN_MBSSID
MIB_CE_MBSSIB_Tp mib_mbssid_default_table = (MIB_CE_MBSSIB_Tp)0;
MIB_CE_MBSSIB_WEP_Tp mib_mbssid_wep_default_table = (MIB_CE_MBSSIB_WEP_Tp)0;
#endif

/*ping_zhang:20090319 START:replace ip range with serving pool of tr069*/
#ifdef _PRMT_X_TELEFONICA_ES_DHCPOPTION_
#ifdef IMAGENIO_IPTV_SUPPORT
DHCPS_SERVING_POOL_Tp mib_dhcp_sp_default_table = (DHCPS_SERVING_POOL_Tp)0;
//MIB_CE_IP_RANGE_DHCP_Tp mib_ip_range_dhcp_default_table = (MIB_CE_IP_RANGE_DHCP_Tp)0;
#endif
#endif
/*ping_zhang:20090319 END*/


#ifdef CONFIG_USER_PPPOMODEM
MIB_WAN_3G_Tp mib_wan_3g_default_table = (MIB_WAN_3G_Tp)0;
#endif //CONFIG_USER_PPPOMODEM

#endif

/*-------------------- MIB Chain record description --------------------------------*/
mib_chain_member_entry_T IP_PORT_FILTER_DESC[]={
	{ "FilterMode",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_PORT_FILTER_T, action),		_SIZE_CE(MIB_CE_IP_PORT_FILTER_T, action) },
	{ "SrcIP",		IA_T,		_OFFSET_CE(MIB_CE_IP_PORT_FILTER_T, srcIp),		_SIZE_CE(MIB_CE_IP_PORT_FILTER_T, srcIp) },
	{ "DstIP",		IA_T,		_OFFSET_CE(MIB_CE_IP_PORT_FILTER_T, dstIp),		_SIZE_CE(MIB_CE_IP_PORT_FILTER_T, dstIp) },
	{ "SrcMask",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_PORT_FILTER_T, smaskbit),		_SIZE_CE(MIB_CE_IP_PORT_FILTER_T, smaskbit) },
	{ "DstMask",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_PORT_FILTER_T, dmaskbit),		_SIZE_CE(MIB_CE_IP_PORT_FILTER_T, dmaskbit) },
	{ "SrcPortStart",	WORD_T,		_OFFSET_CE(MIB_CE_IP_PORT_FILTER_T, srcPortFrom),	_SIZE_CE(MIB_CE_IP_PORT_FILTER_T, srcPortFrom) },
	{ "DstPortStart",	WORD_T,		_OFFSET_CE(MIB_CE_IP_PORT_FILTER_T, dstPortFrom),	_SIZE_CE(MIB_CE_IP_PORT_FILTER_T, dstPortFrom) },
	{ "SrcPortEnd",		WORD_T,		_OFFSET_CE(MIB_CE_IP_PORT_FILTER_T, srcPortTo),		_SIZE_CE(MIB_CE_IP_PORT_FILTER_T, srcPortTo) },
	{ "DstPortEnd",		WORD_T,		_OFFSET_CE(MIB_CE_IP_PORT_FILTER_T, dstPortTo),		_SIZE_CE(MIB_CE_IP_PORT_FILTER_T, dstPortTo) },
	{ "Direction",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_PORT_FILTER_T, dir),		_SIZE_CE(MIB_CE_IP_PORT_FILTER_T, dir) },
	{ "protocol",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_PORT_FILTER_T, protoType),		_SIZE_CE(MIB_CE_IP_PORT_FILTER_T, protoType) },
	{0}
};

mib_chain_member_entry_T PORT_FW_DESC[]={
	{ "IP",			IA_T,		_OFFSET_CE(MIB_CE_PORT_FW_T, ipAddr),			_SIZE_CE(MIB_CE_PORT_FW_T, ipAddr) },
	{ "PortStart",		WORD_T,		_OFFSET_CE(MIB_CE_PORT_FW_T, fromPort),			_SIZE_CE(MIB_CE_PORT_FW_T, fromPort) },
	{ "PortEnd",		WORD_T,		_OFFSET_CE(MIB_CE_PORT_FW_T, toPort),			_SIZE_CE(MIB_CE_PORT_FW_T, toPort) },
	{ "Protocol",		BYTE_T,		_OFFSET_CE(MIB_CE_PORT_FW_T, protoType),		_SIZE_CE(MIB_CE_PORT_FW_T, protoType) },
	{ "Comment",		STRING_T,	_OFFSET_CE(MIB_CE_PORT_FW_T, comment),			_SIZE_CE(MIB_CE_PORT_FW_T, comment) },
	{ "OutInf",		BYTE_T,		_OFFSET_CE(MIB_CE_PORT_FW_T, ifIndex),			_SIZE_CE(MIB_CE_PORT_FW_T, ifIndex) },
	{ "enable",		BYTE_T,		_OFFSET_CE(MIB_CE_PORT_FW_T, enable),			_SIZE_CE(MIB_CE_PORT_FW_T, enable) },
	{ "leaseduration",	INTEGER_T,	_OFFSET_CE(MIB_CE_PORT_FW_T, leaseduration),		_SIZE_CE(MIB_CE_PORT_FW_T, leaseduration) },
	{ "remotehost",		IA_T,		_OFFSET_CE(MIB_CE_PORT_FW_T, remotehost),		_SIZE_CE(MIB_CE_PORT_FW_T, remotehost) },
	{ "externalportStart",	INTEGER_T,	_OFFSET_CE(MIB_CE_PORT_FW_T, externalfromport),		_SIZE_CE(MIB_CE_PORT_FW_T, externalfromport) },
	{ "externalportEnd",	INTEGER_T,	_OFFSET_CE(MIB_CE_PORT_FW_T, externaltoport),		_SIZE_CE(MIB_CE_PORT_FW_T, externaltoport) },
	{ "InstanceNum",	INTEGER_T,	_OFFSET_CE(MIB_CE_PORT_FW_T, InstanceNum),		_SIZE_CE(MIB_CE_PORT_FW_T, InstanceNum) },
	{0}
};

#ifdef NATIP_FORWARDING
mib_chain_member_entry_T IP_FW_DESC[]={
	{ "Action",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_FW_T, action),			_SIZE_CE(MIB_CE_IP_FW_T, action) },
	{ "Local_IP",		IA_T,		_OFFSET_CE(MIB_CE_IP_FW_T, local_ip),			_SIZE_CE(MIB_CE_IP_FW_T, local_ip) },
	{ "Remote_IP",		IA_T,		_OFFSET_CE(MIB_CE_IP_FW_T, remote_ip),			_SIZE_CE(MIB_CE_IP_FW_T, remote_ip) },
	{0}
};
#endif

#ifdef PORT_TRIGGERING
mib_chain_member_entry_T PORT_TRG_DESC[]={
	{ "Name",		STRING_T,	_OFFSET_CE(MIB_CE_PORT_TRG_T, name),			_SIZE_CE(MIB_CE_PORT_TRG_T, name) },
	{ "IP",			IA_T,		_OFFSET_CE(MIB_CE_PORT_TRG_T, ip),			_SIZE_CE(MIB_CE_PORT_TRG_T, ip) },
	{ "TCP_Range",		STRING_T,	_OFFSET_CE(MIB_CE_PORT_TRG_T, tcpRange),		_SIZE_CE(MIB_CE_PORT_TRG_T, tcpRange) },
	{ "UDP_Range",		STRING_T,	_OFFSET_CE(MIB_CE_PORT_TRG_T, udpRange),		_SIZE_CE(MIB_CE_PORT_TRG_T, udpRange) },
	{ "Enable",		BYTE_T,		_OFFSET_CE(MIB_CE_PORT_TRG_T, enable),			_SIZE_CE(MIB_CE_PORT_TRG_T, enable) },
	{0}
};
#endif

#ifdef NEW_PORT_TRIGGER  //add by machuanjun
mib_chain_member_entry_T NEW_PORT_TRG_DESC[]={
	{ "match_port_begine",		STRING_T,	_OFFSET_CE(NEW_MIB_CE_PORT_TRG_T, m_match_port_begin),			_SIZE_CE(NEW_MIB_CE_PORT_TRG_T,m_match_port_begin) },
	{ "match_port_end",		STRING_T,		_OFFSET_CE(NEW_MIB_CE_PORT_TRG_T, m_match_port_end),			_SIZE_CE(NEW_MIB_CE_PORT_TRG_T,m_match_port_end) },
	{ "related_port_begin",		STRING_T,	_OFFSET_CE(NEW_MIB_CE_PORT_TRG_T, m_related_port_begin),		_SIZE_CE(NEW_MIB_CE_PORT_TRG_T, m_related_port_begin) },
	{ "related_port_end",		STRING_T,	_OFFSET_CE(NEW_MIB_CE_PORT_TRG_T, m_related_port_end),		_SIZE_CE(NEW_MIB_CE_PORT_TRG_T, m_related_port_end) },
	{ "name",		STRING_T,		_OFFSET_CE(NEW_MIB_CE_PORT_TRG_T, name),			_SIZE_CE(NEW_MIB_CE_PORT_TRG_T, name) },
	{ "Enable",		BYTE_T,		_OFFSET_CE(NEW_MIB_CE_PORT_TRG_T, 	enable ),			_SIZE_CE(NEW_MIB_CE_PORT_TRG_T, 	enable ) },
	{ "match_protocol",		BYTE_T,		_OFFSET_CE(NEW_MIB_CE_PORT_TRG_T, m_match_protocol ),			_SIZE_CE(NEW_MIB_CE_PORT_TRG_T,	m_match_protocol  ) },
	{ "realted_protocol",		BYTE_T,		_OFFSET_CE(NEW_MIB_CE_PORT_TRG_T, m_realted_protocol),			_SIZE_CE(NEW_MIB_CE_PORT_TRG_T, m_realted_protocol) },
	{0}
};
#endif


mib_chain_member_entry_T MAC_FILTER_DESC[]={
	{ "FilterMode",		STRING_T,	_OFFSET_CE(MIB_CE_MAC_FILTER_T, action),		_SIZE_CE(MIB_CE_MAC_FILTER_T, action) },
	{ "SrcMac",		BYTE6_T,	_OFFSET_CE(MIB_CE_MAC_FILTER_T, srcMac),		_SIZE_CE(MIB_CE_MAC_FILTER_T, srcMac) },
	{ "DstMac",		BYTE6_T,	_OFFSET_CE(MIB_CE_MAC_FILTER_T, dstMac),		_SIZE_CE(MIB_CE_MAC_FILTER_T, dstMac) },
	{ "Comment",		STRING_T,	_OFFSET_CE(MIB_CE_MAC_FILTER_T, comment),		_SIZE_CE(MIB_CE_MAC_FILTER_T, comment) },
	{ "Direction",		BYTE_T,		_OFFSET_CE(MIB_CE_MAC_FILTER_T, dir),			_SIZE_CE(MIB_CE_MAC_FILTER_T, dir) },
	{0}
};

mib_chain_member_entry_T ATM_VC_DESC[]={
	{ "ifIndex",		BYTE_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, ifIndex),			_SIZE_CE(MIB_CE_ATM_VC_T, ifIndex) },
	{ "VPI",		BYTE_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, vpi),			_SIZE_CE(MIB_CE_ATM_VC_T, vpi) },
	{ "VCI",		WORD_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, vci),
    			_SIZE_CE(MIB_CE_ATM_VC_T, vci) },
	{ "QoS",		BYTE_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, qos),
    			_SIZE_CE(MIB_CE_ATM_VC_T, qos) },
	{ "PCR",		WORD_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, pcr),
    			_SIZE_CE(MIB_CE_ATM_VC_T, pcr) },
	{ "SCR",		WORD_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, scr),
    			_SIZE_CE(MIB_CE_ATM_VC_T, scr) },
	{ "MBS",		WORD_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, mbs),
    			_SIZE_CE(MIB_CE_ATM_VC_T, mbs) },
	{ "CDVT",		DWORD_T,	_OFFSET_CE(MIB_CE_ATM_VC_T, cdvt),
   			_SIZE_CE(MIB_CE_ATM_VC_T, cdvt) },
	{ "Encap",		BYTE_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, encap),
  			_SIZE_CE(MIB_CE_ATM_VC_T, encap) },
	{ "NAPT",		BYTE_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, napt),			_SIZE_CE(MIB_CE_ATM_VC_T, napt) },
	{ "ChannelMode",	BYTE_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, cmode),
  			_SIZE_CE(MIB_CE_ATM_VC_T, cmode) },
	{ "BridgeType",		BYTE_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, brmode),			_SIZE_CE(MIB_CE_ATM_VC_T, brmode) },
	{ "pppUser",		STRING_T,	_OFFSET_CE(MIB_CE_ATM_VC_T, pppUsername),		_SIZE_CE(MIB_CE_ATM_VC_T, pppUsername) },
	{ "pppPasswd",		STRING_T,	_OFFSET_CE(MIB_CE_ATM_VC_T, pppPassword),		_SIZE_CE(MIB_CE_ATM_VC_T, pppPassword) },
	{ "pppAuth",		BYTE_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, pppAuth),			_SIZE_CE(MIB_CE_ATM_VC_T, pppAuth) },
	{ "pppACName",		STRING_T,	_OFFSET_CE(MIB_CE_ATM_VC_T, pppACName),			_SIZE_CE(MIB_CE_ATM_VC_T, pppACName) },
	{ "pppConnectType",	BYTE_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, pppCtype),			_SIZE_CE(MIB_CE_ATM_VC_T, pppCtype) },
	{ "pppIdleTime",	WORD_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, pppIdleTime),		_SIZE_CE(MIB_CE_ATM_VC_T, pppIdleTime) },
#ifdef IP_QOS
	{ "enableIpQos",	BYTE_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, enableIpQos),		_SIZE_CE(MIB_CE_ATM_VC_T, enableIpQos) },
#endif
#ifdef CONFIG_IGMPPROXY_MULTIWAN
	{ "enableIGMP",		BYTE_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, enableIGMP),		_SIZE_CE(MIB_CE_ATM_VC_T, enableIGMP) },
#endif
	{ "ChannelAddrType",	BYTE_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, ipDhcp),			_SIZE_CE(MIB_CE_ATM_VC_T, ipDhcp) },
	{ "RIP",		BYTE_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, rip),
    			_SIZE_CE(MIB_CE_ATM_VC_T, rip) },
	{ "LocalIPAddr",	IA_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, ipAddr),
 			_SIZE_CE(MIB_CE_ATM_VC_T, ipAddr) },
	{ "RemoteIPAddr",	IA_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, remoteIpAddr),		_SIZE_CE(MIB_CE_ATM_VC_T, remoteIpAddr) },
	{ "DefaultGW",		BYTE_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, dgw),
    			_SIZE_CE(MIB_CE_ATM_VC_T, dgw) },
	{ "MTU",		DWORD_T,	_OFFSET_CE(MIB_CE_ATM_VC_T, mtu),
    			_SIZE_CE(MIB_CE_ATM_VC_T, mtu) },
	{ "ChannelStatus",	BYTE_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, enable),
 			_SIZE_CE(MIB_CE_ATM_VC_T, enable) },
	{ "SubnetMask",		IA_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, netMask),
			_SIZE_CE(MIB_CE_ATM_VC_T, netMask) },
	{ "Ipunnum",		BYTE_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, ipunnumbered),		_SIZE_CE(MIB_CE_ATM_VC_T, ipunnumbered) },
// Mason Yu. combine_1p_4p_PortMapping
#if defined( CONFIG_EXT_SWITCH) || (defined( ITF_GROUP_1P) && defined(ITF_GROUP))
	{ "vlan",		BYTE_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, vlan),			_SIZE_CE(MIB_CE_ATM_VC_T, vlan) },
	{ "vid",		WORD_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, vid),			_SIZE_CE(MIB_CE_ATM_VC_T, vid) },
	{ "vprio",		WORD_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, vprio),			_SIZE_CE(MIB_CE_ATM_VC_T, vprio) },
	{ "vpass",		BYTE_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, vpass),			_SIZE_CE(MIB_CE_ATM_VC_T, vpass) },
	{ "itfGroup",		BYTE_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, itfGroup),			_SIZE_CE(MIB_CE_ATM_VC_T, itfGroup) },
#endif
	{ "cpePppIfIndex",	DWORD_T,	_OFFSET_CE(MIB_CE_ATM_VC_T, cpePppIfIndex),		_SIZE_CE(MIB_CE_ATM_VC_T, cpePppIfIndex) },
	{ "cpeIpIndex",		DWORD_T,	_OFFSET_CE(MIB_CE_ATM_VC_T, cpeIpIndex),		_SIZE_CE(MIB_CE_ATM_VC_T, cpeIpIndex) },
#ifdef _CWMP_MIB_ /*jiunming, for cwmp-tr069*/
	{ "connDisable",	BYTE_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, connDisable),		_SIZE_CE(MIB_CE_ATM_VC_T, connDisable) },
	{ "ConDevInstNum",	DWORD_T,	_OFFSET_CE(MIB_CE_ATM_VC_T, ConDevInstNum),		_SIZE_CE(MIB_CE_ATM_VC_T, ConDevInstNum) },
	{ "ConIPInstNum",	DWORD_T,	_OFFSET_CE(MIB_CE_ATM_VC_T, ConIPInstNum),		_SIZE_CE(MIB_CE_ATM_VC_T, ConIPInstNum) },
	{ "ConPPPInstNum",	DWORD_T,	_OFFSET_CE(MIB_CE_ATM_VC_T, ConPPPInstNum),		_SIZE_CE(MIB_CE_ATM_VC_T, ConPPPInstNum) },
	{ "autoDisTime",	WORD_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, autoDisTime),		_SIZE_CE(MIB_CE_ATM_VC_T, autoDisTime) },
	{ "warnDisDelay",	WORD_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, warnDisDelay),		_SIZE_CE(MIB_CE_ATM_VC_T, warnDisDelay) },
	{ "pppServiceName",	STRING_T,	_OFFSET_CE(MIB_CE_ATM_VC_T, pppServiceName),		_SIZE_CE(MIB_CE_ATM_VC_T, pppServiceName) },
	{ "WanName",		STRING_T,	_OFFSET_CE(MIB_CE_ATM_VC_T, WanName),			_SIZE_CE(MIB_CE_ATM_VC_T, WanName) },
#ifdef _PRMT_TR143_
	{ "TR143UDPEchoItf",	BYTE_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, TR143UDPEchoItf),		_SIZE_CE(MIB_CE_ATM_VC_T, TR143UDPEchoItf) },
#endif
#ifdef _PRMT_X_CT_COM_PPPOEv2_
	{ "PPPoEProxyEnable",	BYTE_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, PPPoEProxyEnable),		_SIZE_CE(MIB_CE_ATM_VC_T, PPPoEProxyEnable) },
	{ "PPPoEProxyMaxUser",	DWORD_T,	_OFFSET_CE(MIB_CE_ATM_VC_T, PPPoEProxyMaxUser),		_SIZE_CE(MIB_CE_ATM_VC_T, PPPoEProxyMaxUser) },
#endif //_PRMT_X_CT_COM_PPPOEv2_
#ifdef _PRMT_X_CT_COM_WANEXT_
	{ "ServiceList",	WORD_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, ServiceList),		_SIZE_CE(MIB_CE_ATM_VC_T, ServiceList) },
#endif //_PRMT_X_CT_COM_WANEXT_
#endif //_CWMP_MIB_
#ifdef CTC_WAN_NAME
	{ "applicationtype",	DWORD_T,	_OFFSET_CE(MIB_CE_ATM_VC_T, applicationtype),		_SIZE_CE(MIB_CE_ATM_VC_T, applicationtype) },
#endif
#ifdef CONFIG_SPPPD_STATICIP
	{ "StaticPPPoE",	BYTE_T,		_OFFSET_CE(MIB_CE_ATM_VC_T, pppIp),			_SIZE_CE(MIB_CE_ATM_VC_T, pppIp) },
#endif
        //lhj, wan mac
       {"WanMAC",          STRING_T,         _OFFSET_CE(MIB_CE_ATM_VC_T, wanMAC),                 _SIZE_CE(MIB_CE_ATM_VC_T, wanMAC) },
	{0}
};

mib_chain_member_entry_T IP_ROUTE_DESC[]={
	{ "DstIP",		IA_T,		_OFFSET_CE(MIB_CE_IP_ROUTE_T, destID),			_SIZE_CE(MIB_CE_IP_ROUTE_T, destID) },
	{ "Mask",		IA_T,		_OFFSET_CE(MIB_CE_IP_ROUTE_T, netMask),			_SIZE_CE(MIB_CE_IP_ROUTE_T, netMask) },
	{ "NextHop",		IA_T,		_OFFSET_CE(MIB_CE_IP_ROUTE_T, nextHop),			_SIZE_CE(MIB_CE_IP_ROUTE_T, nextHop) },
	{ "Enable",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_ROUTE_T, Enable),			_SIZE_CE(MIB_CE_IP_ROUTE_T, Enable) },
	{ "Type",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_ROUTE_T, Type),			_SIZE_CE(MIB_CE_IP_ROUTE_T, Type) },
	{ "SourceIP",		IA_T,		_OFFSET_CE(MIB_CE_IP_ROUTE_T, SourceIP),		_SIZE_CE(MIB_CE_IP_ROUTE_T, SourceIP) },
	{ "SourceMask",		IA_T,		_OFFSET_CE(MIB_CE_IP_ROUTE_T, SourceMask),		_SIZE_CE(MIB_CE_IP_ROUTE_T, SourceMask) },
	{ "OutInf",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_ROUTE_T, ifIndex),			_SIZE_CE(MIB_CE_IP_ROUTE_T, ifIndex) },
	{ "FWMetric",		INTEGER_T,	_OFFSET_CE(MIB_CE_IP_ROUTE_T, FWMetric),		_SIZE_CE(MIB_CE_IP_ROUTE_T, FWMetric) },
	{ "InstanceNum",	DWORD_T,	_OFFSET_CE(MIB_CE_IP_ROUTE_T, InstanceNum),		_SIZE_CE(MIB_CE_IP_ROUTE_T, InstanceNum) },
#ifdef _PRMT_WT107_
	{ "Flags",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_ROUTE_T, Flags),			_SIZE_CE(MIB_CE_IP_ROUTE_T, Flags) },
#endif
	{0}
};

mib_chain_member_entry_T ACL_IP_DESC[]={
#ifdef ACL_IP_RANGE
	{ "StartIPAddr",	IA_T,		_OFFSET_CE(MIB_CE_ACL_IP_T, startipAddr),		_SIZE_CE(MIB_CE_ACL_IP_T, startipAddr) },
	{ "EndIPAddr",		IA_T,		_OFFSET_CE(MIB_CE_ACL_IP_T, endipAddr),			_SIZE_CE(MIB_CE_ACL_IP_T, endipAddr) },
#endif
	{ "IPAddr",		IA_T,		_OFFSET_CE(MIB_CE_ACL_IP_T, ipAddr),			_SIZE_CE(MIB_CE_ACL_IP_T, ipAddr) },
	{ "NetMask",		BYTE_T,		_OFFSET_CE(MIB_CE_ACL_IP_T, maskbit),			_SIZE_CE(MIB_CE_ACL_IP_T, maskbit) },
	{ "State",		BYTE_T,		_OFFSET_CE(MIB_CE_ACL_IP_T, Enabled),			_SIZE_CE(MIB_CE_ACL_IP_T, Enabled) },
	{ "Interface",		BYTE_T,		_OFFSET_CE(MIB_CE_ACL_IP_T, Interface),			_SIZE_CE(MIB_CE_ACL_IP_T, Interface) },
	{0}
};

#ifdef _PRMT_X_TELEFONICA_ES_DHCPOPTION_
mib_chain_member_entry_T DHCP_SERVER_OPTION_DESC[]={
	{ "ifIndex",		BYTE_T,		_OFFSET_CE(MIB_CE_DHCP_OPTION_T, ifIndex),		_SIZE_CE(MIB_CE_DHCP_OPTION_T, ifIndex) },
	{ "Enable",		BYTE_T,		_OFFSET_CE(MIB_CE_DHCP_OPTION_T, enable),		_SIZE_CE(MIB_CE_DHCP_OPTION_T, enable) },
	{ "Order",		DWORD_T,	_OFFSET_CE(MIB_CE_DHCP_OPTION_T, order),		_SIZE_CE(MIB_CE_DHCP_OPTION_T, order) },
	{ "Tag",		BYTE_T,		_OFFSET_CE(MIB_CE_DHCP_OPTION_T, tag),			_SIZE_CE(MIB_CE_DHCP_OPTION_T, tag) },
	{ "Len",		BYTE_T,		_OFFSET_CE(MIB_CE_DHCP_OPTION_T, len),			_SIZE_CE(MIB_CE_DHCP_OPTION_T, len) },
	{ "Value",		STRING_T,	_OFFSET_CE(MIB_CE_DHCP_OPTION_T, value),		_SIZE_CE(MIB_CE_DHCP_OPTION_T, value) },
	{ "UsedFor",		BYTE_T,		_OFFSET_CE(MIB_CE_DHCP_OPTION_T, usedFor),		_SIZE_CE(MIB_CE_DHCP_OPTION_T, usedFor) },
	{ "DhcpOptInstNum",	DWORD_T,	_OFFSET_CE(MIB_CE_DHCP_OPTION_T, dhcpOptInstNum),	_SIZE_CE(MIB_CE_DHCP_OPTION_T, dhcpOptInstNum) },
	{ "DhcpConSPInstNum",	DWORD_T,	_OFFSET_CE(MIB_CE_DHCP_OPTION_T, dhcpConSPInstNum),	_SIZE_CE(MIB_CE_DHCP_OPTION_T, dhcpConSPInstNum) },
	{0}
};
mib_chain_member_entry_T DHCP_CLIENT_OPTION_DESC[]={
	{ "ifIndex",		BYTE_T,		_OFFSET_CE(MIB_CE_DHCP_OPTION_T, ifIndex),		_SIZE_CE(MIB_CE_DHCP_OPTION_T, ifIndex) },
	{ "Enable",		BYTE_T,		_OFFSET_CE(MIB_CE_DHCP_OPTION_T, enable),		_SIZE_CE(MIB_CE_DHCP_OPTION_T, enable) },
	{ "Order",		DWORD_T,	_OFFSET_CE(MIB_CE_DHCP_OPTION_T, order),		_SIZE_CE(MIB_CE_DHCP_OPTION_T, order) },
	{ "Tag",		BYTE_T,		_OFFSET_CE(MIB_CE_DHCP_OPTION_T, tag),			_SIZE_CE(MIB_CE_DHCP_OPTION_T, tag) },
	{ "Len",		BYTE_T,		_OFFSET_CE(MIB_CE_DHCP_OPTION_T, len),			_SIZE_CE(MIB_CE_DHCP_OPTION_T, len) },
	{ "Value",		STRING_T,	_OFFSET_CE(MIB_CE_DHCP_OPTION_T, value),		_SIZE_CE(MIB_CE_DHCP_OPTION_T, value) },
	{ "UsedFor",		BYTE_T,		_OFFSET_CE(MIB_CE_DHCP_OPTION_T, usedFor),		_SIZE_CE(MIB_CE_DHCP_OPTION_T, usedFor) },
	{ "DhcpOptInstNum",	DWORD_T,	_OFFSET_CE(MIB_CE_DHCP_OPTION_T, dhcpOptInstNum),	_SIZE_CE(MIB_CE_DHCP_OPTION_T, dhcpOptInstNum) },
	{ "DhcpConSPInstNum",	DWORD_T,	_OFFSET_CE(MIB_CE_DHCP_OPTION_T, dhcpConSPInstNum),	_SIZE_CE(MIB_CE_DHCP_OPTION_T, dhcpConSPInstNum) },
	{0}
};
#endif

#ifdef MAC_ACL
mib_chain_member_entry_T ACL_MAC_DESC[]={
	{ "MacAddr",		BYTE6_T,	_OFFSET_CE(MIB_CE_ACL_MAC_T, macAddr),			_SIZE_CE(MIB_CE_ACL_MAC_T, macAddr) },
	{ "State",		BYTE_T,		_OFFSET_CE(MIB_CE_ACL_MAC_T, Enabled),			_SIZE_CE(MIB_CE_ACL_MAC_T, Enabled) },
	{ "Interface",		BYTE_T,		_OFFSET_CE(MIB_CE_ACL_MAC_T, Interface),		_SIZE_CE(MIB_CE_ACL_MAC_T, Interface) },
	{0}
};
#endif

#ifdef NAT_CONN_LIMIT
mib_chain_member_entry_T NAT_CONN_LIMIT_DESC[]={
	{ "IPAddr",		IA_T,		_OFFSET_CE(MIB_CE_CONN_LIMIT_T, ipAddr),		_SIZE_CE(MIB_CE_CONN_LIMIT_T, ipAddr) },
	{ "State",		BYTE_T,		_OFFSET_CE(MIB_CE_CONN_LIMIT_T, Enabled),		_SIZE_CE(MIB_CE_CONN_LIMIT_T, Enabled) },
	{ "connNum",		INTEGER_T,	_OFFSET_CE(MIB_CE_CONN_LIMIT_T, connNum),		_SIZE_CE(MIB_CE_CONN_LIMIT_T, connNum) },
	{0}
};
#endif

#ifdef TCP_UDP_CONN_LIMIT
mib_chain_member_entry_T TCP_UDP_CONN_LIMIT_DESC[]={
	{ "IPAddr",		IA_T,		_OFFSET_CE(MIB_CE_TCP_UDP_CONN_LIMIT_T, ipAddr),	_SIZE_CE(MIB_CE_TCP_UDP_CONN_LIMIT_T, ipAddr) },
	{ "State",		IA_T,		_OFFSET_CE(MIB_CE_TCP_UDP_CONN_LIMIT_T, Enabled),	_SIZE_CE(MIB_CE_TCP_UDP_CONN_LIMIT_T, Enabled) },
	{ "Protocol",		IA_T,		_OFFSET_CE(MIB_CE_TCP_UDP_CONN_LIMIT_T, protocol),	_SIZE_CE(MIB_CE_TCP_UDP_CONN_LIMIT_T, protocol) },
	{ "connNum",		IA_T,		_OFFSET_CE(MIB_CE_TCP_UDP_CONN_LIMIT_T, connNum),	_SIZE_CE(MIB_CE_TCP_UDP_CONN_LIMIT_T, connNum) },
	{0}
};
#endif

mib_chain_member_entry_T ADDRESS_MAPPING_DESC[]={
	{ "AddressMappingType",	BYTE_T,		_OFFSET_CE(MIB_CE_MULTI_ADDR_MAPPING_LIMIT_T, addressMapType),	_SIZE_CE(MIB_CE_MULTI_ADDR_MAPPING_LIMIT_T, addressMapType) },
	{ "LocalStartIP",	IA_T,		_OFFSET_CE(MIB_CE_MULTI_ADDR_MAPPING_LIMIT_T, lsip),		_SIZE_CE(MIB_CE_MULTI_ADDR_MAPPING_LIMIT_T, lsip) },
	{ "LocalEndIP",		IA_T,		_OFFSET_CE(MIB_CE_MULTI_ADDR_MAPPING_LIMIT_T, leip),		_SIZE_CE(MIB_CE_MULTI_ADDR_MAPPING_LIMIT_T, leip) },
	{ "GlobalStartIP",	IA_T,		_OFFSET_CE(MIB_CE_MULTI_ADDR_MAPPING_LIMIT_T, gsip),		_SIZE_CE(MIB_CE_MULTI_ADDR_MAPPING_LIMIT_T, gsip) },
	{ "GlobalEndIP",	IA_T,		_OFFSET_CE(MIB_CE_MULTI_ADDR_MAPPING_LIMIT_T, geip),		_SIZE_CE(MIB_CE_MULTI_ADDR_MAPPING_LIMIT_T, geip) },
	{0}
};

#ifdef URL_BLOCKING_SUPPORT
mib_chain_member_entry_T URL_FQDN_DESC[]={
	{ "URL",		STRING_T,	_OFFSET_CE(MIB_CE_URL_FQDN_T, fqdn),			_SIZE_CE(MIB_CE_URL_FQDN_T, fqdn) },
	{0}
};
#endif

#ifdef URL_ALLOWING_SUPPORT
mib_chain_member_entry_T URL_ALLOW_FQDN_DESC[]={
	{ "URLALW",		STRING_T,	_OFFSET_CE(MIB_CE_URL_ALLOW_FQDN_T, fqdn),		_SIZE_CE(MIB_CE_URL_ALLOW_FQDN_T, fqdn) },
	{0}
};
#endif

#ifdef URL_BLOCKING_SUPPORT
mib_chain_member_entry_T KEYWD_FILTER_DESC[]={
	{ "KEYWD",		STRING_T,	_OFFSET_CE(MIB_CE_KEYWD_FILTER_T, keyword),		_SIZE_CE(MIB_CE_KEYWD_FILTER_T, keyword) },
	{0}
};
#endif

#ifdef DOMAIN_BLOCKING_SUPPORT
mib_chain_member_entry_T DOMAIN_BLOCKING_DESC[]={
	{ "DOMAIN",		STRING_T,	_OFFSET_CE(MIB_CE_DOMAIN_BLOCKING_T, domain),		_SIZE_CE(MIB_CE_DOMAIN_BLOCKING_T, domain) },
	{0}
};
#endif

mib_chain_member_entry_T RIP_DESC[]={
	{ "IfIndex",		BYTE_T,		_OFFSET_CE(MIB_CE_RIP_T, ifIndex),			_SIZE_CE(MIB_CE_RIP_T, ifIndex) },
	{ "ReceiveMode",	BYTE_T,		_OFFSET_CE(MIB_CE_RIP_T, receiveMode),			_SIZE_CE(MIB_CE_RIP_T, receiveMode) },
	{ "SendMode",		BYTE_T,		_OFFSET_CE(MIB_CE_RIP_T, sendMode),			_SIZE_CE(MIB_CE_RIP_T, sendMode) },
	{0}
};

#ifdef CONFIG_USER_ZEBRA_OSPFD_OSPFD
mib_chain_member_entry_T OSPF_DESC[]={
	{ "ipAddr",	IA_T,		_OFFSET_CE(MIB_CE_OSPF_T, ipAddr),		_SIZE_CE(MIB_CE_OSPF_T, ipAddr) },
	{ "netMask", 	IA_T,		_OFFSET_CE(MIB_CE_OSPF_T, netMask),		_SIZE_CE(MIB_CE_OSPF_T, netMask) },
	{0}
};
#endif

#ifdef WLAN_MBSSID
mib_chain_member_entry_T MBSSIB_DESC[]={
	{ "idx",		BYTE_T,		_OFFSET_CE(MIB_CE_MBSSIB_T, idx),			_SIZE_CE(MIB_CE_MBSSIB_T, idx) },
	{ "encrypt",		BYTE_T,		_OFFSET_CE(MIB_CE_MBSSIB_T, encrypt),			_SIZE_CE(MIB_CE_MBSSIB_T, encrypt) },
	{ "enable1X",		BYTE_T,		_OFFSET_CE(MIB_CE_MBSSIB_T, enable1X),			_SIZE_CE(MIB_CE_MBSSIB_T, enable1X) },
	{ "wep",		BYTE_T,		_OFFSET_CE(MIB_CE_MBSSIB_T, wep),			_SIZE_CE(MIB_CE_MBSSIB_T, wep) },
	{ "wpaAuth",		BYTE_T,		_OFFSET_CE(MIB_CE_MBSSIB_T, wpaAuth),			_SIZE_CE(MIB_CE_MBSSIB_T, wpaAuth) },
	{ "wpaPSKFormat",	BYTE_T,		_OFFSET_CE(MIB_CE_MBSSIB_T, wpaPSKFormat),		_SIZE_CE(MIB_CE_MBSSIB_T, wpaPSKFormat) },
	{ "wpaPSK",		BYTE_T,		_OFFSET_CE(MIB_CE_MBSSIB_T, wpaPSK),			_SIZE_CE(MIB_CE_MBSSIB_T, wpaPSK) },
	{ "rsPort",		DWORD_T,	_OFFSET_CE(MIB_CE_MBSSIB_T, rsPort),			_SIZE_CE(MIB_CE_MBSSIB_T, rsPort) },
	{ "rsIpAddr",		IA_T,		_OFFSET_CE(MIB_CE_MBSSIB_T, rsIpAddr),			_SIZE_CE(MIB_CE_MBSSIB_T, rsIpAddr) },
	{ "rsPassword",		STRING_T,	_OFFSET_CE(MIB_CE_MBSSIB_T, rsPassword),		_SIZE_CE(MIB_CE_MBSSIB_T, rsPassword) },
	{ "wlanDisabled",	BYTE_T,		_OFFSET_CE(MIB_CE_MBSSIB_T, wlanDisabled),		_SIZE_CE(MIB_CE_MBSSIB_T, wlanDisabled) },
	{ "ssid",		STRING_T,	_OFFSET_CE(MIB_CE_MBSSIB_T, ssid),			_SIZE_CE(MIB_CE_MBSSIB_T, ssid) },
	{ "authType",		BYTE_T,		_OFFSET_CE(MIB_CE_MBSSIB_T, authType),			_SIZE_CE(MIB_CE_MBSSIB_T, authType) },
#ifdef _CWMP_MIB_ /*jiunming, mib for cwmp-tr069*/
	{ "cwmp_WLAN_BasicEncry",BYTE_T,	_OFFSET_CE(MIB_CE_MBSSIB_T, cwmp_WLAN_BasicEncry),	_SIZE_CE(MIB_CE_MBSSIB_T, cwmp_WLAN_BasicEncry) },
#endif
#ifdef ENABLE_WPAAES_WPA2TKIP
	{ "unicastCipher",	BYTE_T,		_OFFSET_CE(MIB_CE_MBSSIB_T, unicastCipher),		_SIZE_CE(MIB_CE_MBSSIB_T, unicastCipher) },
	{ "wpa2UnicastCipher",	BYTE_T,		_OFFSET_CE(MIB_CE_MBSSIB_T, wpa2UnicastCipher),		_SIZE_CE(MIB_CE_MBSSIB_T, wpa2UnicastCipher) },
#endif
	// ------------------- added by Julia 090713 ----------------------------
	{ "wlIsolation",		BYTE_T,		_OFFSET_CE(MIB_CE_MBSSIB_T, wlIsolation),				_SIZE_CE(MIB_CE_MBSSIB_T, wlIsolation)},
	{ "ethIsolation",		BYTE_T,		_OFFSET_CE(MIB_CE_MBSSIB_T, ethIsolation),				_SIZE_CE(MIB_CE_MBSSIB_T, ethIsolation)},
	// =================== added by Julia 090713 ============================
	{ "bcnAdvtisement",	BYTE_T,		_OFFSET_CE(MIB_CE_MBSSIB_T, bcnAdvtisement),		_SIZE_CE(MIB_CE_MBSSIB_T, bcnAdvtisement) },
	{ "hidessid",		BYTE_T,		_OFFSET_CE(MIB_CE_MBSSIB_T, hidessid),			_SIZE_CE(MIB_CE_MBSSIB_T, hidessid) },
	{0}
};

mib_chain_member_entry_T MBSSIB_WEP_DESC[]={
	{ "wep64Key1",		BYTE5_T,	_OFFSET_CE(MIB_CE_MBSSIB_WEP_T, wep64Key1),		_SIZE_CE(MIB_CE_MBSSIB_WEP_T, wep64Key1) },
	{ "wep64Key2",		BYTE5_T,	_OFFSET_CE(MIB_CE_MBSSIB_WEP_T, wep64Key2),		_SIZE_CE(MIB_CE_MBSSIB_WEP_T, wep64Key2) },
	{ "wep64Key3",		BYTE5_T,	_OFFSET_CE(MIB_CE_MBSSIB_WEP_T, wep64Key3),		_SIZE_CE(MIB_CE_MBSSIB_WEP_T, wep64Key3) },
	{ "wep64Key4",		BYTE5_T,	_OFFSET_CE(MIB_CE_MBSSIB_WEP_T, wep64Key4),		_SIZE_CE(MIB_CE_MBSSIB_WEP_T, wep64Key4) },
	{ "wep128Key1",		BYTE13_T,	_OFFSET_CE(MIB_CE_MBSSIB_WEP_T, wep128Key1),		_SIZE_CE(MIB_CE_MBSSIB_WEP_T, wep128Key1) },
	{ "wep128Key2",		BYTE13_T,	_OFFSET_CE(MIB_CE_MBSSIB_WEP_T, wep128Key2),		_SIZE_CE(MIB_CE_MBSSIB_WEP_T, wep128Key2) },
	{ "wep128Key3",		BYTE13_T,	_OFFSET_CE(MIB_CE_MBSSIB_WEP_T, wep128Key3),		_SIZE_CE(MIB_CE_MBSSIB_WEP_T, wep128Key3) },
	{ "wep128Key4",		BYTE13_T,	_OFFSET_CE(MIB_CE_MBSSIB_WEP_T, wep128Key4),		_SIZE_CE(MIB_CE_MBSSIB_WEP_T, wep128Key4) },
	{ "wepDefaultKey",	BYTE_T,		_OFFSET_CE(MIB_CE_MBSSIB_WEP_T, wepDefaultKey),		_SIZE_CE(MIB_CE_MBSSIB_WEP_T, wepDefaultKey) },
	{ "wepKeyType",		BYTE_T,		_OFFSET_CE(MIB_CE_MBSSIB_WEP_T, wepKeyType),		_SIZE_CE(MIB_CE_MBSSIB_WEP_T, wepKeyType) },
	{0}
};
#endif

#ifdef WLAN_SUPPORT
#ifdef WLAN_ACL
mib_chain_member_entry_T WLAN_AC_DESC[]={
	{ "MacAddr",		BYTE6_T,		_OFFSET_CE(MIB_CE_WLAN_AC_T, macAddr),		_SIZE_CE(MIB_CE_WLAN_AC_T, macAddr) },
	{0}
};
#endif
#endif

// Mason Yu. combine_1p_4p_PortMapping
#if defined( CONFIG_EXT_SWITCH) || (defined( ITF_GROUP_1P) && defined(ITF_GROUP))
mib_chain_member_entry_T SW_PORT_DESC[]={
	{ "PVCInterface",	BYTE_T,		_OFFSET_CE(MIB_CE_SW_PORT_T, pvcItf),			_SIZE_CE(MIB_CE_SW_PORT_T, pvcItf) },
	{ "InterfaceGroup",	BYTE_T,		_OFFSET_CE(MIB_CE_SW_PORT_T, itfGroup),			_SIZE_CE(MIB_CE_SW_PORT_T, itfGroup) },
	{ "PVID",		BYTE_T,		_OFFSET_CE(MIB_CE_SW_PORT_T, pvid),			_SIZE_CE(MIB_CE_SW_PORT_T, pvid) },
	{ "EgressTag",		BYTE_T,		_OFFSET_CE(MIB_CE_SW_PORT_T, egressTagAction),		_SIZE_CE(MIB_CE_SW_PORT_T, egressTagAction) },
	{ "LinkMode",		BYTE_T,		_OFFSET_CE(MIB_CE_SW_PORT_T, linkMode),			_SIZE_CE(MIB_CE_SW_PORT_T, linkMode) },
	{0}
};
#endif

#ifdef CONFIG_EXT_SWITCH
mib_chain_member_entry_T VLAN_DESC[]={
	{ "Member",		DWORD_T,	_OFFSET_CE(MIB_CE_VLAN_T, member),			_SIZE_CE(MIB_CE_VLAN_T, member) },
	{ "Tag",		WORD_T,		_OFFSET_CE(MIB_CE_VLAN_T, tag),				_SIZE_CE(MIB_CE_VLAN_T, tag) },
	{ "Dhcps",		BYTE_T,		_OFFSET_CE(MIB_CE_VLAN_T, dhcps),			_SIZE_CE(MIB_CE_VLAN_T, dhcps) },
	{ "IGMP",		BYTE_T,		_OFFSET_CE(MIB_CE_VLAN_T, igmp),			_SIZE_CE(MIB_CE_VLAN_T, igmp) },
	{0}
};
#endif

#ifdef NEW_IP_QOS_SUPPORT
mib_chain_member_entry_T QOS_TC_DESC[]={
	{ "entryid",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_TC_T, entryid),			_SIZE_CE(MIB_CE_IP_TC_T, entryid) },
	{ "ifIndex",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_TC_T, ifIndex ),			_SIZE_CE(MIB_CE_IP_TC_T, ifIndex ) },
	{ "Srcip",		DWORD_T,	_OFFSET_CE(MIB_CE_IP_TC_T, srcip),			_SIZE_CE(MIB_CE_IP_TC_T, srcip) },
	{ "srcmask",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_TC_T, smaskbits),			_SIZE_CE(MIB_CE_IP_TC_T, smaskbits) },
	{ "dstip",		DWORD_T,	_OFFSET_CE(MIB_CE_IP_TC_T, dstip),			_SIZE_CE(MIB_CE_IP_TC_T, dstip) },
	{ "dstmask",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_TC_T, dmaskbits),			_SIZE_CE(MIB_CE_IP_TC_T, dmaskbits) },
	{ "srcport",		WORD_T,		_OFFSET_CE(MIB_CE_IP_TC_T, sport),			_SIZE_CE(MIB_CE_IP_TC_T, sport) },
	{ "dstport",		WORD_T,		_OFFSET_CE(MIB_CE_IP_TC_T, dport),			_SIZE_CE(MIB_CE_IP_TC_T, dport) },
	{ "protocol",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_TC_T, protoType),			_SIZE_CE(MIB_CE_IP_TC_T, protoType) },
	{ "rate",		DWORD_T,	_OFFSET_CE(MIB_CE_IP_TC_T, limitSpeed),			_SIZE_CE(MIB_CE_IP_TC_T, limitSpeed) },
	{0}
};
#endif

#ifdef IP_QOS
mib_chain_member_entry_T QOS_QUEUE_DESC[]={
	{ "outif",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_QOS_QUEUE_T, outif),			_SIZE_CE(MIB_CE_IP_QOS_QUEUE_T, outif) },
	{ "prior",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_QOS_QUEUE_T, prior ),			_SIZE_CE(MIB_CE_IP_QOS_QUEUE_T, prior ) },
	{ "enable",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_QOS_QUEUE_T, enable),			_SIZE_CE(MIB_CE_IP_QOS_QUEUE_T, enable) },
	{ "desc",		STRING_T,	_OFFSET_CE(MIB_CE_IP_QOS_QUEUE_T, desc),			_SIZE_CE(MIB_CE_IP_QOS_QUEUE_T, desc) },
#ifdef _CWMP_MIB_ /*mib for cwmp-tr069*/
	{ "QueueInstNum",	DWORD_T,	_OFFSET_CE(MIB_CE_IP_QOS_QUEUE_T, QueueInstNum),		_SIZE_CE(MIB_CE_IP_QOS_QUEUE_T, QueueInstNum) },
#endif
	{0}
};

mib_chain_member_entry_T IP_QOS_DESC[]={
	{ "SrcIP",		IA_T,		_OFFSET_CE(MIB_CE_IP_QOS_T, sip),			_SIZE_CE(MIB_CE_IP_QOS_T, sip) },
	{ "SrcMask",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_QOS_T, smaskbit),			_SIZE_CE(MIB_CE_IP_QOS_T, smaskbit) },
	{ "SrcPort",		WORD_T,		_OFFSET_CE(MIB_CE_IP_QOS_T, sPort),			_SIZE_CE(MIB_CE_IP_QOS_T, sPort) },
	{ "DstIP",		IA_T,		_OFFSET_CE(MIB_CE_IP_QOS_T, dip),			_SIZE_CE(MIB_CE_IP_QOS_T, dip) },
	{ "DstMask",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_QOS_T, dmaskbit),			_SIZE_CE(MIB_CE_IP_QOS_T, dmaskbit) },
	{ "DstPort",		WORD_T,		_OFFSET_CE(MIB_CE_IP_QOS_T, dPort),			_SIZE_CE(MIB_CE_IP_QOS_T, dPort) },
	{ "Protocol",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_QOS_T, protoType),			_SIZE_CE(MIB_CE_IP_QOS_T, protoType) },
	{ "PhyPort",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_QOS_T, phyPort),			_SIZE_CE(MIB_CE_IP_QOS_T, phyPort) },
//#ifdef NEW_IP_QOS_SUPPORT
#if defined(NEW_IP_QOS_SUPPORT) || defined(QOS_DIFFSERV)
	{ "qosDscp",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_QOS_T, qosDscp),			_SIZE_CE(MIB_CE_IP_QOS_T, qosDscp) },
#endif
#ifdef NEW_IP_QOS_SUPPORT
	{ "vlan1p",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_QOS_T, vlan1p),			_SIZE_CE(MIB_CE_IP_QOS_T, vlan1p) },
#endif
	{ "OutInf",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_QOS_T, outif),			_SIZE_CE(MIB_CE_IP_QOS_T, outif) },
	{ "Prior",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_QOS_T, prior),			_SIZE_CE(MIB_CE_IP_QOS_T, prior) },
#ifdef QOS_DSCP
	{ "Dscp",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_QOS_T, dscp),			_SIZE_CE(MIB_CE_IP_QOS_T, dscp) },
#endif
	{ "m_ipprio",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_QOS_T, m_ipprio),			_SIZE_CE(MIB_CE_IP_QOS_T, m_ipprio) },
	{ "m_iptos",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_QOS_T, m_iptos),			_SIZE_CE(MIB_CE_IP_QOS_T, m_iptos) },
	{ "m_1p",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_QOS_T, m_1p),			_SIZE_CE(MIB_CE_IP_QOS_T, m_1p) },
#ifdef NEW_IP_QOS_SUPPORT
	{ "m_dscp",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_QOS_T, m_dscp),			_SIZE_CE(MIB_CE_IP_QOS_T, m_dscp) },
#endif
	{ "Enable",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_QOS_T, enable),			_SIZE_CE(MIB_CE_IP_QOS_T, enable) },
#ifdef _CWMP_MIB_ /*jiunming, mib for cwmp-tr069*/
	{ "InstanceNum",	DWORD_T,	_OFFSET_CE(MIB_CE_IP_QOS_T, InstanceNum),		_SIZE_CE(MIB_CE_IP_QOS_T, InstanceNum) },
#endif
#ifdef QOS_SPEED_LIMIT_SUPPORT
	{ "limitSpeedEnabled",	BYTE_T,		_OFFSET_CE(MIB_CE_IP_QOS_T, limitSpeedEnabled),		_SIZE_CE(MIB_CE_IP_QOS_T, limitSpeedEnabled) },
	{ "limitSpeedRank",	BYTE_T,		_OFFSET_CE(MIB_CE_IP_QOS_T, limitSpeedRank),		_SIZE_CE(MIB_CE_IP_QOS_T, limitSpeedRank) },
#endif
#ifdef QOS_DIFFSERV
	{ "ifIndex",			BYTE_T,		_OFFSET_CE(MIB_CE_IP_QOS_T, ifIndex),			_SIZE_CE(MIB_CE_IP_QOS_T, ifIndex) },
	{ "enDiffserv",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_QOS_T, enDiffserv),			_SIZE_CE(MIB_CE_IP_QOS_T, enDiffserv) },
	{ "totalBandwidth",		WORD_T,		_OFFSET_CE(MIB_CE_IP_QOS_T, totalBandwidth),		_SIZE_CE(MIB_CE_IP_QOS_T, totalBandwidth) },
	{ "htbRate",			WORD_T,		_OFFSET_CE(MIB_CE_IP_QOS_T, htbRate),			_SIZE_CE(MIB_CE_IP_QOS_T, htbRate) },
	{ "latency",			DWORD_T,	_OFFSET_CE(MIB_CE_IP_QOS_T, latency),			_SIZE_CE(MIB_CE_IP_QOS_T, latency) },
	{ "limitSpeed",		DWORD_T,	_OFFSET_CE(MIB_CE_IP_QOS_T, limitSpeed),			_SIZE_CE(MIB_CE_IP_QOS_T, limitSpeed) },
	{ "policing",			BYTE_T,		_OFFSET_CE(MIB_CE_IP_QOS_T, policing),			_SIZE_CE(MIB_CE_IP_QOS_T, policing) },
#endif
	{ "flags",		WORD_T,		_OFFSET_CE(MIB_CE_IP_QOS_T, flags),			_SIZE_CE(MIB_CE_IP_QOS_T, flags) },
	{0}
};
#endif // of IP_QOS

#ifdef QOS_SPEED_LIMIT_SUPPORT
mib_chain_member_entry_T MBQOS_SPEED_LIMIT_DESC[]={
	{ "index",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_QOS_SPEEDRANK_T, index),		_SIZE_CE(MIB_CE_IP_QOS_SPEEDRANK_T, index) },
	{ "prior",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_QOS_SPEEDRANK_T, prior),		_SIZE_CE(MIB_CE_IP_QOS_SPEEDRANK_T, prior) },
	{ "speed",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_QOS_SPEEDRANK_T, speed),		_SIZE_CE(MIB_CE_IP_QOS_SPEEDRANK_T, speed) },
	{ "count",		BYTE_T,		_OFFSET_CE(MIB_CE_IP_QOS_SPEEDRANK_T, count),		_SIZE_CE(MIB_CE_IP_QOS_SPEEDRANK_T, count) },
	{0}
};
#endif

mib_chain_member_entry_T ACC_DESC[]={
	{ "telnet",		BYTE_T,		_OFFSET_CE(MIB_CE_ACC_T, telnet),			_SIZE_CE(MIB_CE_ACC_T, telnet) },
	{ "ftp",		BYTE_T,		_OFFSET_CE(MIB_CE_ACC_T, ftp),				_SIZE_CE(MIB_CE_ACC_T, ftp) },
	{ "tftp",		BYTE_T,		_OFFSET_CE(MIB_CE_ACC_T, tftp),				_SIZE_CE(MIB_CE_ACC_T, tftp) },
	{ "web",		BYTE_T,		_OFFSET_CE(MIB_CE_ACC_T, web),				_SIZE_CE(MIB_CE_ACC_T, web) },
	{ "snmp",		BYTE_T,		_OFFSET_CE(MIB_CE_ACC_T, snmp),				_SIZE_CE(MIB_CE_ACC_T, snmp) },
	{ "ssh",		BYTE_T,		_OFFSET_CE(MIB_CE_ACC_T, ssh),				_SIZE_CE(MIB_CE_ACC_T, ssh) },
	{ "icmp",		BYTE_T,		_OFFSET_CE(MIB_CE_ACC_T, icmp),				_SIZE_CE(MIB_CE_ACC_T, icmp) },
	{ "telnet_port",	DWORD_T,	_OFFSET_CE(MIB_CE_ACC_T, telnet_port),			_SIZE_CE(MIB_CE_ACC_T, telnet_port) },
	{ "web_port",		DWORD_T,	_OFFSET_CE(MIB_CE_ACC_T, web_port),			_SIZE_CE(MIB_CE_ACC_T, web_port) },
	{ "ftp_port",		DWORD_T,	_OFFSET_CE(MIB_CE_ACC_T, ftp_port),			_SIZE_CE(MIB_CE_ACC_T, ftp_port) },
	{ "https",		BYTE_T,		_OFFSET_CE(MIB_CE_ACC_T, https),			_SIZE_CE(MIB_CE_ACC_T, https) },
	{ "https_port",		DWORD_T,	_OFFSET_CE(MIB_CE_ACC_T, https_port),			_SIZE_CE(MIB_CE_ACC_T, https_port) },
	{0}
};

#ifdef WLAN_WDS
mib_chain_member_entry_T WDS_DESC[]={
	{ "MacAddr",		BYTE6_T,	_OFFSET_CE(WDS_T, macAddr),				_SIZE_CE(WDS_T, macAddr) },
	{ "Comment",		STRING_T,	_OFFSET_CE(WDS_T, comment),				_SIZE_CE(WDS_T, comment) },
	{0}
};

#endif
#ifdef _CWMP_MIB_
#ifdef WLAN_SUPPORT
mib_chain_member_entry_T CWMP_PSK_DESC[]={
	{ "index",		BYTE_T,		_OFFSET_CE(CWMP_PSK_T, index),				_SIZE_CE(CWMP_PSK_T, index) },
	{ "presharedkey",	STRING_T,	_OFFSET_CE(CWMP_PSK_T, presharedkey),			_SIZE_CE(CWMP_PSK_T, presharedkey) },
	{ "keypassphrase",	STRING_T,	_OFFSET_CE(CWMP_PSK_T, keypassphrase),			_SIZE_CE(CWMP_PSK_T, keypassphrase) },
	{0}
};
#endif
#endif

mib_chain_member_entry_T MAC_BASE_DHCP_DESC[]={
	{ "macAddr",		BYTE6_T,	_OFFSET_CE(MIB_CE_MAC_BASE_DHCP_T, macAddr_Dhcp),		_SIZE_CE(MIB_CE_MAC_BASE_DHCP_T, macAddr_Dhcp) },
	{ "ipAddr",		IA_T,		_OFFSET_CE(MIB_CE_MAC_BASE_DHCP_T, ipAddr_Dhcp),		_SIZE_CE(MIB_CE_MAC_BASE_DHCP_T, ipAddr_Dhcp) },
	{0}
};

#ifdef TRAFFIC_SHAPING_support
mib_chain_member_entry_T ITF_SHAPING_DESC[]={
	{ "encaptype",		INTEGER_T,	_OFFSET_CE(MIB_CE_IPQOS_ITF_SHAPE_T, itfEncapType),	_SIZE_CE(MIB_CE_IPQOS_ITF_SHAPE_T, itfEncapType) },
	{ "bandwidth",		INTEGER_T,	_OFFSET_CE(MIB_CE_IPQOS_ITF_SHAPE_T, bandwidth),	_SIZE_CE(MIB_CE_IPQOS_ITF_SHAPE_T, bandwidth) },
	{0}
};
#endif

mib_chain_member_entry_T AUTO_PVC_SEARCH_DESC[]={
	{ "VPI",		WORD_T,		_OFFSET_CE(MIB_AUTO_PVC_SEARCH_T, vpi),			_SIZE_CE(MIB_AUTO_PVC_SEARCH_T, vpi) },
	{ "VCI",		DWORD_T,	_OFFSET_CE(MIB_AUTO_PVC_SEARCH_T, vci),			_SIZE_CE(MIB_AUTO_PVC_SEARCH_T, vci) },
	{0}
};

#ifdef CONFIG_USER_DDNS
mib_chain_member_entry_T DDNS_DESC[]={
	{ "Provider",		STRING_T,	_OFFSET_CE(MIB_CE_DDNS_T, provider),			_SIZE_CE(MIB_CE_DDNS_T, provider) },
	{ "Hostname",		STRING_T,	_OFFSET_CE(MIB_CE_DDNS_T, hostname),			_SIZE_CE(MIB_CE_DDNS_T, hostname) },
	{ "Interface",		STRING_T,	_OFFSET_CE(MIB_CE_DDNS_T, interface),			_SIZE_CE(MIB_CE_DDNS_T, interface) },
	{ "Username",		STRING_T,	_OFFSET_CE(MIB_CE_DDNS_T, username),			_SIZE_CE(MIB_CE_DDNS_T, username) },
	{ "Password",		STRING_T,	_OFFSET_CE(MIB_CE_DDNS_T, password),			_SIZE_CE(MIB_CE_DDNS_T, password) },
	{ "Enabled",		BYTE_T,		_OFFSET_CE(MIB_CE_DDNS_T, Enabled),			_SIZE_CE(MIB_CE_DDNS_T, Enabled) },
	{ "InstanceNum",	DWORD_T,	_OFFSET_CE(MIB_CE_DDNS_T, InstanceNum),			_SIZE_CE(MIB_CE_DDNS_T, InstanceNum) },
	{ "ServicePort",	WORD_T,		_OFFSET_CE(MIB_CE_DDNS_T, ServicePort),			_SIZE_CE(MIB_CE_DDNS_T, ServicePort) },
	{0}
};
#endif

mib_chain_member_entry_T PPPOE_SESSION_DESC[]={
	{ "InterfaceNo",	BYTE_T,		_OFFSET_CE(MIB_CE_PPPOE_SESSION_T, ifNo),		_SIZE_CE(MIB_CE_PPPOE_SESSION_T, ifNo) },
	{ "VPI",		BYTE_T,		_OFFSET_CE(MIB_CE_PPPOE_SESSION_T, vpi),		_SIZE_CE(MIB_CE_PPPOE_SESSION_T, vpi) },
	{ "VCI",		WORD_T,		_OFFSET_CE(MIB_CE_PPPOE_SESSION_T, vci),		_SIZE_CE(MIB_CE_PPPOE_SESSION_T, vci) },
	{ "ACMacAddr",		BYTE6_T,	_OFFSET_CE(MIB_CE_PPPOE_SESSION_T, acMac),		_SIZE_CE(MIB_CE_PPPOE_SESSION_T, acMac) },
	{ "SessionID",		WORD_T,		_OFFSET_CE(MIB_CE_PPPOE_SESSION_T, sessionId),		_SIZE_CE(MIB_CE_PPPOE_SESSION_T, sessionId) },
	{0}
};

#ifdef _PRMT_X_TELEFONICA_ES_DHCPOPTION_
mib_chain_member_entry_T DHCPS_SERVING_POOL_DESC[]={
	{ "enable",		BYTE_T,		_OFFSET_CE(DHCPS_SERVING_POOL_T, enable),		_SIZE_CE(DHCPS_SERVING_POOL_T, enable) },
	{ "poolorder",		DWORD_T,	_OFFSET_CE(DHCPS_SERVING_POOL_T, poolorder),		_SIZE_CE(DHCPS_SERVING_POOL_T, poolorder) },
	{ "poolname",		STRING_T,	_OFFSET_CE(DHCPS_SERVING_POOL_T, poolname),		_SIZE_CE(DHCPS_SERVING_POOL_T, poolname) },
	{ "deviceType",		BYTE_T,		_OFFSET_CE(DHCPS_SERVING_POOL_T, deviceType),		_SIZE_CE(DHCPS_SERVING_POOL_T, deviceType) },
	{ "rsvOptCode",		BYTE_T,		_OFFSET_CE(DHCPS_SERVING_POOL_T, rsvOptCode),		_SIZE_CE(DHCPS_SERVING_POOL_T, rsvOptCode) },
	{ "sourceinterface",	BYTE_T,		_OFFSET_CE(DHCPS_SERVING_POOL_T, sourceinterface),	_SIZE_CE(DHCPS_SERVING_POOL_T, sourceinterface) },
	{ "vendorclass",	STRING_T,	_OFFSET_CE(DHCPS_SERVING_POOL_T, vendorclass),		_SIZE_CE(DHCPS_SERVING_POOL_T, vendorclass) },
	{ "vendorclassflag",	BYTE_T,		_OFFSET_CE(DHCPS_SERVING_POOL_T, vendorclassflag),	_SIZE_CE(DHCPS_SERVING_POOL_T, vendorclassflag) },
	{ "vendorclassmode",	STRING_T,	_OFFSET_CE(DHCPS_SERVING_POOL_T, vendorclassmode),	_SIZE_CE(DHCPS_SERVING_POOL_T, vendorclassmode) },
	{ "clientid",		STRING_T,	_OFFSET_CE(DHCPS_SERVING_POOL_T, clientid),		_SIZE_CE(DHCPS_SERVING_POOL_T, clientid) },
	{ "clientidflag",	BYTE_T,		_OFFSET_CE(DHCPS_SERVING_POOL_T, clientidflag),		_SIZE_CE(DHCPS_SERVING_POOL_T, clientidflag) },
	{ "userclass",		STRING_T,	_OFFSET_CE(DHCPS_SERVING_POOL_T, userclass),		_SIZE_CE(DHCPS_SERVING_POOL_T, userclass) },
	{ "userclassflag",	BYTE_T,		_OFFSET_CE(DHCPS_SERVING_POOL_T, userclassflag),	_SIZE_CE(DHCPS_SERVING_POOL_T, userclassflag) },
	{ "chaddr",		BYTE6_T,	_OFFSET_CE(DHCPS_SERVING_POOL_T, chaddr),		_SIZE_CE(DHCPS_SERVING_POOL_T, chaddr) },
	{ "chaddrmask",		BYTE6_T,	_OFFSET_CE(DHCPS_SERVING_POOL_T, chaddrmask),		_SIZE_CE(DHCPS_SERVING_POOL_T, chaddrmask) },
	{ "chaddrflag",		BYTE_T,		_OFFSET_CE(DHCPS_SERVING_POOL_T, chaddrflag),		_SIZE_CE(DHCPS_SERVING_POOL_T, chaddrflag) },
	{ "localserved",	WORD_T,		_OFFSET_CE(DHCPS_SERVING_POOL_T, localserved),		_SIZE_CE(DHCPS_SERVING_POOL_T, localserved) },
	{ "startaddr",		IA_T,		_OFFSET_CE(DHCPS_SERVING_POOL_T, startaddr),		_SIZE_CE(DHCPS_SERVING_POOL_T, startaddr) },
	{ "endaddr",		IA_T,		_OFFSET_CE(DHCPS_SERVING_POOL_T, endaddr),		_SIZE_CE(DHCPS_SERVING_POOL_T, endaddr) },
	{ "subnetmask",		IA_T,		_OFFSET_CE(DHCPS_SERVING_POOL_T, subnetmask),		_SIZE_CE(DHCPS_SERVING_POOL_T, subnetmask) },
	{ "iprouter",		IA_T,		_OFFSET_CE(DHCPS_SERVING_POOL_T, iprouter),		_SIZE_CE(DHCPS_SERVING_POOL_T, iprouter) },
	{ "dnsserver1",		IA_T,		_OFFSET_CE(DHCPS_SERVING_POOL_T, dnsserver1),		_SIZE_CE(DHCPS_SERVING_POOL_T, dnsserver1) },
	{ "dnsserver2",		IA_T,		_OFFSET_CE(DHCPS_SERVING_POOL_T, dnsserver2),		_SIZE_CE(DHCPS_SERVING_POOL_T, dnsserver2) },
	{ "dnsserver3",		IA_T,		_OFFSET_CE(DHCPS_SERVING_POOL_T, dnsserver3),		_SIZE_CE(DHCPS_SERVING_POOL_T, dnsserver3) },
	{ "domainname",		STRING_T,	_OFFSET_CE(DHCPS_SERVING_POOL_T, domainname),		_SIZE_CE(DHCPS_SERVING_POOL_T, domainname) },
	{ "leasetime",		INTEGER_T,	_OFFSET_CE(DHCPS_SERVING_POOL_T, leasetime),		_SIZE_CE(DHCPS_SERVING_POOL_T, leasetime) },
	{ "dhcprelayip",	IA_T,		_OFFSET_CE(DHCPS_SERVING_POOL_T, dhcprelayip),		_SIZE_CE(DHCPS_SERVING_POOL_T, dhcprelayip) },
	{ "dnsservermode",	BYTE_T,		_OFFSET_CE(DHCPS_SERVING_POOL_T, dnsservermode),	_SIZE_CE(DHCPS_SERVING_POOL_T, dnsservermode) },
#ifdef _CWMP_MIB_
	{ "InstanceNum",	DWORD_T,	_OFFSET_CE(DHCPS_SERVING_POOL_T, InstanceNum),		_SIZE_CE(DHCPS_SERVING_POOL_T, InstanceNum) },
#endif
	{0}
};
#endif
#ifdef PARENTAL_CTRL
mib_chain_member_entry_T PARENTAL_CTRL_DESC[]={
	{ "Username",		STRING_T,	_OFFSET_CE(MIB_PARENT_CTRL_T, username),		_SIZE_CE(MIB_PARENT_CTRL_T, username) },
	{ "MAC",		BYTE6_T,	_OFFSET_CE(MIB_PARENT_CTRL_T, mac),			_SIZE_CE(MIB_PARENT_CTRL_T, mac) },
	{ "Day",		BYTE_T,		_OFFSET_CE(MIB_PARENT_CTRL_T, controlled_day),		_SIZE_CE(MIB_PARENT_CTRL_T, controlled_day) },
	{ "Start_hr",		BYTE_T,		_OFFSET_CE(MIB_PARENT_CTRL_T, start_hr),		_SIZE_CE(MIB_PARENT_CTRL_T, start_hr) },
	{ "Start_min",		BYTE_T,		_OFFSET_CE(MIB_PARENT_CTRL_T, start_min),		_SIZE_CE(MIB_PARENT_CTRL_T, start_min) },
	{ "End_hr",		BYTE_T,		_OFFSET_CE(MIB_PARENT_CTRL_T, end_hr),			_SIZE_CE(MIB_PARENT_CTRL_T, end_hr) },
	{ "End_min",		BYTE_T,		_OFFSET_CE(MIB_PARENT_CTRL_T, end_min),			_SIZE_CE(MIB_PARENT_CTRL_T, end_min) },
	{ "State",		BYTE_T,		_OFFSET_CE(MIB_PARENT_CTRL_T, cur_state),		_SIZE_CE(MIB_PARENT_CTRL_T, cur_state) },
	{0}
};
#endif

#ifdef _SUPPORT_CAPTIVEPORTAL_PROFILE_
mib_chain_member_entry_T CAPTIVEPORTAL_ALLOWED_LIST_DESC[] =
{
	{ "ipAddr",	 IA_T, _OFFSET_CE(CWMP_CAPTIVEPORTAL_ALLOWED_LIST_T, ip_addr),		_SIZE_CE(CWMP_CAPTIVEPORTAL_ALLOWED_LIST_T, ip_addr) },
	{ "mask",	 BYTE_T, _OFFSET_CE(CWMP_CAPTIVEPORTAL_ALLOWED_LIST_T, mask),		_SIZE_CE(CWMP_CAPTIVEPORTAL_ALLOWED_LIST_T, mask) },
	{0}
};
#endif

#ifdef WLAN_QoS
mib_chain_member_entry_T WLAN_QOS_DESC[]={
	{ "aifsn",		INTEGER_T,	_OFFSET_CE(MIB_WLAN_QOS_T, aifsn),		_SIZE_CE(MIB_WLAN_QOS_T, aifsn) },
	{ "ecwmin",		INTEGER_T,		_OFFSET_CE(MIB_WLAN_QOS_T, ecwmin),		_SIZE_CE(MIB_WLAN_QOS_T, ecwmin) },
	{ "ecwmax",		INTEGER_T,	_OFFSET_CE(MIB_WLAN_QOS_T, ecwmax),		_SIZE_CE(MIB_WLAN_QOS_T, ecwmax) },
	{ "txop",		INTEGER_T,		_OFFSET_CE(MIB_WLAN_QOS_T, txop),		_SIZE_CE(MIB_WLAN_QOS_T, txop) },
	{ "ack",		INTEGER_T,		_OFFSET_CE(MIB_WLAN_QOS_T, ack),		_SIZE_CE(MIB_WLAN_QOS_T, ack) },
	{0}
};

#endif

#ifdef SUPPORT_DHCP_RESERVED_IPADDR
mib_chain_member_entry_T DHCP_RESERVED_IPADDR_DESC[] =
{
	{ "InstanceNum",	DWORD_T,	_OFFSET_CE(MIB_DHCP_RESERVED_IPADDR_T, InstanceNum),		_SIZE_CE(MIB_DHCP_RESERVED_IPADDR_T, InstanceNum) },
	{ "IPAddr",		IA_T,		_OFFSET_CE(MIB_DHCP_RESERVED_IPADDR_T, IPAddr),			_SIZE_CE(MIB_DHCP_RESERVED_IPADDR_T, IPAddr) },
	{0}
};
#endif //SUPPORT_DHCP_RESERVED_IPADDR

#ifdef CONFIG_USER_PPPOMODEM
mib_chain_member_entry_T WAN_3G_DESC[] =
{
	{ "enable",	BYTE_T,		_OFFSET_CE(MIB_WAN_3G_T, enable),	_SIZE_CE(MIB_WAN_3G_T, enable) },
	{ "auth",	BYTE_T,		_OFFSET_CE(MIB_WAN_3G_T, auth),		_SIZE_CE(MIB_WAN_3G_T, auth) },
	{ "ctype",	BYTE_T,		_OFFSET_CE(MIB_WAN_3G_T, ctype),	_SIZE_CE(MIB_WAN_3G_T, ctype) },
	{ "napt",	BYTE_T,		_OFFSET_CE(MIB_WAN_3G_T, napt),		_SIZE_CE(MIB_WAN_3G_T, napt) },
	{ "pin",	WORD_T,		_OFFSET_CE(MIB_WAN_3G_T, pin),		_SIZE_CE(MIB_WAN_3G_T, pin) },
	{ "idletime",	WORD_T,		_OFFSET_CE(MIB_WAN_3G_T, idletime),	_SIZE_CE(MIB_WAN_3G_T, idletime) },
	{ "mtu",	WORD_T,		_OFFSET_CE(MIB_WAN_3G_T, mtu),		_SIZE_CE(MIB_WAN_3G_T, mtu) },
	{ "dgw",	BYTE_T,		_OFFSET_CE(MIB_WAN_3G_T, dgw),		_SIZE_CE(MIB_WAN_3G_T, dgw) },
	{ "apn",	STRING_T,	_OFFSET_CE(MIB_WAN_3G_T, apn),		_SIZE_CE(MIB_WAN_3G_T, apn) },
	{ "dial",	STRING_T,	_OFFSET_CE(MIB_WAN_3G_T, dial),		_SIZE_CE(MIB_WAN_3G_T, dial) },
	{ "username",	STRING_T,	_OFFSET_CE(MIB_WAN_3G_T, username),	_SIZE_CE(MIB_WAN_3G_T, username) },
	{ "password",	STRING_T,	_OFFSET_CE(MIB_WAN_3G_T, password),	_SIZE_CE(MIB_WAN_3G_T, password) },
	{0}
};
#endif //CONFIG_USER_PPPOMODEM


mib_chain_record_table_entry_T mib_chain_record_table[]={

MIB_CHAIN_TBL_ENTRY(MIB_ATM_VC_TBL,		CURRENT_SETTING,	"ATM_VC_TBL",			sizeof(MIB_CE_ATM_VC_T),		MAX_VC_NUM,	0, mib_atm_vc_default_table, sizeof(mib_atm_vc_default_table), ATM_VC_DESC),
MIB_CHAIN_TBL_ENTRY(MIB_IP_PORT_FILTER_TBL,	CURRENT_SETTING,	"IP_PORT_FILTER_TBL",		sizeof(MIB_CE_IP_PORT_FILTER_T),		MAX_FILTER_NUM,		0,		0,		0, IP_PORT_FILTER_DESC),
#ifdef MAC_FILTER
MIB_CHAIN_TBL_ENTRY(MIB_MAC_FILTER_TBL,		CURRENT_SETTING,	"MAC_FILTER_TBL",		sizeof(MIB_CE_MAC_FILTER_T),		MAX_FILTER_NUM,		0,		0,		0, MAC_FILTER_DESC),
#endif
MIB_CHAIN_TBL_ENTRY(MIB_PORT_FW_TBL,		CURRENT_SETTING,	"PORT_FW_TBL",			sizeof(MIB_CE_PORT_FW_T),		8,		0,		0,		0, PORT_FW_DESC),
#ifdef PORT_FORWARD_ADVANCE
MIB_CHAIN_TBL_ENTRY(MIB_PFW_ADVANCE_TBL,	CURRENT_SETTING,	"PORT_FW_ADVANCE_TBL",		sizeof(MIB_CE_PORT_FW_ADVANCE_T),	8,		0,		0,		0, 0),
#endif
#ifdef ZTE_GENERAL_ROUTER_SC
MIB_CHAIN_TBL_ENTRY(MIB_VIRTUAL_SVR_TBL,	CURRENT_SETTING,	"VIRTUAL_SVR_TBL",		sizeof(MIB_CE_VTL_SVR_T),		-1,		0,		0,		0, 0),
#endif
MIB_CHAIN_TBL_ENTRY(MIB_IP_ROUTE_TBL,		CURRENT_SETTING,	"IP_ROUTE_TBL",			sizeof(MIB_CE_IP_ROUTE_T),		8,		0,		0,		0, IP_ROUTE_DESC),
#ifdef TELEFONICA_DEFAULT_CFG
MIB_CHAIN_TBL_ENTRY(MIB_ACL_IP_TBL,		CURRENT_SETTING,	"ACL_IP_TBL",			sizeof(MIB_CE_ACL_IP_T),		8,		0, mib_acl_default_table, sizeof(mib_acl_default_table), ACL_IP_DESC),
#else
MIB_CHAIN_TBL_ENTRY(MIB_ACL_IP_TBL,		CURRENT_SETTING,	"ACL_IP_TBL",			sizeof(MIB_CE_ACL_IP_T),		8,		0,		0,		0, ACL_IP_DESC),
#endif
/*ping_zhang:20080919 START:add for new telefonica tr069 request: dhcp option*/
#ifdef _PRMT_X_TELEFONICA_ES_DHCPOPTION_
MIB_CHAIN_TBL_ENTRY(MIB_DHCP_SERVER_OPTION_TBL,		CURRENT_SETTING,	"DHCP_SERVER_OPTION_TBL",		sizeof(MIB_CE_DHCP_OPTION_T),		-1,		0,		0,		0,	DHCP_SERVER_OPTION_DESC),
MIB_CHAIN_TBL_ENTRY(MIB_DHCP_CLIENT_OPTION_TBL,		CURRENT_SETTING,	"DHCP_CLIENT_OPTION_TBL",		sizeof(MIB_CE_DHCP_OPTION_T),		-1,		0,    	0, 		0,	DHCP_CLIENT_OPTION_DESC),
#endif
/*ping_zhang:20080919 END*/
//ql_xu add:
#ifdef MAC_ACL
MIB_CHAIN_TBL_ENTRY(MIB_ACL_MAC_TBL,		CURRENT_SETTING,	"ACL_MAC_TBL",			sizeof(MIB_CE_ACL_MAC_T),		8,		0,		0,		0, ACL_MAC_DESC),
#endif
#ifdef NAT_CONN_LIMIT
MIB_CHAIN_TBL_ENTRY(MIB_CONN_LIMIT_TBL,		CURRENT_SETTING,	"NAT_CONN_TBL",			sizeof(MIB_CE_CONN_LIMIT_T),		16,		0,		0,		0, NAT_CONN_LIMIT_DESC),
#endif
#ifdef WLAN_SUPPORT
#ifdef WLAN_ACL
MIB_CHAIN_TBL_ENTRY(MIB_WLAN_AC_TBL,		CURRENT_SETTING,	"WLAN_AC_TBL",			sizeof(MIB_CE_WLAN_AC_T),	MAX_WLAN_AC_NUM,		0,		0,		0, WLAN_AC_DESC),
#endif
#endif
#ifdef CONFIG_EXT_SWITCH
MIB_CHAIN_TBL_ENTRY(MIB_SW_PORT_TBL,		CURRENT_SETTING,	"SW_PORT_TBL",			sizeof(MIB_CE_SW_PORT_T),		4,		0, mib_sw_port_default_table, sizeof(mib_sw_port_default_table), SW_PORT_DESC),
MIB_CHAIN_TBL_ENTRY(MIB_VLAN_TBL,		CURRENT_SETTING,	"VLAN_TBL",			sizeof(MIB_CE_VLAN_T),			VLAN_NUM,	0, mib_vlan_default_table, sizeof(mib_vlan_default_table), VLAN_DESC),
#endif
#ifdef IP_QOS
#ifdef TELEFONICA_DEFAULT_CFG
MIB_CHAIN_TBL_ENTRY(MIB_IP_QOS_TBL,		CURRENT_SETTING,	"IP_QOS_TBL",			sizeof(MIB_CE_IP_QOS_T),		MAX_QOS_RULE,		0, mib_ipqos_default_table, sizeof(mib_ipqos_default_table), IP_QOS_DESC),
#else
MIB_CHAIN_TBL_ENTRY(MIB_IP_QOS_TBL,		CURRENT_SETTING,	"IP_QOS_TBL",			sizeof(MIB_CE_IP_QOS_T),		MAX_QOS_RULE,		0,		0,		0, IP_QOS_DESC),
#endif
#endif
//ql 20081119 for IP QoS traffic shaping
#ifdef NEW_IP_QOS_SUPPORT
MIB_CHAIN_TBL_ENTRY(MIB_IP_QOS_TC_TBL,		CURRENT_SETTING,	"IP_QOS_TC_TBL",			sizeof(MIB_CE_IP_TC_T),		MAX_QOS_RULE,		0,		0,		0, QOS_TC_DESC),
#endif
#ifdef IP_QOS
MIB_CHAIN_TBL_ENTRY(MIB_IP_QOS_QUEUE_TBL,	CURRENT_SETTING,	"IP_QOS_QUEUE_TBL",		sizeof(MIB_CE_IP_QOS_QUEUE_T),		MAX_QOS_QUEUE_NUM, 	0,		0,		0, QOS_QUEUE_DESC),
#endif
MIB_CHAIN_TBL_ENTRY(MIB_ACC_TBL,		CURRENT_SETTING,	"ACC_TBL",			sizeof(MIB_CE_ACC_T),			-1,		0, mib_acc_default_table, sizeof(mib_acc_default_table), ACC_DESC),
#ifdef WLAN_WDS
MIB_CHAIN_TBL_ENTRY(MIB_WDS_TBL,		CURRENT_SETTING,	"WLAN_WDS_TBL",			sizeof(WDS_T),		MAX_WDS_NUM,		0,		0,		0, WDS_DESC),
#endif
#ifdef PORT_TRIGGERING
MIB_CHAIN_TBL_ENTRY(MIB_PORT_TRG_TBL,		CURRENT_SETTING,	"PORT_TRG_TBL",			sizeof(MIB_CE_PORT_TRG_T),		8,		0,		0,		0, PORT_TRG_DESC),
#endif
#ifdef NEW_PORT_TRIGGER //add by machuanjun
MIB_CHAIN_TBL_ENTRY(NEW_MIB_PORT_TRG_TBL,		CURRENT_SETTING,	"NEW_PORT_TRG_TBL",			sizeof(NEW_MIB_CE_PORT_TRG_T),		16,		0,		0,		0, NEW_PORT_TRG_DESC),
#endif
#ifdef NATIP_FORWARDING
MIB_CHAIN_TBL_ENTRY(MIB_IP_FW_TBL,		CURRENT_SETTING,	"IP_FW_TBL",			sizeof(MIB_CE_IP_FW_T),			8,		0,		0,		0, IP_FW_DESC),
#endif
#ifdef URL_BLOCKING_SUPPORT
MIB_CHAIN_TBL_ENTRY(MIB_URL_FQDN_TBL,		CURRENT_SETTING,	"URL_FQDN_TBL",			sizeof(MIB_CE_URL_FQDN_T),		8,		0,		0,		0, URL_FQDN_DESC),
MIB_CHAIN_TBL_ENTRY(MIB_KEYWD_FILTER_TBL,	CURRENT_SETTING,	"KEYWD_FILTER_TBL",		sizeof(MIB_CE_KEYWD_FILTER_T),		8,		0,		0,		0, KEYWD_FILTER_DESC),
#endif
#ifdef URL_ALLOWING_SUPPORT
MIB_CHAIN_TBL_ENTRY(MIB_URL_ALLOW_FQDN_TBL,	CURRENT_SETTING,	"URL_ALLOW_FQDN_TBL",		sizeof(MIB_CE_URL_ALLOW_FQDN_T),	8,		0,		0,		0, URL_ALLOW_FQDN_DESC),
#endif

#ifdef _CWMP_MIB_ /*jiunming, mib for cwmp-tr069*/
#ifdef WLAN_SUPPORT
MIB_CHAIN_TBL_ENTRY(CWMP_PSK_TBL,		CURRENT_SETTING,	"CWMP_PSK_TBL",			sizeof(CWMP_PSK_T),			8,		0,		0,		0, CWMP_PSK_DESC),
#endif
#ifdef _PRMT_X_CT_COM_PPPOE_
MIB_CHAIN_TBL_ENTRY(CWMP_CT_PPPOE_TBL,		CURRENT_SETTING,	"CWMP_CT_PPPOE_TBL",		sizeof(CWMP_CT_PPPOE_T),		8,		0,		0,		0, 0),
#endif
#endif /*_CWMP_MIB_*/
MIB_CHAIN_TBL_ENTRY(MIB_MAC_BASE_DHCP_TBL,	CURRENT_SETTING,	"MAC_BASE_DHCP_TBL",		sizeof(MIB_CE_MAC_BASE_DHCP_T),		8,		0,		0,		0, MAC_BASE_DHCP_DESC),
// add for auto-pvc-search
MIB_CHAIN_TBL_ENTRY(MIB_AUTO_PVC_SEARCH_TBL,	CURRENT_SETTING,	"AUTO_PVC_SEARCH_TBL",		sizeof(MIB_AUTO_PVC_SEARCH_T),		16,		0,mib_auto_pvc_search_default_table,sizeof(mib_auto_pvc_search_default_table), AUTO_PVC_SEARCH_DESC),
#ifdef CONFIG_USER_DDNS
MIB_CHAIN_TBL_ENTRY(MIB_DDNS_TBL,		CURRENT_SETTING,	"MIB_DDNS_TBL",			sizeof(MIB_CE_DDNS_T),			8,		0,		0,		0, DDNS_DESC),
#endif
// Jenny, add for PPPoE session information
MIB_CHAIN_TBL_ENTRY(MIB_PPPOE_SESSION_TBL,	CURRENT_SETTING,	"PPPOE_SESSION_TBL",		sizeof(MIB_CE_PPPOE_SESSION_T),		-1,		0,		0,		0, PPPOE_SESSION_DESC),
#ifdef ACCOUNT_CONFIG
// Jenny, add for user account information
MIB_CHAIN_TBL_ENTRY(MIB_ACCOUNT_CONFIG_TBL,	CURRENT_SETTING,	"ACCOUNT_CONFIG_TBL",		sizeof(MIB_CE_ACCOUNT_CONFIG_T),	8,		0,		0,		0, 0),
#endif
#ifdef DOMAIN_BLOCKING_SUPPORT  // Added by Mason Yu
MIB_CHAIN_TBL_ENTRY(MIB_DOMAIN_BLOCKING_TBL,	CURRENT_SETTING,	"DOMAIN_BLOCKING_TBL",		sizeof(MIB_CE_DOMAIN_BLOCKING_T),	8,		0,		0,		0, DOMAIN_BLOCKING_DESC),
#endif
MIB_CHAIN_TBL_ENTRY(MIB_RIP_TBL,		CURRENT_SETTING,	"RIP_TBL",			sizeof(MIB_CE_RIP_T),			-1,		0,		0,		0, RIP_DESC),
#ifdef CONFIG_USER_ZEBRA_OSPFD_OSPFD
MIB_CHAIN_TBL_ENTRY(MIB_OSPF_TBL,		CURRENT_SETTING,	"OSPF_TBL",			sizeof(MIB_CE_OSPF_T),			-1,		0,		0,		0, OSPF_DESC),
#endif

#ifdef WLAN_MBSSID
MIB_CHAIN_TBL_ENTRY(MIB_MBSSIB_TBL,		CURRENT_SETTING,	"MBSSIB_TBL",			sizeof(MIB_CE_MBSSIB_T),		5,		0,mib_mbssid_default_table, sizeof(mib_mbssid_default_table), MBSSIB_DESC),
MIB_CHAIN_TBL_ENTRY(MIB_MBSSIB_WEP_TBL,		CURRENT_SETTING,	"MBSSIB_WEP_TBL",		sizeof(MIB_CE_MBSSIB_WEP_T),		5,		0,mib_mbssid_wep_default_table, sizeof(mib_mbssid_wep_default_table), MBSSIB_WEP_DESC),
#endif

#ifdef LAYER7_FILTER_SUPPORT
MIB_CHAIN_TBL_ENTRY(MIB_LAYER7_FILTER_TBL, 	CURRENT_SETTING,	"LAYER7_FILTER_TBL",		sizeof(LAYER7_FILTER_T),		8,		0,		0,		0, 0),
#endif

#ifdef QOS_SPEED_LIMIT_SUPPORT
MIB_CHAIN_TBL_ENTRY(MIB_QOS_SPEED_LIMIT,	CURRENT_SETTING,	"MBQOS_SPEED_LIMIT",		sizeof(MIB_CE_IP_QOS_SPEEDRANK_T),	-1,		0,		0,		0, MBQOS_SPEED_LIMIT_DESC),
#endif

#ifdef VOIP_SUPPORT
MIB_CHAIN_TBL_ENTRY(MIB_VOIP_CFG_TBL,		CURRENT_SETTING,	"VOIP_TBL",			sizeof(voipCfgParam_t),			1,		0,		0,		0, 0),
#endif /*VOIP_SUPPORT*/

#ifdef PARENTAL_CTRL
MIB_CHAIN_TBL_ENTRY(MIB_PARENTAL_CTRL_TBL,	CURRENT_SETTING,	"PARENTAL_CTRL_TBL",		sizeof(MIB_PARENT_CTRL_T),		MAX_PARENTCTRL_USER_NUM,		0,		0,		0, PARENTAL_CTRL_DESC),
#endif

/*ping_zhang:20080919 START:add for new telefonica tr069 request: dhcp option*/
#ifdef _PRMT_X_TELEFONICA_ES_DHCPOPTION_
/*ping_zhang:20090319 START:replace ip range with serving pool of tr069*/
#ifdef IMAGENIO_IPTV_SUPPORT
MIB_CHAIN_TBL_ENTRY(MIB_DHCPS_SERVING_POOL_TBL,	CURRENT_SETTING,	"DHCPS_SERVING_POOL_TBL",		sizeof(DHCPS_SERVING_POOL_T),		-1,		0,mib_dhcp_sp_default_table,		sizeof(mib_dhcp_sp_default_table),DHCPS_SERVING_POOL_DESC),
#else
MIB_CHAIN_TBL_ENTRY(MIB_DHCPS_SERVING_POOL_TBL,	CURRENT_SETTING,	"DHCPS_SERVING_POOL_TBL",		sizeof(DHCPS_SERVING_POOL_T),		-1,		0,		0,		0,DHCPS_SERVING_POOL_DESC),
#endif
/*ping_zhang:20090319 END*/
#endif
/*ping_zhang:20080919 END*/

#ifdef TCP_UDP_CONN_LIMIT
MIB_CHAIN_TBL_ENTRY(MIB_TCP_UDP_CONN_LIMIT_TBL,	CURRENT_SETTING,	"TCP_UDP_CONN_TBL",		sizeof(MIB_CE_TCP_UDP_CONN_LIMIT_T),	8,		0,		0,		0, TCP_UDP_CONN_LIMIT_DESC),
#endif

#ifdef WEB_REDIRECT_BY_MAC
MIB_CHAIN_TBL_ENTRY(MIB_WEB_REDIR_BY_MAC_TBL,	CURRENT_SETTING,	"WEB_REDIR_BY_MAC_TBL",		sizeof(MIB_WEB_REDIR_BY_MAC_T),		MAX_WEB_REDIR_BY_MAC,		0,		0,		0, 0),
#endif

#ifdef MULTI_ADDRESS_MAPPING
MIB_CHAIN_TBL_ENTRY(MULTI_ADDRESS_MAPPING_LIMIT_TBL,	CURRENT_SETTING,	"MULTI_ADDR_MAPPING_TBL",	sizeof(MIB_CE_MULTI_ADDR_MAPPING_LIMIT_T),		16,	0,		0,		0, ADDRESS_MAPPING_DESC),
#endif //MULTI_ADDRESS_MAPPING

#ifdef _SUPPORT_CAPTIVEPORTAL_PROFILE_
MIB_CHAIN_TBL_ENTRY(CWMP_CAPTIVEPORTAL_ALLOWED_LIST,	CURRENT_SETTING, "CAPTIVEPORTAL_ALLOWED_LIST", sizeof(CWMP_CAPTIVEPORTAL_ALLOWED_LIST_T), MAX_ALLOWED_LIST, 0, 0, 0, CAPTIVEPORTAL_ALLOWED_LIST_DESC),
#endif

#ifdef WLAN_QoS
MIB_CHAIN_TBL_ENTRY(MIB_WLAN_QOS_AP_TBL,	CURRENT_SETTING,	"WLAN_QOS_AP_TBL",	sizeof(MIB_WLAN_QOS_T),		4,	0,		mib_wlan_qos_default_ap_table, sizeof(mib_wlan_qos_default_ap_table), WLAN_QOS_DESC),
MIB_CHAIN_TBL_ENTRY(MIB_WLAN_QOS_STA_TBL,	CURRENT_SETTING,	"WLAN_QOS_STA_TBL",	sizeof(MIB_WLAN_QOS_T),		4,	0,		mib_wlan_qos_default_sta_table, sizeof(mib_wlan_qos_default_sta_table), WLAN_QOS_DESC),
#endif //WLAN_QoS

#ifdef SUPPORT_DHCP_RESERVED_IPADDR
MIB_CHAIN_TBL_ENTRY(MIB_DHCP_RESERVED_IPADDR_TBL, CURRENT_SETTING, "DHCP_RESERVED_IPADDR_TBL", sizeof(MIB_DHCP_RESERVED_IPADDR_T), -1, 0, 0, 0, DHCP_RESERVED_IPADDR_DESC),
#endif //SUPPORT_DHCP_RESERVED_IPADDR

#ifdef CONFIG_USER_PPPOMODEM
MIB_CHAIN_TBL_ENTRY(MIB_WAN_3G_TBL, 		CURRENT_SETTING, 	"WAN_3G_TBL", 		sizeof(MIB_WAN_3G_T), 		1, 	0, 		mib_wan_3g_default_table, sizeof(mib_wan_3g_default_table), WAN_3G_DESC),
#endif //CONFIG_USER_PPPOMODEM

{0}

};


